# SdkmsClient\AWSApi

All URIs are relative to *https://apps.smartkey.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**cancelDeletion**](AWSApi.md#cancelDeletion) | **POST** /crypto/v1/keys/{key-id}/cancel_deletion | Cancel scheduled deletion of an AWS KMS key
[**deleteKeyMaterial**](AWSApi.md#deleteKeyMaterial) | **POST** /crypto/v1/keys/{key-id}/delete_key_material | Delete the key material of an AWS KMS key
[**restore**](AWSApi.md#restore) | **POST** /crypto/v1/keys/{key-id}/restore | Restore an AWS KMS key from its source key material
[**scheduleDeletion**](AWSApi.md#scheduleDeletion) | **POST** /crypto/v1/keys/{key-id}/schedule_deletion | Schedule an AWS KMS key for deletion


# **cancelDeletion**
> \SdkmsClient\Model\KeyObject cancelDeletion($key_id)

Cancel scheduled deletion of an AWS KMS key

Cancel scheduled deletion of an AWS KMS key

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\AWSApi();
$key_id = "key_id_example"; // string | kid of security object

try {
    $result = $api_instance->cancelDeletion($key_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AWSApi->cancelDeletion: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **string**| kid of security object |

### Return type

[**\SdkmsClient\Model\KeyObject**](../Model/KeyObject.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **deleteKeyMaterial**
> \SdkmsClient\Model\KeyObject deleteKeyMaterial($key_id)

Delete the key material of an AWS KMS key

Delete the key material of an AWS KMS key

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\AWSApi();
$key_id = "key_id_example"; // string | kid of security object

try {
    $result = $api_instance->deleteKeyMaterial($key_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AWSApi->deleteKeyMaterial: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **string**| kid of security object |

### Return type

[**\SdkmsClient\Model\KeyObject**](../Model/KeyObject.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **restore**
> \SdkmsClient\Model\KeyObject restore($key_id)

Restore an AWS KMS key from its source key material

Restore an AWS key from its source key material

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\AWSApi();
$key_id = "key_id_example"; // string | kid of security object

try {
    $result = $api_instance->restore($key_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AWSApi->restore: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **string**| kid of security object |

### Return type

[**\SdkmsClient\Model\KeyObject**](../Model/KeyObject.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **scheduleDeletion**
> \SdkmsClient\Model\KeyObject scheduleDeletion($key_id, $body)

Schedule an AWS KMS key for deletion

Schedule an AWS KMS key for deletion

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\AWSApi();
$key_id = "key_id_example"; // string | kid of security object
$body = new \SdkmsClient\Model\ScheduleDeletionRequest(); // \SdkmsClient\Model\ScheduleDeletionRequest | Request to schedule deletion for an AWS KMS key

try {
    $result = $api_instance->scheduleDeletion($key_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AWSApi->scheduleDeletion: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **string**| kid of security object |
 **body** | [**\SdkmsClient\Model\ScheduleDeletionRequest**](../Model/ScheduleDeletionRequest.md)| Request to schedule deletion for an AWS KMS key |

### Return type

[**\SdkmsClient\Model\KeyObject**](../Model/KeyObject.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

