# SdkmsClient\ChildAccountUsersApi

All URIs are relative to *https://apps.smartkey.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createChildAccountUser**](ChildAccountUsersApi.md#createChildAccountUser) | **POST** /sys/v1/users/child_account | Create a new user user in a child account
[**deleteChildAccountUser**](ChildAccountUsersApi.md#deleteChildAccountUser) | **DELETE** /sys/v1/users/child_account/{user-id} | Completely delete a user in child account
[**getAllChildAccountUsers**](ChildAccountUsersApi.md#getAllChildAccountUsers) | **GET** /sys/v1/users/child_account/{account-id}/all | Get all users in a child account
[**getChildAccountUser**](ChildAccountUsersApi.md#getChildAccountUser) | **GET** /sys/v1/users/child_account/{user-id} | Get a specific child account user
[**updateChildAccountUser**](ChildAccountUsersApi.md#updateChildAccountUser) | **PATCH** /sys/v1/users/child_account/{user-id} | Update a child account user


# **createChildAccountUser**
> \SdkmsClient\Model\ChildAccountUser createChildAccountUser($body)

Create a new user user in a child account

Create a new user user in a child account.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\ChildAccountUsersApi();
$body = new \SdkmsClient\Model\ChildAccountUserRequest(); // \SdkmsClient\Model\ChildAccountUserRequest | User in child account

try {
    $result = $api_instance->createChildAccountUser($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ChildAccountUsersApi->createChildAccountUser: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\ChildAccountUserRequest**](../Model/ChildAccountUserRequest.md)| User in child account |

### Return type

[**\SdkmsClient\Model\ChildAccountUser**](../Model/ChildAccountUser.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **deleteChildAccountUser**
> deleteChildAccountUser($user_id)

Completely delete a user in child account

Completely delete a user in child account.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\ChildAccountUsersApi();
$user_id = "user_id_example"; // string | User Identifier

try {
    $api_instance->deleteChildAccountUser($user_id);
} catch (Exception $e) {
    echo 'Exception when calling ChildAccountUsersApi->deleteChildAccountUser: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**| User Identifier |

### Return type

void (empty response body)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getAllChildAccountUsers**
> \SdkmsClient\Model\ChildAccountUser[] getAllChildAccountUsers($account_id)

Get all users in a child account

Get all users in a child account

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\ChildAccountUsersApi();
$account_id = "account_id_example"; // string | Account Identifier

try {
    $result = $api_instance->getAllChildAccountUsers($account_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ChildAccountUsersApi->getAllChildAccountUsers: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **account_id** | **string**| Account Identifier |

### Return type

[**\SdkmsClient\Model\ChildAccountUser[]**](../Model/ChildAccountUser.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getChildAccountUser**
> \SdkmsClient\Model\ChildAccountUser getChildAccountUser($user_id)

Get a specific child account user

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\ChildAccountUsersApi();
$user_id = "user_id_example"; // string | User Identifier

try {
    $result = $api_instance->getChildAccountUser($user_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ChildAccountUsersApi->getChildAccountUser: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**| User Identifier |

### Return type

[**\SdkmsClient\Model\ChildAccountUser**](../Model/ChildAccountUser.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **updateChildAccountUser**
> \SdkmsClient\Model\ChildAccountUser updateChildAccountUser($user_id, $body)

Update a child account user

Change a child account user's properties.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\ChildAccountUsersApi();
$user_id = "user_id_example"; // string | User Identifier
$body = new \SdkmsClient\Model\ChildAccountUserRequest(); // \SdkmsClient\Model\ChildAccountUserRequest | User in child account

try {
    $result = $api_instance->updateChildAccountUser($user_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ChildAccountUsersApi->updateChildAccountUser: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**| User Identifier |
 **body** | [**\SdkmsClient\Model\ChildAccountUserRequest**](../Model/ChildAccountUserRequest.md)| User in child account |

### Return type

[**\SdkmsClient\Model\ChildAccountUser**](../Model/ChildAccountUser.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

