# SdkmsClient\ChildAccountsApi

All URIs are relative to *https://apps.smartkey.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createChildAccount**](ChildAccountsApi.md#createChildAccount) | **POST** /sys/v1/accounts/child | Create a new child account
[**getChildAccounts**](ChildAccountsApi.md#getChildAccounts) | **GET** /sys/v1/accounts/{account-id}/child | Get all child accounts of the given account


# **createChildAccount**
> \SdkmsClient\Model\Account createChildAccount($body)

Create a new child account

Create a new child account with the specified properties.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\ChildAccountsApi();
$body = new \SdkmsClient\Model\AccountRequest(); // \SdkmsClient\Model\AccountRequest | Properties to assign to Account.

try {
    $result = $api_instance->createChildAccount($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ChildAccountsApi->createChildAccount: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\AccountRequest**](../Model/AccountRequest.md)| Properties to assign to Account. |

### Return type

[**\SdkmsClient\Model\Account**](../Model/Account.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getChildAccounts**
> \SdkmsClient\Model\Account[] getChildAccounts($account_id)

Get all child accounts of the given account

Get all child accounts of the given account.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\ChildAccountsApi();
$account_id = "account_id_example"; // string | Account Identifier

try {
    $result = $api_instance->getChildAccounts($account_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ChildAccountsApi->getChildAccounts: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **account_id** | **string**| Account Identifier |

### Return type

[**\SdkmsClient\Model\Account[]**](../Model/Account.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

