# SdkmsClient\EncryptionAndDecryptionApi

All URIs are relative to *https://apps.smartkey.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**batchDecrypt**](EncryptionAndDecryptionApi.md#batchDecrypt) | **POST** /crypto/v1/keys/batch/decrypt | Batch decrypt with one or more keys
[**batchEncrypt**](EncryptionAndDecryptionApi.md#batchEncrypt) | **POST** /crypto/v1/keys/batch/encrypt | Batch encrypt with one or more keys
[**decrypt**](EncryptionAndDecryptionApi.md#decrypt) | **POST** /crypto/v1/keys/{key-id}/decrypt | Decrypt data
[**decryptEx**](EncryptionAndDecryptionApi.md#decryptEx) | **POST** /crypto/v1/decrypt | Decrypt data
[**decryptFinal**](EncryptionAndDecryptionApi.md#decryptFinal) | **POST** /crypto/v1/keys/{key-id}/decrypt/final | Conclude multi-part decryption
[**decryptFinalEx**](EncryptionAndDecryptionApi.md#decryptFinalEx) | **POST** /crypto/v1/decrypt/final | Conclude multi-part decryption
[**decryptInit**](EncryptionAndDecryptionApi.md#decryptInit) | **POST** /crypto/v1/keys/{key-id}/decrypt/init | Begin multi-part decryption
[**decryptInitEx**](EncryptionAndDecryptionApi.md#decryptInitEx) | **POST** /crypto/v1/decrypt/init | Begin multi-part decryption
[**decryptUpdate**](EncryptionAndDecryptionApi.md#decryptUpdate) | **POST** /crypto/v1/keys/{key-id}/decrypt/update | Continue multi-part decryption
[**decryptUpdateEx**](EncryptionAndDecryptionApi.md#decryptUpdateEx) | **POST** /crypto/v1/decrypt/update | Continue multi-part decryption
[**encrypt**](EncryptionAndDecryptionApi.md#encrypt) | **POST** /crypto/v1/keys/{key-id}/encrypt | Encrypt data
[**encryptEx**](EncryptionAndDecryptionApi.md#encryptEx) | **POST** /crypto/v1/encrypt | Encrypt data
[**encryptFinal**](EncryptionAndDecryptionApi.md#encryptFinal) | **POST** /crypto/v1/keys/{key-id}/encrypt/final | Conclude multi-part encryption
[**encryptFinalEx**](EncryptionAndDecryptionApi.md#encryptFinalEx) | **POST** /crypto/v1/encrypt/final | Conclude multi-part encryption
[**encryptInit**](EncryptionAndDecryptionApi.md#encryptInit) | **POST** /crypto/v1/keys/{key-id}/encrypt/init | Begin multi-part encryption
[**encryptInitEx**](EncryptionAndDecryptionApi.md#encryptInitEx) | **POST** /crypto/v1/encrypt/init | Begin multi-part encryption
[**encryptUpdate**](EncryptionAndDecryptionApi.md#encryptUpdate) | **POST** /crypto/v1/keys/{key-id}/encrypt/update | Continue multi-part encryption
[**encryptUpdateEx**](EncryptionAndDecryptionApi.md#encryptUpdateEx) | **POST** /crypto/v1/encrypt/update | Continue multi-part encryption


# **batchDecrypt**
> \SdkmsClient\Model\BatchDecryptResponse batchDecrypt($body)

Batch decrypt with one or more keys

The data to be decrypted and the key ids to be used are provided in the request body. The decrypted plain text is returned in the response body. The ordering of the body matches the ordering of the request. An individual status code is returned for each batch item. Maximum size of the entire batch request is 512 KB.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$body = new \SdkmsClient\Model\BatchDecryptRequest(); // \SdkmsClient\Model\BatchDecryptRequest | Batch decryption request

try {
    $result = $api_instance->batchDecrypt($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->batchDecrypt: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\BatchDecryptRequest**](../Model/BatchDecryptRequest.md)| Batch decryption request |

### Return type

[**\SdkmsClient\Model\BatchDecryptResponse**](../Model/BatchDecryptResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **batchEncrypt**
> \SdkmsClient\Model\BatchEncryptResponse batchEncrypt($body)

Batch encrypt with one or more keys

The data to be encrypted and the key ids to be used are provided in the request body. The encrypted cipher text is returned in the response body. The ordering of the body matches the ordering of the request. An individual status code is returned for each batch item. Maximum size of the entire batch request is 512 KB.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$body = new \SdkmsClient\Model\BatchEncryptRequest(); // \SdkmsClient\Model\BatchEncryptRequest | Batch Encryption request

try {
    $result = $api_instance->batchEncrypt($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->batchEncrypt: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\BatchEncryptRequest**](../Model/BatchEncryptRequest.md)| Batch Encryption request |

### Return type

[**\SdkmsClient\Model\BatchEncryptResponse**](../Model/BatchEncryptResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **decrypt**
> \SdkmsClient\Model\DecryptResponse decrypt($key_id, $body)

Decrypt data

Decrypt data using a symmetric or asymmetric key. For symmetric ciphers, mode (specifying the block cipher mode) is a required field. <br> For GCM and CCM modes, tag_len is a required field. <br> iv is required for symmetric ciphers and unused for asymmetric ciphers. It must contain the initialization value used when the object was encrypted. <br> Objects of type opaque, EC, or HMAC may not be used for encryption or decryption. <br>

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$key_id = "key_id_example"; // string | kid of security object
$body = new \SdkmsClient\Model\DecryptRequest(); // \SdkmsClient\Model\DecryptRequest | Decryption request

try {
    $result = $api_instance->decrypt($key_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->decrypt: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **string**| kid of security object |
 **body** | [**\SdkmsClient\Model\DecryptRequest**](../Model/DecryptRequest.md)| Decryption request |

### Return type

[**\SdkmsClient\Model\DecryptResponse**](../Model/DecryptResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **decryptEx**
> \SdkmsClient\Model\DecryptResponse decryptEx($body)

Decrypt data

Decrypt data using a symmetric or asymmetric key. For symmetric ciphers, mode (specifying the block cipher mode) is a required field. <br> For GCM and CCM modes, tag_len is a required field. <br> iv is required for symmetric ciphers and unused for asymmetric ciphers. It must contain the initialization value used when the object was encrypted. <br> Objects of type opaque, EC, or HMAC may not be used for encryption or decryption. <br>

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$body = new \SdkmsClient\Model\DecryptRequestEx(); // \SdkmsClient\Model\DecryptRequestEx | Decryption request

try {
    $result = $api_instance->decryptEx($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->decryptEx: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\DecryptRequestEx**](../Model/DecryptRequestEx.md)| Decryption request |

### Return type

[**\SdkmsClient\Model\DecryptResponse**](../Model/DecryptResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **decryptFinal**
> \SdkmsClient\Model\DecryptFinalResponse decryptFinal($key_id, $body)

Conclude multi-part decryption

Conclude a multi-part decryption operation. See `decrypt/init` for details.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$key_id = "key_id_example"; // string | kid of security object
$body = new \SdkmsClient\Model\DecryptFinalRequest(); // \SdkmsClient\Model\DecryptFinalRequest | Finish multi-part decryption

try {
    $result = $api_instance->decryptFinal($key_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->decryptFinal: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **string**| kid of security object |
 **body** | [**\SdkmsClient\Model\DecryptFinalRequest**](../Model/DecryptFinalRequest.md)| Finish multi-part decryption |

### Return type

[**\SdkmsClient\Model\DecryptFinalResponse**](../Model/DecryptFinalResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **decryptFinalEx**
> \SdkmsClient\Model\DecryptFinalResponse decryptFinalEx($body)

Conclude multi-part decryption

Conclude a multi-part decryption operation. See `decrypt/init` for details.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$body = new \SdkmsClient\Model\DecryptFinalRequestEx(); // \SdkmsClient\Model\DecryptFinalRequestEx | Finish multi-part decryption

try {
    $result = $api_instance->decryptFinalEx($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->decryptFinalEx: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\DecryptFinalRequestEx**](../Model/DecryptFinalRequestEx.md)| Finish multi-part decryption |

### Return type

[**\SdkmsClient\Model\DecryptFinalResponse**](../Model/DecryptFinalResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **decryptInit**
> \SdkmsClient\Model\DecryptInitResponse decryptInit($key_id, $body)

Begin multi-part decryption

This API is used when decrypting more data than the client wishes to submit in a single request. It supports only symmetric ciphers and CBC, CBCNOPAD, CTR, and GCM modes of operation. To perform multi-part decryption, the client makes one request to the `init` resource, zero or more requests to the `update` resource, followed by one request to the `final` resource. The response to init and update requests includes a `state` field. The `state` is an opaque data blob that must be supplied unmodified by the client with the subsequent request.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$key_id = "key_id_example"; // string | kid of security object
$body = new \SdkmsClient\Model\DecryptInitRequest(); // \SdkmsClient\Model\DecryptInitRequest | Multi-part decryption initialization request

try {
    $result = $api_instance->decryptInit($key_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->decryptInit: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **string**| kid of security object |
 **body** | [**\SdkmsClient\Model\DecryptInitRequest**](../Model/DecryptInitRequest.md)| Multi-part decryption initialization request |

### Return type

[**\SdkmsClient\Model\DecryptInitResponse**](../Model/DecryptInitResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **decryptInitEx**
> \SdkmsClient\Model\DecryptInitResponse decryptInitEx($body)

Begin multi-part decryption

This API is used when decrypting more data than the client wishes to submit in a single request. It supports only symmetric ciphers and CBC, CBCNOPAD, CTR, and GCM modes of operation. To perform multi-part decryption, the client makes one request to the `init` resource, zero or more requests to the `update` resource, followed by one request to the `final` resource. The response to init and update requests includes a `state` field. The `state` is an opaque data blob that must be supplied unmodified by the client with the subsequent request.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$body = new \SdkmsClient\Model\DecryptInitRequestEx(); // \SdkmsClient\Model\DecryptInitRequestEx | Multi-part decryption initialization request

try {
    $result = $api_instance->decryptInitEx($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->decryptInitEx: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\DecryptInitRequestEx**](../Model/DecryptInitRequestEx.md)| Multi-part decryption initialization request |

### Return type

[**\SdkmsClient\Model\DecryptInitResponse**](../Model/DecryptInitResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **decryptUpdate**
> \SdkmsClient\Model\DecryptUpdateResponse decryptUpdate($key_id, $body)

Continue multi-part decryption

Continue a multi-part decryption operation. See `decrypt/init` for details.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$key_id = "key_id_example"; // string | kid of security object
$body = new \SdkmsClient\Model\DecryptUpdateRequest(); // \SdkmsClient\Model\DecryptUpdateRequest | Multi-part decryption

try {
    $result = $api_instance->decryptUpdate($key_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->decryptUpdate: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **string**| kid of security object |
 **body** | [**\SdkmsClient\Model\DecryptUpdateRequest**](../Model/DecryptUpdateRequest.md)| Multi-part decryption |

### Return type

[**\SdkmsClient\Model\DecryptUpdateResponse**](../Model/DecryptUpdateResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **decryptUpdateEx**
> \SdkmsClient\Model\DecryptUpdateResponse decryptUpdateEx($body)

Continue multi-part decryption

Continue a multi-part decryption operation. See `decrypt/init` for details.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$body = new \SdkmsClient\Model\DecryptUpdateRequestEx(); // \SdkmsClient\Model\DecryptUpdateRequestEx | Multi-part decryption

try {
    $result = $api_instance->decryptUpdateEx($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->decryptUpdateEx: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\DecryptUpdateRequestEx**](../Model/DecryptUpdateRequestEx.md)| Multi-part decryption |

### Return type

[**\SdkmsClient\Model\DecryptUpdateResponse**](../Model/DecryptUpdateResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **encrypt**
> \SdkmsClient\Model\EncryptResponse encrypt($key_id, $body)

Encrypt data

Encrypt data using a symmetric or asymmetric key. <br> For symmetric ciphers, mode (specifying the block cipher mode) is a required field. <br> For GCM and CCM modes, tag_len is a required field. <br> iv is optional for symmetric ciphers and unused for asymmetric ciphers. If provided, it will be used as the cipher initialization value. Length of iv must match the initialization value size for the cipher and mode. If not provided, SDKMS will create a random iv of the correct length for the cipher and mode and return this value in the response. <br> Objects of type Opaque, EC, or HMAC may not be used for encryption or decryption. <br>

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$key_id = "key_id_example"; // string | kid of security object
$body = new \SdkmsClient\Model\EncryptRequest(); // \SdkmsClient\Model\EncryptRequest | Encryption request

try {
    $result = $api_instance->encrypt($key_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->encrypt: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **string**| kid of security object |
 **body** | [**\SdkmsClient\Model\EncryptRequest**](../Model/EncryptRequest.md)| Encryption request |

### Return type

[**\SdkmsClient\Model\EncryptResponse**](../Model/EncryptResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **encryptEx**
> \SdkmsClient\Model\EncryptResponse encryptEx($body)

Encrypt data

Encrypt data using a symmetric or asymmetric key. <br> For symmetric ciphers, mode (specifying the block cipher mode) is a required field. <br> For GCM and CCM modes, tag_len is a required field. <br> iv is optional for symmetric ciphers and unused for asymmetric ciphers. If provided, it will be used as the cipher initialization value. Length of iv must match the initialization value size for the cipher and mode. If not provided, SDKMS will create a random iv of the correct length for the cipher and mode and return this value in the response. <br> Objects of type Opaque, EC, or HMAC may not be used for encryption or decryption. <br>

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$body = new \SdkmsClient\Model\EncryptRequestEx(); // \SdkmsClient\Model\EncryptRequestEx | Encryption request

try {
    $result = $api_instance->encryptEx($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->encryptEx: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\EncryptRequestEx**](../Model/EncryptRequestEx.md)| Encryption request |

### Return type

[**\SdkmsClient\Model\EncryptResponse**](../Model/EncryptResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **encryptFinal**
> \SdkmsClient\Model\EncryptFinalResponse encryptFinal($key_id, $body)

Conclude multi-part encryption

Conclude a multi-part encryption operation. See `encrypt/init` for details.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$key_id = "key_id_example"; // string | kid of security object
$body = new \SdkmsClient\Model\EncryptFinalRequest(); // \SdkmsClient\Model\EncryptFinalRequest | Finish multi-part encryption

try {
    $result = $api_instance->encryptFinal($key_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->encryptFinal: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **string**| kid of security object |
 **body** | [**\SdkmsClient\Model\EncryptFinalRequest**](../Model/EncryptFinalRequest.md)| Finish multi-part encryption |

### Return type

[**\SdkmsClient\Model\EncryptFinalResponse**](../Model/EncryptFinalResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **encryptFinalEx**
> \SdkmsClient\Model\EncryptFinalResponse encryptFinalEx($body)

Conclude multi-part encryption

Conclude a multi-part encryption operation. See `encrypt/init` for details.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$body = new \SdkmsClient\Model\EncryptFinalRequestEx(); // \SdkmsClient\Model\EncryptFinalRequestEx | Finish multi-part encryption

try {
    $result = $api_instance->encryptFinalEx($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->encryptFinalEx: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\EncryptFinalRequestEx**](../Model/EncryptFinalRequestEx.md)| Finish multi-part encryption |

### Return type

[**\SdkmsClient\Model\EncryptFinalResponse**](../Model/EncryptFinalResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **encryptInit**
> \SdkmsClient\Model\EncryptInitResponse encryptInit($key_id, $body)

Begin multi-part encryption

This API is used when encrypting more data than the client wishes to submit in a single request. It supports only symmetric ciphers and CBC, CBCNOPAD, CTR, and GCM modes of operation. To perform multi-part encryption, the client makes one request to the `init` resource, zero or more requests to the `update` resource, followed by one request to the `final` resource. The response to init and update requests includes a `state` field. The `state` is an opaque data blob that must be supplied unmodified by the client with the subsequent request.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$key_id = "key_id_example"; // string | kid of security object
$body = new \SdkmsClient\Model\EncryptInitRequest(); // \SdkmsClient\Model\EncryptInitRequest | Multi-part encryption initialization request

try {
    $result = $api_instance->encryptInit($key_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->encryptInit: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **string**| kid of security object |
 **body** | [**\SdkmsClient\Model\EncryptInitRequest**](../Model/EncryptInitRequest.md)| Multi-part encryption initialization request |

### Return type

[**\SdkmsClient\Model\EncryptInitResponse**](../Model/EncryptInitResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **encryptInitEx**
> \SdkmsClient\Model\EncryptInitResponse encryptInitEx($body)

Begin multi-part encryption

This API is used when encrypting more data than the client wishes to submit in a single request. It supports only symmetric ciphers and CBC, CBCNOPAD, CTR, and GCM modes of operation. To perform multi-part encryption, the client makes one request to the `init` resource, zero or more requests to the `update` resource, followed by one request to the `final` resource. The response to init and update requests includes a `state` field. The `state` is an opaque data blob that must be supplied unmodified by the client with the subsequent request.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$body = new \SdkmsClient\Model\EncryptInitRequestEx(); // \SdkmsClient\Model\EncryptInitRequestEx | Multi-part encryption initialization request

try {
    $result = $api_instance->encryptInitEx($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->encryptInitEx: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\EncryptInitRequestEx**](../Model/EncryptInitRequestEx.md)| Multi-part encryption initialization request |

### Return type

[**\SdkmsClient\Model\EncryptInitResponse**](../Model/EncryptInitResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **encryptUpdate**
> \SdkmsClient\Model\EncryptUpdateResponse encryptUpdate($key_id, $body)

Continue multi-part encryption

Continue a multi-part encryption operation. See `encrypt/init` for details.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$key_id = "key_id_example"; // string | kid of security object
$body = new \SdkmsClient\Model\EncryptUpdateRequest(); // \SdkmsClient\Model\EncryptUpdateRequest | Multi-part encryption

try {
    $result = $api_instance->encryptUpdate($key_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->encryptUpdate: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **string**| kid of security object |
 **body** | [**\SdkmsClient\Model\EncryptUpdateRequest**](../Model/EncryptUpdateRequest.md)| Multi-part encryption |

### Return type

[**\SdkmsClient\Model\EncryptUpdateResponse**](../Model/EncryptUpdateResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **encryptUpdateEx**
> \SdkmsClient\Model\EncryptUpdateResponse encryptUpdateEx($body)

Continue multi-part encryption

Continue a multi-part encryption operation. See `encrypt/init` for details.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\EncryptionAndDecryptionApi();
$body = new \SdkmsClient\Model\EncryptUpdateRequestEx(); // \SdkmsClient\Model\EncryptUpdateRequestEx | Multi-part encryption

try {
    $result = $api_instance->encryptUpdateEx($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EncryptionAndDecryptionApi->encryptUpdateEx: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\EncryptUpdateRequestEx**](../Model/EncryptUpdateRequestEx.md)| Multi-part encryption |

### Return type

[**\SdkmsClient\Model\EncryptUpdateResponse**](../Model/EncryptUpdateResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

