# SdkmsClient\UsersApi

All URIs are relative to *https://apps.smartkey.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**changePassword**](UsersApi.md#changePassword) | **POST** /sys/v1/users/change_password | Change user password
[**confirmEmail**](UsersApi.md#confirmEmail) | **POST** /sys/v1/users/{user-id}/confirm_email | Confirms user&#39;s email address
[**createUser**](UsersApi.md#createUser) | **POST** /sys/v1/users | Create a new user
[**deleteUser**](UsersApi.md#deleteUser) | **DELETE** /sys/v1/users/{user-id}/accounts | Removed user&#39;s association with an account
[**deleteUserAccount**](UsersApi.md#deleteUserAccount) | **DELETE** /sys/v1/users | Completely delete a user profile from system
[**forgotPassword**](UsersApi.md#forgotPassword) | **POST** /sys/v1/users/forgot_password | Initiate password reset sequence for a user
[**getUser**](UsersApi.md#getUser) | **GET** /sys/v1/users/{user-id} | Get a specific user
[**getUserAccount**](UsersApi.md#getUserAccount) | **GET** /sys/v1/users/accounts | Get account information for the user
[**getUsers**](UsersApi.md#getUsers) | **GET** /sys/v1/users | Get all users
[**inviteUser**](UsersApi.md#inviteUser) | **POST** /sys/v1/users/invite | Invite a user
[**processInvitations**](UsersApi.md#processInvitations) | **POST** /sys/v1/users/process_invite | Process a user&#39;s pending account invitations
[**resendConfirmEmail**](UsersApi.md#resendConfirmEmail) | **POST** /sys/v1/users/{user-id}/resend_confirm_email | Resend email with link to confirm user&#39;s email address
[**resendInvitation**](UsersApi.md#resendInvitation) | **POST** /sys/v1/users/{user-id}/resend_invite | Resend invite to the user to join a specific account
[**resetPassword**](UsersApi.md#resetPassword) | **POST** /sys/v1/users/{user-id}/reset_password | Reset a user&#39;s password
[**updateUser**](UsersApi.md#updateUser) | **PATCH** /sys/v1/users/{user-id} | Update user
[**validatePasswordResetToken**](UsersApi.md#validatePasswordResetToken) | **POST** /sys/v1/users/{user-id}/validate_token | Validates password reset token for the user


# **changePassword**
> changePassword($body)

Change user password

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\UsersApi();
$body = new \SdkmsClient\Model\PasswordChangeRequest(); // \SdkmsClient\Model\PasswordChangeRequest | Password change request

try {
    $api_instance->changePassword($body);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->changePassword: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\PasswordChangeRequest**](../Model/PasswordChangeRequest.md)| Password change request |

### Return type

void (empty response body)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **confirmEmail**
> \SdkmsClient\Model\ConfirmEmailResponse confirmEmail($user_id, $body)

Confirms user's email address

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\UsersApi();
$user_id = "user_id_example"; // string | User Identifier
$body = new \SdkmsClient\Model\ConfirmEmailRequest(); // \SdkmsClient\Model\ConfirmEmailRequest | Validate user's email

try {
    $result = $api_instance->confirmEmail($user_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->confirmEmail: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**| User Identifier |
 **body** | [**\SdkmsClient\Model\ConfirmEmailRequest**](../Model/ConfirmEmailRequest.md)| Validate user&#39;s email |

### Return type

[**\SdkmsClient\Model\ConfirmEmailResponse**](../Model/ConfirmEmailResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **createUser**
> \SdkmsClient\Model\User createUser($body)

Create a new user

Signs up a new user.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\UsersApi();
$body = new \SdkmsClient\Model\SignupRequest(); // \SdkmsClient\Model\SignupRequest | Email address of user

try {
    $result = $api_instance->createUser($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->createUser: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\SignupRequest**](../Model/SignupRequest.md)| Email address of user |

### Return type

[**\SdkmsClient\Model\User**](../Model/User.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **deleteUser**
> deleteUser($user_id)

Removed user's association with an account

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\UsersApi();
$user_id = "user_id_example"; // string | User Identifier

try {
    $api_instance->deleteUser($user_id);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->deleteUser: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**| User Identifier |

### Return type

void (empty response body)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **deleteUserAccount**
> deleteUserAccount()

Completely delete a user profile from system

Completely deletes the currently logged in user from the system.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\UsersApi();

try {
    $api_instance->deleteUserAccount();
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->deleteUserAccount: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **forgotPassword**
> forgotPassword($body)

Initiate password reset sequence for a user

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\UsersApi();
$body = new \SdkmsClient\Model\ForgotPasswordRequest(); // \SdkmsClient\Model\ForgotPasswordRequest | Initiate forgot password sequrence

try {
    $api_instance->forgotPassword($body);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->forgotPassword: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\ForgotPasswordRequest**](../Model/ForgotPasswordRequest.md)| Initiate forgot password sequrence |

### Return type

void (empty response body)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getUser**
> \SdkmsClient\Model\User getUser($user_id)

Get a specific user

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\UsersApi();
$user_id = "user_id_example"; // string | User Identifier

try {
    $result = $api_instance->getUser($user_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->getUser: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**| User Identifier |

### Return type

[**\SdkmsClient\Model\User**](../Model/User.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getUserAccount**
> \SdkmsClient\Model\UserAccountMap getUserAccount()

Get account information for the user

Obtain the current user's account information.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\UsersApi();

try {
    $result = $api_instance->getUserAccount();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->getUserAccount: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**\SdkmsClient\Model\UserAccountMap**](../Model/UserAccountMap.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getUsers**
> \SdkmsClient\Model\User[] getUsers($group_id, $sort, $start, $limit, $offset)

Get all users

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\UsersApi();
$group_id = "group_id_example"; // string | Only retrieve users in the specified group.
$sort = "sort_example"; // string | This specifies the property (`user_id` only, for now) and order (ascending or descending) with which to sort the users. By default, users are sorted by `user_id` in ascending order. The syntax is \"<property>:[asc|desc]\" (e.g. \"user_id:desc\") or just \"<property>\" (ascending order by default).
$start = "start_example"; // string | If provided, this must be a value of the property specified in `sort`. Returned users will begin just above or just below this value (for asc/desc order resp.).
$limit = 56; // int | Maximum number of users to return. If not provided, the limit is 100.
$offset = 56; // int | Number of users past `start` to skip.

try {
    $result = $api_instance->getUsers($group_id, $sort, $start, $limit, $offset);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->getUsers: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **group_id** | **string**| Only retrieve users in the specified group. | [optional]
 **sort** | **string**| This specifies the property (&#x60;user_id&#x60; only, for now) and order (ascending or descending) with which to sort the users. By default, users are sorted by &#x60;user_id&#x60; in ascending order. The syntax is \&quot;&lt;property&gt;:[asc|desc]\&quot; (e.g. \&quot;user_id:desc\&quot;) or just \&quot;&lt;property&gt;\&quot; (ascending order by default). | [optional]
 **start** | **string**| If provided, this must be a value of the property specified in &#x60;sort&#x60;. Returned users will begin just above or just below this value (for asc/desc order resp.). | [optional]
 **limit** | **int**| Maximum number of users to return. If not provided, the limit is 100. | [optional]
 **offset** | **int**| Number of users past &#x60;start&#x60; to skip. | [optional]

### Return type

[**\SdkmsClient\Model\User[]**](../Model/User.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **inviteUser**
> \SdkmsClient\Model\User inviteUser($body)

Invite a user

Invite an existing user or new user to join an existing account. Only user email is required for invite API

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\UsersApi();
$body = new \SdkmsClient\Model\UserRequest(); // \SdkmsClient\Model\UserRequest | Name of user

try {
    $result = $api_instance->inviteUser($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->inviteUser: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\UserRequest**](../Model/UserRequest.md)| Name of user |

### Return type

[**\SdkmsClient\Model\User**](../Model/User.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **processInvitations**
> processInvitations($body)

Process a user's pending account invitations

Process a user's pending invitations. It does both accepts and rejects.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\UsersApi();
$body = new \SdkmsClient\Model\ProcessInviteRequest(); // \SdkmsClient\Model\ProcessInviteRequest | Process account invitation (both accepts and rejects)

try {
    $api_instance->processInvitations($body);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->processInvitations: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\ProcessInviteRequest**](../Model/ProcessInviteRequest.md)| Process account invitation (both accepts and rejects) |

### Return type

void (empty response body)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **resendConfirmEmail**
> resendConfirmEmail($user_id)

Resend email with link to confirm user's email address

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\UsersApi();
$user_id = "user_id_example"; // string | User Identifier

try {
    $api_instance->resendConfirmEmail($user_id);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->resendConfirmEmail: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**| User Identifier |

### Return type

void (empty response body)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **resendInvitation**
> resendInvitation($user_id)

Resend invite to the user to join a specific account

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\UsersApi();
$user_id = "user_id_example"; // string | User Identifier

try {
    $api_instance->resendInvitation($user_id);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->resendInvitation: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**| User Identifier |

### Return type

void (empty response body)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **resetPassword**
> resetPassword($user_id, $body)

Reset a user's password

Resetting a user's password. User must have a valid reset token from forgot password step.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\UsersApi();
$user_id = "user_id_example"; // string | User Identifier
$body = new \SdkmsClient\Model\PasswordResetRequest(); // \SdkmsClient\Model\PasswordResetRequest | Reset password

try {
    $api_instance->resetPassword($user_id, $body);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->resetPassword: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**| User Identifier |
 **body** | [**\SdkmsClient\Model\PasswordResetRequest**](../Model/PasswordResetRequest.md)| Reset password |

### Return type

void (empty response body)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **updateUser**
> \SdkmsClient\Model\User updateUser($user_id, $body)

Update user

Change a user's properties.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\UsersApi();
$user_id = "user_id_example"; // string | User Identifier
$body = new \SdkmsClient\Model\UserRequest(); // \SdkmsClient\Model\UserRequest | Name of user

try {
    $result = $api_instance->updateUser($user_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->updateUser: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**| User Identifier |
 **body** | [**\SdkmsClient\Model\UserRequest**](../Model/UserRequest.md)| Name of user |

### Return type

[**\SdkmsClient\Model\User**](../Model/User.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **validatePasswordResetToken**
> \SdkmsClient\Model\ValidateTokenResponse validatePasswordResetToken($user_id, $body)

Validates password reset token for the user

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\UsersApi();
$user_id = "user_id_example"; // string | User Identifier
$body = new \SdkmsClient\Model\ValidateTokenRequest(); // \SdkmsClient\Model\ValidateTokenRequest | Validate token

try {
    $result = $api_instance->validatePasswordResetToken($user_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->validatePasswordResetToken: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**| User Identifier |
 **body** | [**\SdkmsClient\Model\ValidateTokenRequest**](../Model/ValidateTokenRequest.md)| Validate token |

### Return type

[**\SdkmsClient\Model\ValidateTokenResponse**](../Model/ValidateTokenResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

