# Account

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**name** | **string** | Name of the account. Account names must be unique within an SDKMS instance. | 
**acct_id** | **string** | Account ID uniquely identifying this account. | 
**description** | **string** | Description of this account. | [optional] 
**organization** | **string** | Organization (e.g. company name) that owns this account | [optional] 
**country** | **string** | Main country associated with this account | [optional] 
**phone** | **string** | Contact phone number associated with this account | [optional] 
**notification_pref** | [**\SdkmsClient\Model\NotificationPref**](NotificationPref.md) |  | [optional] 
**auth_config** | [**\SdkmsClient\Model\AuthConfig**](AuthConfig.md) |  | [optional] 
**subscription** | [**\SdkmsClient\Model\SubscriptionType**](SubscriptionType.md) |  | 
**state** | [**\SdkmsClient\Model\AccountState**](AccountState.md) |  | 
**auth_type** | [**\SdkmsClient\Model\AuthType**](AuthType.md) |  | 
**logging_configs** | [**map[string,\SdkmsClient\Model\LoggingConfig]**](LoggingConfig.md) | Map from UUIDs to LoggingConfig objects | [optional] 
**enabled** | **bool** | Whether this account is enabled. This may only be changed by sysadmins. | [optional] 
**created_at** | **string** | When this account was created. | [optional] 
**initial_purchase_at** | **string** | When this accout was upgraded a paid subscription. | [optional] 
**pending_subscription_change_request** | [**\SdkmsClient\Model\SubscriptionChangeRequest**](SubscriptionChangeRequest.md) |  | [optional] 
**custom_metadata** | **map[string,string]** | Sysadmin-defined metadata for this account. Stored as key-value pairs. This field is only visible to sysadmin users. | [optional] 
**key_undo_policy** | [**\SdkmsClient\Model\KeyUndoPolicy**](KeyUndoPolicy.md) |  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


