# UnwrapKeyRequest

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**alg** | [**\SdkmsClient\Model\ObjectType**](ObjectType.md) |  | 
**group_id** | **string** | Group ID (not name) of the security group that this security object should belong to. The user or application creating this security object must be a member of this group. If no group is specified, the default group for the user or application will be used. | [optional] 
**obj_type** | [**\SdkmsClient\Model\ObjectType**](ObjectType.md) |  | 
**wrapped_key** | **string** | A Security Object previously wrapped with another key. | 
**mode** | [**\SdkmsClient\Model\CryptMode**](CryptMode.md) |  | [optional] 
**iv** | **string** | The initialization value used to encrypt this ciphertext. This field is required for symmetric ciphers, and ignored for asymmetric ciphers. | [optional] 
**ad** | **string** | The authenticated data used with this ciphertext and authentication tag. This field is required for symmetric ciphers using cipher mode GCM or CCM, and must not be specified for all other ciphers. | [optional] 
**tag** | **string** | The authentication tag used with this ciphertext and authenticated data. This field is required for symmetric ciphers using cipher mode GCM or CCM, and must not be specified for all other ciphers. | [optional] 
**name** | **string** | Name of the security object to unwrap. Security object names must be unique within an account. | 
**description** | **string** | Description of the Security object to unwrap. | [optional] 
**key_ops** | [**\SdkmsClient\Model\KeyOperations[]**](KeyOperations.md) | Optional array of key operations to be enabled for this security object. If this property is not provided, the SDKMS server will provide a default set of key operations. Note that if you provide an empty array, all key operations will be disabled. | [optional] 
**custom_metadata** | **map[string,string]** | User-defined metadata for this key. Stored as key-value pairs. | [optional] 
**enabled** | **bool** | Whether the new security object should be enabled. Disabled security objects may not perform cryptographic operations. | [optional] 
**transient** | **bool** | If this is true, SDKMS will unwrap a transient key. | [optional] 
**rsa** | [**\SdkmsClient\Model\RsaOptions**](RsaOptions.md) |  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


