<?php
/**
 * AppsApi
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Api;

use \SdkmsClient\ApiClient;
use \SdkmsClient\ApiException;
use \SdkmsClient\Configuration;
use \SdkmsClient\ObjectSerializer;

/**
 * AppsApi Class Doc Comment
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class AppsApi
{
    /**
     * API Client
     *
     * @var \SdkmsClient\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \SdkmsClient\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\SdkmsClient\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \SdkmsClient\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \SdkmsClient\ApiClient $apiClient set the API client
     *
     * @return AppsApi
     */
    public function setApiClient(\SdkmsClient\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation createApp
     *
     * Create a new application
     *
     * @param \SdkmsClient\Model\AppRequest $body Properties of application to create (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\App
     */
    public function createApp($body)
    {
        list($response) = $this->createAppWithHttpInfo($body);
        return $response;
    }

    /**
     * Operation createAppWithHttpInfo
     *
     * Create a new application
     *
     * @param \SdkmsClient\Model\AppRequest $body Properties of application to create (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\App, HTTP status code, HTTP response headers (array of strings)
     */
    public function createAppWithHttpInfo($body)
    {
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling createApp');
        }
        // parse inputs
        $resourcePath = "/sys/v1/apps";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\App',
                '/sys/v1/apps'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\App', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 201:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\App', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation deleteApp
     *
     * Delete application
     *
     * @param string $app_id Application Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return void
     */
    public function deleteApp($app_id)
    {
        list($response) = $this->deleteAppWithHttpInfo($app_id);
        return $response;
    }

    /**
     * Operation deleteAppWithHttpInfo
     *
     * Delete application
     *
     * @param string $app_id Application Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteAppWithHttpInfo($app_id)
    {
        // verify the required parameter 'app_id' is set
        if ($app_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $app_id when calling deleteApp');
        }
        // parse inputs
        $resourcePath = "/sys/v1/apps/{app-id}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($app_id !== null) {
            $resourcePath = str_replace(
                "{" . "app-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($app_id),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'DELETE',
                $queryParams,
                $httpBody,
                $headerParams,
                null,
                '/sys/v1/apps/{app-id}'
            );

            return [null, $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getApp
     *
     * Get a specific application
     *
     * @param string $app_id Application Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\App
     */
    public function getApp($app_id)
    {
        list($response) = $this->getAppWithHttpInfo($app_id);
        return $response;
    }

    /**
     * Operation getAppWithHttpInfo
     *
     * Get a specific application
     *
     * @param string $app_id Application Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\App, HTTP status code, HTTP response headers (array of strings)
     */
    public function getAppWithHttpInfo($app_id)
    {
        // verify the required parameter 'app_id' is set
        if ($app_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $app_id when calling getApp');
        }
        // parse inputs
        $resourcePath = "/sys/v1/apps/{app-id}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($app_id !== null) {
            $resourcePath = str_replace(
                "{" . "app-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($app_id),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\App',
                '/sys/v1/apps/{app-id}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\App', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\App', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getApps
     *
     * Get all applications
     *
     * @param string $group_id Only retrieve applications in the specified group. (optional)
     * @param string $sort This specifies the property (&#x60;app_id&#x60; only, for now) and order (ascending or descending) with which to sort the apps. By default, apps are sorted by &#x60;app_id&#x60; in ascending order. The syntax is \&quot;&lt;property&gt;:[asc|desc]\&quot; (e.g. \&quot;app_id:desc\&quot;) or just \&quot;&lt;property&gt;\&quot; (ascending order by default). (optional)
     * @param string $start If provided, this must be a value of the property specified in &#x60;sort&#x60;. Returned apps will begin just above or just below this value (for asc/desc order resp.). (optional)
     * @param int $limit Maximum number of apps to return. If not provided, the limit is 100. (optional)
     * @param int $offset Number of apps past &#x60;start&#x60; to skip. (optional)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\App[]
     */
    public function getApps($group_id = null, $sort = null, $start = null, $limit = null, $offset = null)
    {
        list($response) = $this->getAppsWithHttpInfo($group_id, $sort, $start, $limit, $offset);
        return $response;
    }

    /**
     * Operation getAppsWithHttpInfo
     *
     * Get all applications
     *
     * @param string $group_id Only retrieve applications in the specified group. (optional)
     * @param string $sort This specifies the property (&#x60;app_id&#x60; only, for now) and order (ascending or descending) with which to sort the apps. By default, apps are sorted by &#x60;app_id&#x60; in ascending order. The syntax is \&quot;&lt;property&gt;:[asc|desc]\&quot; (e.g. \&quot;app_id:desc\&quot;) or just \&quot;&lt;property&gt;\&quot; (ascending order by default). (optional)
     * @param string $start If provided, this must be a value of the property specified in &#x60;sort&#x60;. Returned apps will begin just above or just below this value (for asc/desc order resp.). (optional)
     * @param int $limit Maximum number of apps to return. If not provided, the limit is 100. (optional)
     * @param int $offset Number of apps past &#x60;start&#x60; to skip. (optional)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\App[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getAppsWithHttpInfo($group_id = null, $sort = null, $start = null, $limit = null, $offset = null)
    {
        // parse inputs
        $resourcePath = "/sys/v1/apps";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // query params
        if ($group_id !== null) {
            $queryParams['group_id'] = $this->apiClient->getSerializer()->toQueryValue($group_id);
        }
        // query params
        if ($sort !== null) {
            $queryParams['sort'] = $this->apiClient->getSerializer()->toQueryValue($sort);
        }
        // query params
        if ($start !== null) {
            $queryParams['start'] = $this->apiClient->getSerializer()->toQueryValue($start);
        }
        // query params
        if ($limit !== null) {
            $queryParams['limit'] = $this->apiClient->getSerializer()->toQueryValue($limit);
        }
        // query params
        if ($offset !== null) {
            $queryParams['offset'] = $this->apiClient->getSerializer()->toQueryValue($offset);
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\App[]',
                '/sys/v1/apps'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\App[]', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\App[]', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getCredential
     *
     * Get a specific application's credential
     *
     * @param string $app_id Application Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\AppCredentialResponse
     */
    public function getCredential($app_id)
    {
        list($response) = $this->getCredentialWithHttpInfo($app_id);
        return $response;
    }

    /**
     * Operation getCredentialWithHttpInfo
     *
     * Get a specific application's credential
     *
     * @param string $app_id Application Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\AppCredentialResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function getCredentialWithHttpInfo($app_id)
    {
        // verify the required parameter 'app_id' is set
        if ($app_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $app_id when calling getCredential');
        }
        // parse inputs
        $resourcePath = "/sys/v1/apps/{app-id}/credential";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($app_id !== null) {
            $resourcePath = str_replace(
                "{" . "app-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($app_id),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\AppCredentialResponse',
                '/sys/v1/apps/{app-id}/credential'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\AppCredentialResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\AppCredentialResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation regenerateApiKey
     *
     * Regenerate API key
     *
     * @param string $app_id Application Identifier (required)
     * @param \SdkmsClient\Model\AppResetSecretRequest $body Decryption request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\App
     */
    public function regenerateApiKey($app_id, $body)
    {
        list($response) = $this->regenerateApiKeyWithHttpInfo($app_id, $body);
        return $response;
    }

    /**
     * Operation regenerateApiKeyWithHttpInfo
     *
     * Regenerate API key
     *
     * @param string $app_id Application Identifier (required)
     * @param \SdkmsClient\Model\AppResetSecretRequest $body Decryption request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\App, HTTP status code, HTTP response headers (array of strings)
     */
    public function regenerateApiKeyWithHttpInfo($app_id, $body)
    {
        // verify the required parameter 'app_id' is set
        if ($app_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $app_id when calling regenerateApiKey');
        }
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling regenerateApiKey');
        }
        // parse inputs
        $resourcePath = "/sys/v1/apps/{app-id}/reset_secret";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($app_id !== null) {
            $resourcePath = str_replace(
                "{" . "app-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($app_id),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\App',
                '/sys/v1/apps/{app-id}/reset_secret'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\App', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\App', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation updateApp
     *
     * Update an application
     *
     * @param string $app_id Application Identifier (required)
     * @param \SdkmsClient\Model\AppRequest $body Properties of application to create (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\App
     */
    public function updateApp($app_id, $body)
    {
        list($response) = $this->updateAppWithHttpInfo($app_id, $body);
        return $response;
    }

    /**
     * Operation updateAppWithHttpInfo
     *
     * Update an application
     *
     * @param string $app_id Application Identifier (required)
     * @param \SdkmsClient\Model\AppRequest $body Properties of application to create (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\App, HTTP status code, HTTP response headers (array of strings)
     */
    public function updateAppWithHttpInfo($app_id, $body)
    {
        // verify the required parameter 'app_id' is set
        if ($app_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $app_id when calling updateApp');
        }
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling updateApp');
        }
        // parse inputs
        $resourcePath = "/sys/v1/apps/{app-id}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($app_id !== null) {
            $resourcePath = str_replace(
                "{" . "app-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($app_id),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'PATCH',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\App',
                '/sys/v1/apps/{app-id}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\App', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\App', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
