<?php
/**
 * EncryptionAndDecryptionApi
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Api;

use \SdkmsClient\ApiClient;
use \SdkmsClient\ApiException;
use \SdkmsClient\Configuration;
use \SdkmsClient\ObjectSerializer;

/**
 * EncryptionAndDecryptionApi Class Doc Comment
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class EncryptionAndDecryptionApi
{
    /**
     * API Client
     *
     * @var \SdkmsClient\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \SdkmsClient\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\SdkmsClient\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \SdkmsClient\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \SdkmsClient\ApiClient $apiClient set the API client
     *
     * @return EncryptionAndDecryptionApi
     */
    public function setApiClient(\SdkmsClient\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation batchDecrypt
     *
     * Batch decrypt with one or more keys
     *
     * @param \SdkmsClient\Model\BatchDecryptRequest $body Batch decryption request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\BatchDecryptResponse
     */
    public function batchDecrypt($body)
    {
        list($response) = $this->batchDecryptWithHttpInfo($body);
        return $response;
    }

    /**
     * Operation batchDecryptWithHttpInfo
     *
     * Batch decrypt with one or more keys
     *
     * @param \SdkmsClient\Model\BatchDecryptRequest $body Batch decryption request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\BatchDecryptResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function batchDecryptWithHttpInfo($body)
    {
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling batchDecrypt');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/keys/batch/decrypt";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\BatchDecryptResponse',
                '/crypto/v1/keys/batch/decrypt'
            );

            $arr =  (array) null;
            foreach($response as $r) {
                $val = $this->apiClient->getSerializer()->deserialize($r, '\SdkmsClient\Model\BatchDecryptResponseInner', $httpHeader);
                array_push($arr, $val);
            }
            return [$arr, $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\BatchDecryptResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation batchEncrypt
     *
     * Batch encrypt with one or more keys
     *
     * @param \SdkmsClient\Model\BatchEncryptRequest $body Batch Encryption request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\BatchEncryptResponse
     */
    public function batchEncrypt($body)
    {
        list($response) = $this->batchEncryptWithHttpInfo($body);
        return $response;
    }

    /**
     * Operation batchEncryptWithHttpInfo
     *
     * Batch encrypt with one or more keys
     *
     * @param \SdkmsClient\Model\BatchEncryptRequest $body Batch Encryption request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\BatchEncryptResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function batchEncryptWithHttpInfo($body)
    {
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling batchEncrypt');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/keys/batch/encrypt";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\BatchEncryptResponse',
                '/crypto/v1/keys/batch/encrypt'
            );

            $arr =  (array) null;
            foreach($response as $r) {
                $val = $this->apiClient->getSerializer()->deserialize($r, '\SdkmsClient\Model\BatchEncryptResponseInner', $httpHeader);
                array_push($arr, $val);
            }
            return [$arr, $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\BatchEncryptResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation decrypt
     *
     * Decrypt data
     *
     * @param string $key_id kid of security object (required)
     * @param \SdkmsClient\Model\DecryptRequest $body Decryption request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\DecryptResponse
     */
    public function decrypt($key_id, $body)
    {
        list($response) = $this->decryptWithHttpInfo($key_id, $body);
        return $response;
    }

    /**
     * Operation decryptWithHttpInfo
     *
     * Decrypt data
     *
     * @param string $key_id kid of security object (required)
     * @param \SdkmsClient\Model\DecryptRequest $body Decryption request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\DecryptResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function decryptWithHttpInfo($key_id, $body)
    {
        // verify the required parameter 'key_id' is set
        if ($key_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $key_id when calling decrypt');
        }
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling decrypt');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/keys/{key-id}/decrypt";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($key_id !== null) {
            $resourcePath = str_replace(
                "{" . "key-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($key_id),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\DecryptResponse',
                '/crypto/v1/keys/{key-id}/decrypt'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\DecryptResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\DecryptResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation decryptEx
     *
     * Decrypt data
     *
     * @param \SdkmsClient\Model\DecryptRequestEx $body Decryption request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\DecryptResponse
     */
    public function decryptEx($body)
    {
        list($response) = $this->decryptExWithHttpInfo($body);
        return $response;
    }

    /**
     * Operation decryptExWithHttpInfo
     *
     * Decrypt data
     *
     * @param \SdkmsClient\Model\DecryptRequestEx $body Decryption request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\DecryptResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function decryptExWithHttpInfo($body)
    {
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling decryptEx');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/decrypt";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\DecryptResponse',
                '/crypto/v1/decrypt'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\DecryptResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\DecryptResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation decryptFinal
     *
     * Conclude multi-part decryption
     *
     * @param string $key_id kid of security object (required)
     * @param \SdkmsClient\Model\DecryptFinalRequest $body Finish multi-part decryption (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\DecryptFinalResponse
     */
    public function decryptFinal($key_id, $body)
    {
        list($response) = $this->decryptFinalWithHttpInfo($key_id, $body);
        return $response;
    }

    /**
     * Operation decryptFinalWithHttpInfo
     *
     * Conclude multi-part decryption
     *
     * @param string $key_id kid of security object (required)
     * @param \SdkmsClient\Model\DecryptFinalRequest $body Finish multi-part decryption (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\DecryptFinalResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function decryptFinalWithHttpInfo($key_id, $body)
    {
        // verify the required parameter 'key_id' is set
        if ($key_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $key_id when calling decryptFinal');
        }
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling decryptFinal');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/keys/{key-id}/decrypt/final";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($key_id !== null) {
            $resourcePath = str_replace(
                "{" . "key-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($key_id),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\DecryptFinalResponse',
                '/crypto/v1/keys/{key-id}/decrypt/final'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\DecryptFinalResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\DecryptFinalResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation decryptFinalEx
     *
     * Conclude multi-part decryption
     *
     * @param \SdkmsClient\Model\DecryptFinalRequestEx $body Finish multi-part decryption (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\DecryptFinalResponse
     */
    public function decryptFinalEx($body)
    {
        list($response) = $this->decryptFinalExWithHttpInfo($body);
        return $response;
    }

    /**
     * Operation decryptFinalExWithHttpInfo
     *
     * Conclude multi-part decryption
     *
     * @param \SdkmsClient\Model\DecryptFinalRequestEx $body Finish multi-part decryption (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\DecryptFinalResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function decryptFinalExWithHttpInfo($body)
    {
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling decryptFinalEx');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/decrypt/final";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\DecryptFinalResponse',
                '/crypto/v1/decrypt/final'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\DecryptFinalResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\DecryptFinalResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation decryptInit
     *
     * Begin multi-part decryption
     *
     * @param string $key_id kid of security object (required)
     * @param \SdkmsClient\Model\DecryptInitRequest $body Multi-part decryption initialization request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\DecryptInitResponse
     */
    public function decryptInit($key_id, $body)
    {
        list($response) = $this->decryptInitWithHttpInfo($key_id, $body);
        return $response;
    }

    /**
     * Operation decryptInitWithHttpInfo
     *
     * Begin multi-part decryption
     *
     * @param string $key_id kid of security object (required)
     * @param \SdkmsClient\Model\DecryptInitRequest $body Multi-part decryption initialization request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\DecryptInitResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function decryptInitWithHttpInfo($key_id, $body)
    {
        // verify the required parameter 'key_id' is set
        if ($key_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $key_id when calling decryptInit');
        }
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling decryptInit');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/keys/{key-id}/decrypt/init";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($key_id !== null) {
            $resourcePath = str_replace(
                "{" . "key-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($key_id),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\DecryptInitResponse',
                '/crypto/v1/keys/{key-id}/decrypt/init'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\DecryptInitResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\DecryptInitResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation decryptInitEx
     *
     * Begin multi-part decryption
     *
     * @param \SdkmsClient\Model\DecryptInitRequestEx $body Multi-part decryption initialization request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\DecryptInitResponse
     */
    public function decryptInitEx($body)
    {
        list($response) = $this->decryptInitExWithHttpInfo($body);
        return $response;
    }

    /**
     * Operation decryptInitExWithHttpInfo
     *
     * Begin multi-part decryption
     *
     * @param \SdkmsClient\Model\DecryptInitRequestEx $body Multi-part decryption initialization request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\DecryptInitResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function decryptInitExWithHttpInfo($body)
    {
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling decryptInitEx');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/decrypt/init";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\DecryptInitResponse',
                '/crypto/v1/decrypt/init'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\DecryptInitResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\DecryptInitResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation decryptUpdate
     *
     * Continue multi-part decryption
     *
     * @param string $key_id kid of security object (required)
     * @param \SdkmsClient\Model\DecryptUpdateRequest $body Multi-part decryption (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\DecryptUpdateResponse
     */
    public function decryptUpdate($key_id, $body)
    {
        list($response) = $this->decryptUpdateWithHttpInfo($key_id, $body);
        return $response;
    }

    /**
     * Operation decryptUpdateWithHttpInfo
     *
     * Continue multi-part decryption
     *
     * @param string $key_id kid of security object (required)
     * @param \SdkmsClient\Model\DecryptUpdateRequest $body Multi-part decryption (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\DecryptUpdateResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function decryptUpdateWithHttpInfo($key_id, $body)
    {
        // verify the required parameter 'key_id' is set
        if ($key_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $key_id when calling decryptUpdate');
        }
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling decryptUpdate');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/keys/{key-id}/decrypt/update";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($key_id !== null) {
            $resourcePath = str_replace(
                "{" . "key-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($key_id),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\DecryptUpdateResponse',
                '/crypto/v1/keys/{key-id}/decrypt/update'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\DecryptUpdateResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\DecryptUpdateResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation decryptUpdateEx
     *
     * Continue multi-part decryption
     *
     * @param \SdkmsClient\Model\DecryptUpdateRequestEx $body Multi-part decryption (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\DecryptUpdateResponse
     */
    public function decryptUpdateEx($body)
    {
        list($response) = $this->decryptUpdateExWithHttpInfo($body);
        return $response;
    }

    /**
     * Operation decryptUpdateExWithHttpInfo
     *
     * Continue multi-part decryption
     *
     * @param \SdkmsClient\Model\DecryptUpdateRequestEx $body Multi-part decryption (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\DecryptUpdateResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function decryptUpdateExWithHttpInfo($body)
    {
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling decryptUpdateEx');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/decrypt/update";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\DecryptUpdateResponse',
                '/crypto/v1/decrypt/update'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\DecryptUpdateResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\DecryptUpdateResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation encrypt
     *
     * Encrypt data
     *
     * @param string $key_id kid of security object (required)
     * @param \SdkmsClient\Model\EncryptRequest $body Encryption request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\EncryptResponse
     */
    public function encrypt($key_id, $body)
    {
        list($response) = $this->encryptWithHttpInfo($key_id, $body);
        return $response;
    }

    /**
     * Operation encryptWithHttpInfo
     *
     * Encrypt data
     *
     * @param string $key_id kid of security object (required)
     * @param \SdkmsClient\Model\EncryptRequest $body Encryption request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\EncryptResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function encryptWithHttpInfo($key_id, $body)
    {
        // verify the required parameter 'key_id' is set
        if ($key_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $key_id when calling encrypt');
        }
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling encrypt');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/keys/{key-id}/encrypt";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($key_id !== null) {
            $resourcePath = str_replace(
                "{" . "key-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($key_id),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\EncryptResponse',
                '/crypto/v1/keys/{key-id}/encrypt'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\EncryptResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\EncryptResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation encryptEx
     *
     * Encrypt data
     *
     * @param \SdkmsClient\Model\EncryptRequestEx $body Encryption request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\EncryptResponse
     */
    public function encryptEx($body)
    {
        list($response) = $this->encryptExWithHttpInfo($body);
        return $response;
    }

    /**
     * Operation encryptExWithHttpInfo
     *
     * Encrypt data
     *
     * @param \SdkmsClient\Model\EncryptRequestEx $body Encryption request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\EncryptResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function encryptExWithHttpInfo($body)
    {
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling encryptEx');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/encrypt";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\EncryptResponse',
                '/crypto/v1/encrypt'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\EncryptResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\EncryptResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation encryptFinal
     *
     * Conclude multi-part encryption
     *
     * @param string $key_id kid of security object (required)
     * @param \SdkmsClient\Model\EncryptFinalRequest $body Finish multi-part encryption (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\EncryptFinalResponse
     */
    public function encryptFinal($key_id, $body)
    {
        list($response) = $this->encryptFinalWithHttpInfo($key_id, $body);
        return $response;
    }

    /**
     * Operation encryptFinalWithHttpInfo
     *
     * Conclude multi-part encryption
     *
     * @param string $key_id kid of security object (required)
     * @param \SdkmsClient\Model\EncryptFinalRequest $body Finish multi-part encryption (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\EncryptFinalResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function encryptFinalWithHttpInfo($key_id, $body)
    {
        // verify the required parameter 'key_id' is set
        if ($key_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $key_id when calling encryptFinal');
        }
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling encryptFinal');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/keys/{key-id}/encrypt/final";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($key_id !== null) {
            $resourcePath = str_replace(
                "{" . "key-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($key_id),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\EncryptFinalResponse',
                '/crypto/v1/keys/{key-id}/encrypt/final'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\EncryptFinalResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\EncryptFinalResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation encryptFinalEx
     *
     * Conclude multi-part encryption
     *
     * @param \SdkmsClient\Model\EncryptFinalRequestEx $body Finish multi-part encryption (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\EncryptFinalResponse
     */
    public function encryptFinalEx($body)
    {
        list($response) = $this->encryptFinalExWithHttpInfo($body);
        return $response;
    }

    /**
     * Operation encryptFinalExWithHttpInfo
     *
     * Conclude multi-part encryption
     *
     * @param \SdkmsClient\Model\EncryptFinalRequestEx $body Finish multi-part encryption (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\EncryptFinalResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function encryptFinalExWithHttpInfo($body)
    {
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling encryptFinalEx');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/encrypt/final";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\EncryptFinalResponse',
                '/crypto/v1/encrypt/final'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\EncryptFinalResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\EncryptFinalResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation encryptInit
     *
     * Begin multi-part encryption
     *
     * @param string $key_id kid of security object (required)
     * @param \SdkmsClient\Model\EncryptInitRequest $body Multi-part encryption initialization request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\EncryptInitResponse
     */
    public function encryptInit($key_id, $body)
    {
        list($response) = $this->encryptInitWithHttpInfo($key_id, $body);
        return $response;
    }

    /**
     * Operation encryptInitWithHttpInfo
     *
     * Begin multi-part encryption
     *
     * @param string $key_id kid of security object (required)
     * @param \SdkmsClient\Model\EncryptInitRequest $body Multi-part encryption initialization request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\EncryptInitResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function encryptInitWithHttpInfo($key_id, $body)
    {
        // verify the required parameter 'key_id' is set
        if ($key_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $key_id when calling encryptInit');
        }
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling encryptInit');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/keys/{key-id}/encrypt/init";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($key_id !== null) {
            $resourcePath = str_replace(
                "{" . "key-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($key_id),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\EncryptInitResponse',
                '/crypto/v1/keys/{key-id}/encrypt/init'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\EncryptInitResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\EncryptInitResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation encryptInitEx
     *
     * Begin multi-part encryption
     *
     * @param \SdkmsClient\Model\EncryptInitRequestEx $body Multi-part encryption initialization request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\EncryptInitResponse
     */
    public function encryptInitEx($body)
    {
        list($response) = $this->encryptInitExWithHttpInfo($body);
        return $response;
    }

    /**
     * Operation encryptInitExWithHttpInfo
     *
     * Begin multi-part encryption
     *
     * @param \SdkmsClient\Model\EncryptInitRequestEx $body Multi-part encryption initialization request (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\EncryptInitResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function encryptInitExWithHttpInfo($body)
    {
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling encryptInitEx');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/encrypt/init";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\EncryptInitResponse',
                '/crypto/v1/encrypt/init'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\EncryptInitResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\EncryptInitResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation encryptUpdate
     *
     * Continue multi-part encryption
     *
     * @param string $key_id kid of security object (required)
     * @param \SdkmsClient\Model\EncryptUpdateRequest $body Multi-part encryption (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\EncryptUpdateResponse
     */
    public function encryptUpdate($key_id, $body)
    {
        list($response) = $this->encryptUpdateWithHttpInfo($key_id, $body);
        return $response;
    }

    /**
     * Operation encryptUpdateWithHttpInfo
     *
     * Continue multi-part encryption
     *
     * @param string $key_id kid of security object (required)
     * @param \SdkmsClient\Model\EncryptUpdateRequest $body Multi-part encryption (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\EncryptUpdateResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function encryptUpdateWithHttpInfo($key_id, $body)
    {
        // verify the required parameter 'key_id' is set
        if ($key_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $key_id when calling encryptUpdate');
        }
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling encryptUpdate');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/keys/{key-id}/encrypt/update";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($key_id !== null) {
            $resourcePath = str_replace(
                "{" . "key-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($key_id),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\EncryptUpdateResponse',
                '/crypto/v1/keys/{key-id}/encrypt/update'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\EncryptUpdateResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\EncryptUpdateResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation encryptUpdateEx
     *
     * Continue multi-part encryption
     *
     * @param \SdkmsClient\Model\EncryptUpdateRequestEx $body Multi-part encryption (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\EncryptUpdateResponse
     */
    public function encryptUpdateEx($body)
    {
        list($response) = $this->encryptUpdateExWithHttpInfo($body);
        return $response;
    }

    /**
     * Operation encryptUpdateExWithHttpInfo
     *
     * Continue multi-part encryption
     *
     * @param \SdkmsClient\Model\EncryptUpdateRequestEx $body Multi-part encryption (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\EncryptUpdateResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function encryptUpdateExWithHttpInfo($body)
    {
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling encryptUpdateEx');
        }
        // parse inputs
        $resourcePath = "/crypto/v1/encrypt/update";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\EncryptUpdateResponse',
                '/crypto/v1/encrypt/update'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\EncryptUpdateResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\EncryptUpdateResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
