<?php
/**
 * AccountRequest
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * AccountRequest Class Doc Comment
 *
 * @category    Class
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class AccountRequest implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'AccountRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'name' => 'string',
        'description' => 'string',
        'organization' => 'string',
        'country' => 'string',
        'phone' => 'string',
        'notification_pref' => '\SdkmsClient\Model\NotificationPref',
        'auth_config' => '\SdkmsClient\Model\AuthConfig',
        'add_logging_configs' => '\SdkmsClient\Model\LoggingConfigRequest[]',
        'mod_logging_configs' => 'map[string,\SdkmsClient\Model\LoggingConfigRequest]',
        'del_logging_configs' => 'string[]',
        'pending_subscription_change_request' => '\SdkmsClient\Model\SubscriptionChangeRequest',
        'enabled' => 'bool',
        'subscription' => '\SdkmsClient\Model\SubscriptionType',
        'custom_metadata' => 'map[string,string]',
        'key_undo_policy' => '\SdkmsClient\Model\KeyUndoPolicy'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'name' => null,
        'description' => null,
        'organization' => null,
        'country' => null,
        'phone' => null,
        'notification_pref' => null,
        'auth_config' => null,
        'add_logging_configs' => null,
        'mod_logging_configs' => null,
        'del_logging_configs' => null,
        'pending_subscription_change_request' => null,
        'enabled' => null,
        'subscription' => null,
        'custom_metadata' => null,
        'key_undo_policy' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'name' => 'name',
        'description' => 'description',
        'organization' => 'organization',
        'country' => 'country',
        'phone' => 'phone',
        'notification_pref' => 'notification_pref',
        'auth_config' => 'auth_config',
        'add_logging_configs' => 'add_logging_configs',
        'mod_logging_configs' => 'mod_logging_configs',
        'del_logging_configs' => 'del_logging_configs',
        'pending_subscription_change_request' => 'pending_subscription_change_request',
        'enabled' => 'enabled',
        'subscription' => 'subscription',
        'custom_metadata' => 'custom_metadata',
        'key_undo_policy' => 'key_undo_policy'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'name' => 'setName',
        'description' => 'setDescription',
        'organization' => 'setOrganization',
        'country' => 'setCountry',
        'phone' => 'setPhone',
        'notification_pref' => 'setNotificationPref',
        'auth_config' => 'setAuthConfig',
        'add_logging_configs' => 'setAddLoggingConfigs',
        'mod_logging_configs' => 'setModLoggingConfigs',
        'del_logging_configs' => 'setDelLoggingConfigs',
        'pending_subscription_change_request' => 'setPendingSubscriptionChangeRequest',
        'enabled' => 'setEnabled',
        'subscription' => 'setSubscription',
        'custom_metadata' => 'setCustomMetadata',
        'key_undo_policy' => 'setKeyUndoPolicy'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'name' => 'getName',
        'description' => 'getDescription',
        'organization' => 'getOrganization',
        'country' => 'getCountry',
        'phone' => 'getPhone',
        'notification_pref' => 'getNotificationPref',
        'auth_config' => 'getAuthConfig',
        'add_logging_configs' => 'getAddLoggingConfigs',
        'mod_logging_configs' => 'getModLoggingConfigs',
        'del_logging_configs' => 'getDelLoggingConfigs',
        'pending_subscription_change_request' => 'getPendingSubscriptionChangeRequest',
        'enabled' => 'getEnabled',
        'subscription' => 'getSubscription',
        'custom_metadata' => 'getCustomMetadata',
        'key_undo_policy' => 'getKeyUndoPolicy'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['description'] = isset($data['description']) ? $data['description'] : null;
        $this->container['organization'] = isset($data['organization']) ? $data['organization'] : null;
        $this->container['country'] = isset($data['country']) ? $data['country'] : null;
        $this->container['phone'] = isset($data['phone']) ? $data['phone'] : null;
        $this->container['notification_pref'] = isset($data['notification_pref']) ? $data['notification_pref'] : null;
        $this->container['auth_config'] = isset($data['auth_config']) ? $data['auth_config'] : null;
        $this->container['add_logging_configs'] = isset($data['add_logging_configs']) ? $data['add_logging_configs'] : null;
        $this->container['mod_logging_configs'] = isset($data['mod_logging_configs']) ? $data['mod_logging_configs'] : null;
        $this->container['del_logging_configs'] = isset($data['del_logging_configs']) ? $data['del_logging_configs'] : null;
        $this->container['pending_subscription_change_request'] = isset($data['pending_subscription_change_request']) ? $data['pending_subscription_change_request'] : null;
        $this->container['enabled'] = isset($data['enabled']) ? $data['enabled'] : null;
        $this->container['subscription'] = isset($data['subscription']) ? $data['subscription'] : null;
        $this->container['custom_metadata'] = isset($data['custom_metadata']) ? $data['custom_metadata'] : null;
        $this->container['key_undo_policy'] = isset($data['key_undo_policy']) ? $data['key_undo_policy'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        return true;
    }


    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     * @param string $name Name of the account. Accounts must be unique within an SDKMS instance.
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     * @param string $description Account ID uniquely identifying this account.
     * @return $this
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets organization
     * @return string
     */
    public function getOrganization()
    {
        return $this->container['organization'];
    }

    /**
     * Sets organization
     * @param string $organization Organization (e.g. company name) that owns this account
     * @return $this
     */
    public function setOrganization($organization)
    {
        $this->container['organization'] = $organization;

        return $this;
    }

    /**
     * Gets country
     * @return string
     */
    public function getCountry()
    {
        return $this->container['country'];
    }

    /**
     * Sets country
     * @param string $country Main country associated with this account
     * @return $this
     */
    public function setCountry($country)
    {
        $this->container['country'] = $country;

        return $this;
    }

    /**
     * Gets phone
     * @return string
     */
    public function getPhone()
    {
        return $this->container['phone'];
    }

    /**
     * Sets phone
     * @param string $phone Contact phone number associated with this account
     * @return $this
     */
    public function setPhone($phone)
    {
        $this->container['phone'] = $phone;

        return $this;
    }

    /**
     * Gets notification_pref
     * @return \SdkmsClient\Model\NotificationPref
     */
    public function getNotificationPref()
    {
        return $this->container['notification_pref'];
    }

    /**
     * Sets notification_pref
     * @param \SdkmsClient\Model\NotificationPref $notification_pref
     * @return $this
     */
    public function setNotificationPref($notification_pref)
    {
        $this->container['notification_pref'] = $notification_pref;

        return $this;
    }

    /**
     * Gets auth_config
     * @return \SdkmsClient\Model\AuthConfig
     */
    public function getAuthConfig()
    {
        return $this->container['auth_config'];
    }

    /**
     * Sets auth_config
     * @param \SdkmsClient\Model\AuthConfig $auth_config
     * @return $this
     */
    public function setAuthConfig($auth_config)
    {
        $this->container['auth_config'] = $auth_config;

        return $this;
    }

    /**
     * Gets add_logging_configs
     * @return \SdkmsClient\Model\LoggingConfigRequest[]
     */
    public function getAddLoggingConfigs()
    {
        return $this->container['add_logging_configs'];
    }

    /**
     * Sets add_logging_configs
     * @param \SdkmsClient\Model\LoggingConfigRequest[] $add_logging_configs
     * @return $this
     */
    public function setAddLoggingConfigs($add_logging_configs)
    {
        $this->container['add_logging_configs'] = $add_logging_configs;

        return $this;
    }

    /**
     * Gets mod_logging_configs
     * @return map[string,\SdkmsClient\Model\LoggingConfigRequest]
     */
    public function getModLoggingConfigs()
    {
        return $this->container['mod_logging_configs'];
    }

    /**
     * Sets mod_logging_configs
     * @param map[string,\SdkmsClient\Model\LoggingConfigRequest] $mod_logging_configs Map from UUIDs to LoggingConfigRequest objects
     * @return $this
     */
    public function setModLoggingConfigs($mod_logging_configs)
    {
        $this->container['mod_logging_configs'] = $mod_logging_configs;

        return $this;
    }

    /**
     * Gets del_logging_configs
     * @return string[]
     */
    public function getDelLoggingConfigs()
    {
        return $this->container['del_logging_configs'];
    }

    /**
     * Sets del_logging_configs
     * @param string[] $del_logging_configs
     * @return $this
     */
    public function setDelLoggingConfigs($del_logging_configs)
    {
        $this->container['del_logging_configs'] = $del_logging_configs;

        return $this;
    }

    /**
     * Gets pending_subscription_change_request
     * @return \SdkmsClient\Model\SubscriptionChangeRequest
     */
    public function getPendingSubscriptionChangeRequest()
    {
        return $this->container['pending_subscription_change_request'];
    }

    /**
     * Sets pending_subscription_change_request
     * @param \SdkmsClient\Model\SubscriptionChangeRequest $pending_subscription_change_request
     * @return $this
     */
    public function setPendingSubscriptionChangeRequest($pending_subscription_change_request)
    {
        $this->container['pending_subscription_change_request'] = $pending_subscription_change_request;

        return $this;
    }

    /**
     * Gets enabled
     * @return bool
     */
    public function getEnabled()
    {
        return $this->container['enabled'];
    }

    /**
     * Sets enabled
     * @param bool $enabled Whether this account is enabled. This may only be changed by sysadmins.
     * @return $this
     */
    public function setEnabled($enabled)
    {
        $this->container['enabled'] = $enabled;

        return $this;
    }

    /**
     * Gets subscription
     * @return \SdkmsClient\Model\SubscriptionType
     */
    public function getSubscription()
    {
        return $this->container['subscription'];
    }

    /**
     * Sets subscription
     * @param \SdkmsClient\Model\SubscriptionType $subscription
     * @return $this
     */
    public function setSubscription($subscription)
    {
        $this->container['subscription'] = $subscription;

        return $this;
    }

    /**
     * Gets custom_metadata
     * @return map[string,string]
     */
    public function getCustomMetadata()
    {
        return $this->container['custom_metadata'];
    }

    /**
     * Sets custom_metadata
     * @param map[string,string] $custom_metadata Sysadmin-defined metadata for this account. Stored as key-value pairs. This field may only be used by sysadmin users.
     * @return $this
     */
    public function setCustomMetadata($custom_metadata)
    {
        $this->container['custom_metadata'] = $custom_metadata;

        return $this;
    }

    /**
     * Gets key_undo_policy
     * @return \SdkmsClient\Model\KeyUndoPolicy
     */
    public function getKeyUndoPolicy()
    {
        return $this->container['key_undo_policy'];
    }

    /**
     * Sets key_undo_policy
     * @param \SdkmsClient\Model\KeyUndoPolicy $key_undo_policy
     * @return $this
     */
    public function setKeyUndoPolicy($key_undo_policy)
    {
        $this->container['key_undo_policy'] = $key_undo_policy;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


