<?php
/**
 * App
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * App Class Doc Comment
 *
 * @category    Class
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class App implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'App';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'name' => 'string',
        'app_id' => 'string',
        'auth_type' => '\SdkmsClient\Model\AppAuthType',
        'description' => 'string',
        'interface' => 'string',
        'acct_id' => 'string',
        'groups' => 'string[]',
        'default_group' => 'string',
        'enabled' => 'bool',
        'app_type' => 'string',
        'creator' => '\SdkmsClient\Model\CreatorType',
        'created_at' => 'string',
        'lastused_at' => 'string',
        'oauth_config' => '\SdkmsClient\Model\AppOauthConfig',
        'cert_not_after' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'name' => null,
        'app_id' => null,
        'auth_type' => null,
        'description' => null,
        'interface' => null,
        'acct_id' => null,
        'groups' => null,
        'default_group' => null,
        'enabled' => null,
        'app_type' => null,
        'creator' => null,
        'created_at' => 'dateTime',
        'lastused_at' => 'dateTime',
        'oauth_config' => null,
        'cert_not_after' => 'dateTime'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'name' => 'name',
        'app_id' => 'app_id',
        'auth_type' => 'auth_type',
        'description' => 'description',
        'interface' => 'interface',
        'acct_id' => 'acct_id',
        'groups' => 'groups',
        'default_group' => 'default_group',
        'enabled' => 'enabled',
        'app_type' => 'app_type',
        'creator' => 'creator',
        'created_at' => 'created_at',
        'lastused_at' => 'lastused_at',
        'oauth_config' => 'oauth_config',
        'cert_not_after' => 'cert_not_after'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'name' => 'setName',
        'app_id' => 'setAppId',
        'auth_type' => 'setAuthType',
        'description' => 'setDescription',
        'interface' => 'setInterface',
        'acct_id' => 'setAcctId',
        'groups' => 'setGroups',
        'default_group' => 'setDefaultGroup',
        'enabled' => 'setEnabled',
        'app_type' => 'setAppType',
        'creator' => 'setCreator',
        'created_at' => 'setCreatedAt',
        'lastused_at' => 'setLastusedAt',
        'oauth_config' => 'setOauthConfig',
        'cert_not_after' => 'setCertNotAfter'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'name' => 'getName',
        'app_id' => 'getAppId',
        'auth_type' => 'getAuthType',
        'description' => 'getDescription',
        'interface' => 'getInterface',
        'acct_id' => 'getAcctId',
        'groups' => 'getGroups',
        'default_group' => 'getDefaultGroup',
        'enabled' => 'getEnabled',
        'app_type' => 'getAppType',
        'creator' => 'getCreator',
        'created_at' => 'getCreatedAt',
        'lastused_at' => 'getLastusedAt',
        'oauth_config' => 'getOauthConfig',
        'cert_not_after' => 'getCertNotAfter'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['app_id'] = isset($data['app_id']) ? $data['app_id'] : null;
        $this->container['auth_type'] = isset($data['auth_type']) ? $data['auth_type'] : null;
        $this->container['description'] = isset($data['description']) ? $data['description'] : null;
        $this->container['interface'] = isset($data['interface']) ? $data['interface'] : null;
        $this->container['acct_id'] = isset($data['acct_id']) ? $data['acct_id'] : null;
        $this->container['groups'] = isset($data['groups']) ? $data['groups'] : null;
        $this->container['default_group'] = isset($data['default_group']) ? $data['default_group'] : null;
        $this->container['enabled'] = isset($data['enabled']) ? $data['enabled'] : null;
        $this->container['app_type'] = isset($data['app_type']) ? $data['app_type'] : null;
        $this->container['creator'] = isset($data['creator']) ? $data['creator'] : null;
        $this->container['created_at'] = isset($data['created_at']) ? $data['created_at'] : null;
        $this->container['lastused_at'] = isset($data['lastused_at']) ? $data['lastused_at'] : null;
        $this->container['oauth_config'] = isset($data['oauth_config']) ? $data['oauth_config'] : null;
        $this->container['cert_not_after'] = isset($data['cert_not_after']) ? $data['cert_not_after'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['name'] === null) {
            $invalid_properties[] = "'name' can't be null";
        }
        if ($this->container['app_id'] === null) {
            $invalid_properties[] = "'app_id' can't be null";
        }
        if ($this->container['auth_type'] === null) {
            $invalid_properties[] = "'auth_type' can't be null";
        }
        if ($this->container['acct_id'] === null) {
            $invalid_properties[] = "'acct_id' can't be null";
        }
        if ($this->container['groups'] === null) {
            $invalid_properties[] = "'groups' can't be null";
        }
        if ($this->container['default_group'] === null) {
            $invalid_properties[] = "'default_group' can't be null";
        }
        if ($this->container['enabled'] === null) {
            $invalid_properties[] = "'enabled' can't be null";
        }
        if ($this->container['app_type'] === null) {
            $invalid_properties[] = "'app_type' can't be null";
        }
        if ($this->container['creator'] === null) {
            $invalid_properties[] = "'creator' can't be null";
        }
        if ($this->container['created_at'] === null) {
            $invalid_properties[] = "'created_at' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['name'] === null) {
            return false;
        }
        if ($this->container['app_id'] === null) {
            return false;
        }
        if ($this->container['auth_type'] === null) {
            return false;
        }
        if ($this->container['acct_id'] === null) {
            return false;
        }
        if ($this->container['groups'] === null) {
            return false;
        }
        if ($this->container['default_group'] === null) {
            return false;
        }
        if ($this->container['enabled'] === null) {
            return false;
        }
        if ($this->container['app_type'] === null) {
            return false;
        }
        if ($this->container['creator'] === null) {
            return false;
        }
        if ($this->container['created_at'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     * @param string $name Name of the application. Application names must be unique within an account.
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets app_id
     * @return string
     */
    public function getAppId()
    {
        return $this->container['app_id'];
    }

    /**
     * Sets app_id
     * @param string $app_id Application ID uniquely identifying this application.
     * @return $this
     */
    public function setAppId($app_id)
    {
        $this->container['app_id'] = $app_id;

        return $this;
    }

    /**
     * Gets auth_type
     * @return \SdkmsClient\Model\AppAuthType
     */
    public function getAuthType()
    {
        return $this->container['auth_type'];
    }

    /**
     * Sets auth_type
     * @param \SdkmsClient\Model\AppAuthType $auth_type
     * @return $this
     */
    public function setAuthType($auth_type)
    {
        $this->container['auth_type'] = $auth_type;

        return $this;
    }

    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     * @param string $description Description of this application.
     * @return $this
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets interface
     * @return string
     */
    public function getInterface()
    {
        return $this->container['interface'];
    }

    /**
     * Sets interface
     * @param string $interface Interface used with this application (PKCS11, CNG, JCE, KMIP, etc.).
     * @return $this
     */
    public function setInterface($interface)
    {
        $this->container['interface'] = $interface;

        return $this;
    }

    /**
     * Gets acct_id
     * @return string
     */
    public function getAcctId()
    {
        return $this->container['acct_id'];
    }

    /**
     * Sets acct_id
     * @param string $acct_id The account ID of the account that this application belongs to.
     * @return $this
     */
    public function setAcctId($acct_id)
    {
        $this->container['acct_id'] = $acct_id;

        return $this;
    }

    /**
     * Gets groups
     * @return string[]
     */
    public function getGroups()
    {
        return $this->container['groups'];
    }

    /**
     * Sets groups
     * @param string[] $groups An array of Security Group IDs. The application belongs to each Security Group in this array.
     * @return $this
     */
    public function setGroups($groups)
    {
        $this->container['groups'] = $groups;

        return $this;
    }

    /**
     * Gets default_group
     * @return string
     */
    public function getDefaultGroup()
    {
        return $this->container['default_group'];
    }

    /**
     * Sets default_group
     * @param string $default_group The default group of this application. This is the group where security objects will be created by default by this application.
     * @return $this
     */
    public function setDefaultGroup($default_group)
    {
        $this->container['default_group'] = $default_group;

        return $this;
    }

    /**
     * Gets enabled
     * @return bool
     */
    public function getEnabled()
    {
        return $this->container['enabled'];
    }

    /**
     * Sets enabled
     * @param bool $enabled Whether this application is enabled.
     * @return $this
     */
    public function setEnabled($enabled)
    {
        $this->container['enabled'] = $enabled;

        return $this;
    }

    /**
     * Gets app_type
     * @return string
     */
    public function getAppType()
    {
        return $this->container['app_type'];
    }

    /**
     * Sets app_type
     * @param string $app_type The user-defined type of this application.
     * @return $this
     */
    public function setAppType($app_type)
    {
        $this->container['app_type'] = $app_type;

        return $this;
    }

    /**
     * Gets creator
     * @return \SdkmsClient\Model\CreatorType
     */
    public function getCreator()
    {
        return $this->container['creator'];
    }

    /**
     * Sets creator
     * @param \SdkmsClient\Model\CreatorType $creator
     * @return $this
     */
    public function setCreator($creator)
    {
        $this->container['creator'] = $creator;

        return $this;
    }

    /**
     * Gets created_at
     * @return string
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     * @param string $created_at When this application was created.
     * @return $this
     */
    public function setCreatedAt($created_at)
    {
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets lastused_at
     * @return string
     */
    public function getLastusedAt()
    {
        return $this->container['lastused_at'];
    }

    /**
     * Sets lastused_at
     * @param string $lastused_at When this application was last used.
     * @return $this
     */
    public function setLastusedAt($lastused_at)
    {
        $this->container['lastused_at'] = $lastused_at;

        return $this;
    }

    /**
     * Gets oauth_config
     * @return \SdkmsClient\Model\AppOauthConfig
     */
    public function getOauthConfig()
    {
        return $this->container['oauth_config'];
    }

    /**
     * Sets oauth_config
     * @param \SdkmsClient\Model\AppOauthConfig $oauth_config
     * @return $this
     */
    public function setOauthConfig($oauth_config)
    {
        $this->container['oauth_config'] = $oauth_config;

        return $this;
    }

    /**
     * Gets cert_not_after
     * @return string
     */
    public function getCertNotAfter()
    {
        return $this->container['cert_not_after'];
    }

    /**
     * Sets cert_not_after
     * @param string $cert_not_after Certificate expiration date.
     * @return $this
     */
    public function setCertNotAfter($cert_not_after)
    {
        $this->container['cert_not_after'] = $cert_not_after;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


