<?php
/**
 * AppCredential
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * AppCredential Class Doc Comment
 *
 * @category    Class
 * @description Credential for an application.
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class AppCredential implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'AppCredential';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'secret' => 'string',
        'certificate' => 'string',
        'trustedca' => '\SdkmsClient\Model\AppCredentialTrustedca',
        'googleserviceaccount' => 'object',
        'signedjwt' => '\SdkmsClient\Model\AppCredentialSignedjwt'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'secret' => null,
        'certificate' => null,
        'trustedca' => null,
        'googleserviceaccount' => null,
        'signedjwt' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'secret' => 'secret',
        'certificate' => 'certificate',
        'trustedca' => 'trustedca',
        'googleserviceaccount' => 'googleserviceaccount',
        'signedjwt' => 'signedjwt'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'secret' => 'setSecret',
        'certificate' => 'setCertificate',
        'trustedca' => 'setTrustedca',
        'googleserviceaccount' => 'setGoogleserviceaccount',
        'signedjwt' => 'setSignedjwt'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'secret' => 'getSecret',
        'certificate' => 'getCertificate',
        'trustedca' => 'getTrustedca',
        'googleserviceaccount' => 'getGoogleserviceaccount',
        'signedjwt' => 'getSignedjwt'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['secret'] = isset($data['secret']) ? $data['secret'] : null;
        $this->container['certificate'] = isset($data['certificate']) ? $data['certificate'] : null;
        $this->container['trustedca'] = isset($data['trustedca']) ? $data['trustedca'] : null;
        $this->container['googleserviceaccount'] = isset($data['googleserviceaccount']) ? $data['googleserviceaccount'] : null;
        $this->container['signedjwt'] = isset($data['signedjwt']) ? $data['signedjwt'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        return true;
    }


    /**
     * Gets secret
     * @return string
     */
    public function getSecret()
    {
        return $this->container['secret'];
    }

    /**
     * Sets secret
     * @param string $secret
     * @return $this
     */
    public function setSecret($secret)
    {
        $this->container['secret'] = $secret;

        return $this;
    }

    /**
     * Gets certificate
     * @return string
     */
    public function getCertificate()
    {
        return $this->container['certificate'];
    }

    /**
     * Sets certificate
     * @param string $certificate
     * @return $this
     */
    public function setCertificate($certificate)
    {
        $this->container['certificate'] = $certificate;

        return $this;
    }

    /**
     * Gets trustedca
     * @return \SdkmsClient\Model\AppCredentialTrustedca
     */
    public function getTrustedca()
    {
        return $this->container['trustedca'];
    }

    /**
     * Sets trustedca
     * @param \SdkmsClient\Model\AppCredentialTrustedca $trustedca
     * @return $this
     */
    public function setTrustedca($trustedca)
    {
        $this->container['trustedca'] = $trustedca;

        return $this;
    }

    /**
     * Gets googleserviceaccount
     * @return object
     */
    public function getGoogleserviceaccount()
    {
        return $this->container['googleserviceaccount'];
    }

    /**
     * Sets googleserviceaccount
     * @param object $googleserviceaccount
     * @return $this
     */
    public function setGoogleserviceaccount($googleserviceaccount)
    {
        $this->container['googleserviceaccount'] = $googleserviceaccount;

        return $this;
    }

    /**
     * Gets signedjwt
     * @return \SdkmsClient\Model\AppCredentialSignedjwt
     */
    public function getSignedjwt()
    {
        return $this->container['signedjwt'];
    }

    /**
     * Sets signedjwt
     * @param \SdkmsClient\Model\AppCredentialSignedjwt $signedjwt
     * @return $this
     */
    public function setSignedjwt($signedjwt)
    {
        $this->container['signedjwt'] = $signedjwt;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


