<?php
/**
 * ApprovalRequest
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * ApprovalRequest Class Doc Comment
 *
 * @category    Class
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class ApprovalRequest implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'ApprovalRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'request_id' => 'string',
        'requester' => '\SdkmsClient\Model\Entity',
        'created_at' => 'string',
        'acct_id' => 'string',
        'operation' => 'string',
        'method' => 'string',
        'body' => 'object',
        'approvers' => '\SdkmsClient\Model\Entity[]',
        'denier' => '\SdkmsClient\Model\Entity',
        'status' => '\SdkmsClient\Model\ApprovalStatus',
        'reviewers' => '\SdkmsClient\Model\Entity[]',
        'subjects' => '\SdkmsClient\Model\ApprovalSubject[]',
        'description' => 'string',
        'expiry' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'request_id' => null,
        'requester' => null,
        'created_at' => 'dateTime',
        'acct_id' => null,
        'operation' => null,
        'method' => null,
        'body' => null,
        'approvers' => null,
        'denier' => null,
        'status' => null,
        'reviewers' => null,
        'subjects' => null,
        'description' => null,
        'expiry' => 'dateTime'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'request_id' => 'request_id',
        'requester' => 'requester',
        'created_at' => 'created_at',
        'acct_id' => 'acct_id',
        'operation' => 'operation',
        'method' => 'method',
        'body' => 'body',
        'approvers' => 'approvers',
        'denier' => 'denier',
        'status' => 'status',
        'reviewers' => 'reviewers',
        'subjects' => 'subjects',
        'description' => 'description',
        'expiry' => 'expiry'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'request_id' => 'setRequestId',
        'requester' => 'setRequester',
        'created_at' => 'setCreatedAt',
        'acct_id' => 'setAcctId',
        'operation' => 'setOperation',
        'method' => 'setMethod',
        'body' => 'setBody',
        'approvers' => 'setApprovers',
        'denier' => 'setDenier',
        'status' => 'setStatus',
        'reviewers' => 'setReviewers',
        'subjects' => 'setSubjects',
        'description' => 'setDescription',
        'expiry' => 'setExpiry'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'request_id' => 'getRequestId',
        'requester' => 'getRequester',
        'created_at' => 'getCreatedAt',
        'acct_id' => 'getAcctId',
        'operation' => 'getOperation',
        'method' => 'getMethod',
        'body' => 'getBody',
        'approvers' => 'getApprovers',
        'denier' => 'getDenier',
        'status' => 'getStatus',
        'reviewers' => 'getReviewers',
        'subjects' => 'getSubjects',
        'description' => 'getDescription',
        'expiry' => 'getExpiry'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['request_id'] = isset($data['request_id']) ? $data['request_id'] : null;
        $this->container['requester'] = isset($data['requester']) ? $data['requester'] : null;
        $this->container['created_at'] = isset($data['created_at']) ? $data['created_at'] : null;
        $this->container['acct_id'] = isset($data['acct_id']) ? $data['acct_id'] : null;
        $this->container['operation'] = isset($data['operation']) ? $data['operation'] : null;
        $this->container['method'] = isset($data['method']) ? $data['method'] : null;
        $this->container['body'] = isset($data['body']) ? $data['body'] : null;
        $this->container['approvers'] = isset($data['approvers']) ? $data['approvers'] : null;
        $this->container['denier'] = isset($data['denier']) ? $data['denier'] : null;
        $this->container['status'] = isset($data['status']) ? $data['status'] : null;
        $this->container['reviewers'] = isset($data['reviewers']) ? $data['reviewers'] : null;
        $this->container['subjects'] = isset($data['subjects']) ? $data['subjects'] : null;
        $this->container['description'] = isset($data['description']) ? $data['description'] : null;
        $this->container['expiry'] = isset($data['expiry']) ? $data['expiry'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['request_id'] === null) {
            $invalid_properties[] = "'request_id' can't be null";
        }
        if ($this->container['requester'] === null) {
            $invalid_properties[] = "'requester' can't be null";
        }
        if ($this->container['created_at'] === null) {
            $invalid_properties[] = "'created_at' can't be null";
        }
        if ($this->container['acct_id'] === null) {
            $invalid_properties[] = "'acct_id' can't be null";
        }
        if ($this->container['operation'] === null) {
            $invalid_properties[] = "'operation' can't be null";
        }
        if ($this->container['method'] === null) {
            $invalid_properties[] = "'method' can't be null";
        }
        if ($this->container['body'] === null) {
            $invalid_properties[] = "'body' can't be null";
        }
        if ($this->container['approvers'] === null) {
            $invalid_properties[] = "'approvers' can't be null";
        }
        if ($this->container['denier'] === null) {
            $invalid_properties[] = "'denier' can't be null";
        }
        if ($this->container['status'] === null) {
            $invalid_properties[] = "'status' can't be null";
        }
        if ($this->container['reviewers'] === null) {
            $invalid_properties[] = "'reviewers' can't be null";
        }
        if ($this->container['subjects'] === null) {
            $invalid_properties[] = "'subjects' can't be null";
        }
        if ($this->container['expiry'] === null) {
            $invalid_properties[] = "'expiry' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['request_id'] === null) {
            return false;
        }
        if ($this->container['requester'] === null) {
            return false;
        }
        if ($this->container['created_at'] === null) {
            return false;
        }
        if ($this->container['acct_id'] === null) {
            return false;
        }
        if ($this->container['operation'] === null) {
            return false;
        }
        if ($this->container['method'] === null) {
            return false;
        }
        if ($this->container['body'] === null) {
            return false;
        }
        if ($this->container['approvers'] === null) {
            return false;
        }
        if ($this->container['denier'] === null) {
            return false;
        }
        if ($this->container['status'] === null) {
            return false;
        }
        if ($this->container['reviewers'] === null) {
            return false;
        }
        if ($this->container['subjects'] === null) {
            return false;
        }
        if ($this->container['expiry'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets request_id
     * @return string
     */
    public function getRequestId()
    {
        return $this->container['request_id'];
    }

    /**
     * Sets request_id
     * @param string $request_id UUID uniquely identifying this approval request.
     * @return $this
     */
    public function setRequestId($request_id)
    {
        $this->container['request_id'] = $request_id;

        return $this;
    }

    /**
     * Gets requester
     * @return \SdkmsClient\Model\Entity
     */
    public function getRequester()
    {
        return $this->container['requester'];
    }

    /**
     * Sets requester
     * @param \SdkmsClient\Model\Entity $requester
     * @return $this
     */
    public function setRequester($requester)
    {
        $this->container['requester'] = $requester;

        return $this;
    }

    /**
     * Gets created_at
     * @return string
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     * @param string $created_at When this approval request was created.
     * @return $this
     */
    public function setCreatedAt($created_at)
    {
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets acct_id
     * @return string
     */
    public function getAcctId()
    {
        return $this->container['acct_id'];
    }

    /**
     * Sets acct_id
     * @param string $acct_id The account ID of the account that this approval request belongs to.
     * @return $this
     */
    public function setAcctId($acct_id)
    {
        $this->container['acct_id'] = $acct_id;

        return $this;
    }

    /**
     * Gets operation
     * @return string
     */
    public function getOperation()
    {
        return $this->container['operation'];
    }

    /**
     * Sets operation
     * @param string $operation Operation URL path, e.g. `/crypto/v1/keys`, `/crypto/v1/groups/<id>`.
     * @return $this
     */
    public function setOperation($operation)
    {
        $this->container['operation'] = $operation;

        return $this;
    }

    /**
     * Gets method
     * @return string
     */
    public function getMethod()
    {
        return $this->container['method'];
    }

    /**
     * Sets method
     * @param string $method Method for the operation: POST, PATCH, PUT, DELETE, or GET. Default is POST.
     * @return $this
     */
    public function setMethod($method)
    {
        $this->container['method'] = $method;

        return $this;
    }

    /**
     * Gets body
     * @return object
     */
    public function getBody()
    {
        return $this->container['body'];
    }

    /**
     * Sets body
     * @param object $body
     * @return $this
     */
    public function setBody($body)
    {
        $this->container['body'] = $body;

        return $this;
    }

    /**
     * Gets approvers
     * @return \SdkmsClient\Model\Entity[]
     */
    public function getApprovers()
    {
        return $this->container['approvers'];
    }

    /**
     * Sets approvers
     * @param \SdkmsClient\Model\Entity[] $approvers
     * @return $this
     */
    public function setApprovers($approvers)
    {
        $this->container['approvers'] = $approvers;

        return $this;
    }

    /**
     * Gets denier
     * @return \SdkmsClient\Model\Entity
     */
    public function getDenier()
    {
        return $this->container['denier'];
    }

    /**
     * Sets denier
     * @param \SdkmsClient\Model\Entity $denier
     * @return $this
     */
    public function setDenier($denier)
    {
        $this->container['denier'] = $denier;

        return $this;
    }

    /**
     * Gets status
     * @return \SdkmsClient\Model\ApprovalStatus
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     * @param \SdkmsClient\Model\ApprovalStatus $status
     * @return $this
     */
    public function setStatus($status)
    {
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets reviewers
     * @return \SdkmsClient\Model\Entity[]
     */
    public function getReviewers()
    {
        return $this->container['reviewers'];
    }

    /**
     * Sets reviewers
     * @param \SdkmsClient\Model\Entity[] $reviewers
     * @return $this
     */
    public function setReviewers($reviewers)
    {
        $this->container['reviewers'] = $reviewers;

        return $this;
    }

    /**
     * Gets subjects
     * @return \SdkmsClient\Model\ApprovalSubject[]
     */
    public function getSubjects()
    {
        return $this->container['subjects'];
    }

    /**
     * Sets subjects
     * @param \SdkmsClient\Model\ApprovalSubject[] $subjects
     * @return $this
     */
    public function setSubjects($subjects)
    {
        $this->container['subjects'] = $subjects;

        return $this;
    }

    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     * @param string $description Optional comment about the approval request for the reviewer.
     * @return $this
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets expiry
     * @return string
     */
    public function getExpiry()
    {
        return $this->container['expiry'];
    }

    /**
     * Sets expiry
     * @param string $expiry When this approval request expires.
     * @return $this
     */
    public function setExpiry($expiry)
    {
        $this->container['expiry'] = $expiry;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


