<?php
/**
 * AuditLogResponse
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * AuditLogResponse Class Doc Comment
 *
 * @category    Class
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class AuditLogResponse implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'AuditLogResponse';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'action_type' => 'string',
        'actor_type' => 'string',
        'message' => 'string',
        'severity' => 'string',
        'time' => 'string',
        'object_id' => 'string',
        'actor_id' => 'string',
        'acct_id' => 'string',
        'group_ids' => 'string[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'action_type' => null,
        'actor_type' => null,
        'message' => null,
        'severity' => null,
        'time' => null,
        'object_id' => null,
        'actor_id' => null,
        'acct_id' => null,
        'group_ids' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'action_type' => 'action_type',
        'actor_type' => 'actor_type',
        'message' => 'message',
        'severity' => 'severity',
        'time' => 'time',
        'object_id' => 'object_id',
        'actor_id' => 'actor_id',
        'acct_id' => 'acct_id',
        'group_ids' => 'group_ids'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'action_type' => 'setActionType',
        'actor_type' => 'setActorType',
        'message' => 'setMessage',
        'severity' => 'setSeverity',
        'time' => 'setTime',
        'object_id' => 'setObjectId',
        'actor_id' => 'setActorId',
        'acct_id' => 'setAcctId',
        'group_ids' => 'setGroupIds'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'action_type' => 'getActionType',
        'actor_type' => 'getActorType',
        'message' => 'getMessage',
        'severity' => 'getSeverity',
        'time' => 'getTime',
        'object_id' => 'getObjectId',
        'actor_id' => 'getActorId',
        'acct_id' => 'getAcctId',
        'group_ids' => 'getGroupIds'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['action_type'] = isset($data['action_type']) ? $data['action_type'] : null;
        $this->container['actor_type'] = isset($data['actor_type']) ? $data['actor_type'] : null;
        $this->container['message'] = isset($data['message']) ? $data['message'] : null;
        $this->container['severity'] = isset($data['severity']) ? $data['severity'] : null;
        $this->container['time'] = isset($data['time']) ? $data['time'] : null;
        $this->container['object_id'] = isset($data['object_id']) ? $data['object_id'] : null;
        $this->container['actor_id'] = isset($data['actor_id']) ? $data['actor_id'] : null;
        $this->container['acct_id'] = isset($data['acct_id']) ? $data['acct_id'] : null;
        $this->container['group_ids'] = isset($data['group_ids']) ? $data['group_ids'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['action_type'] === null) {
            $invalid_properties[] = "'action_type' can't be null";
        }
        if ($this->container['actor_type'] === null) {
            $invalid_properties[] = "'actor_type' can't be null";
        }
        if ($this->container['message'] === null) {
            $invalid_properties[] = "'message' can't be null";
        }
        if ($this->container['severity'] === null) {
            $invalid_properties[] = "'severity' can't be null";
        }
        if ($this->container['time'] === null) {
            $invalid_properties[] = "'time' can't be null";
        }
        if ($this->container['object_id'] === null) {
            $invalid_properties[] = "'object_id' can't be null";
        }
        if ($this->container['actor_id'] === null) {
            $invalid_properties[] = "'actor_id' can't be null";
        }
        if ($this->container['acct_id'] === null) {
            $invalid_properties[] = "'acct_id' can't be null";
        }
        if ($this->container['group_ids'] === null) {
            $invalid_properties[] = "'group_ids' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['action_type'] === null) {
            return false;
        }
        if ($this->container['actor_type'] === null) {
            return false;
        }
        if ($this->container['message'] === null) {
            return false;
        }
        if ($this->container['severity'] === null) {
            return false;
        }
        if ($this->container['time'] === null) {
            return false;
        }
        if ($this->container['object_id'] === null) {
            return false;
        }
        if ($this->container['actor_id'] === null) {
            return false;
        }
        if ($this->container['acct_id'] === null) {
            return false;
        }
        if ($this->container['group_ids'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets action_type
     * @return string
     */
    public function getActionType()
    {
        return $this->container['action_type'];
    }

    /**
     * Sets action_type
     * @param string $action_type Type of action performed.
     * @return $this
     */
    public function setActionType($action_type)
    {
        $this->container['action_type'] = $action_type;

        return $this;
    }

    /**
     * Gets actor_type
     * @return string
     */
    public function getActorType()
    {
        return $this->container['actor_type'];
    }

    /**
     * Sets actor_type
     * @param string $actor_type Type of entity performing action.
     * @return $this
     */
    public function setActorType($actor_type)
    {
        $this->container['actor_type'] = $actor_type;

        return $this;
    }

    /**
     * Gets message
     * @return string
     */
    public function getMessage()
    {
        return $this->container['message'];
    }

    /**
     * Sets message
     * @param string $message Audit log message.
     * @return $this
     */
    public function setMessage($message)
    {
        $this->container['message'] = $message;

        return $this;
    }

    /**
     * Gets severity
     * @return string
     */
    public function getSeverity()
    {
        return $this->container['severity'];
    }

    /**
     * Sets severity
     * @param string $severity Severity of audit log message.
     * @return $this
     */
    public function setSeverity($severity)
    {
        $this->container['severity'] = $severity;

        return $this;
    }

    /**
     * Gets time
     * @return string
     */
    public function getTime()
    {
        return $this->container['time'];
    }

    /**
     * Sets time
     * @param string $time Time that action occurred.
     * @return $this
     */
    public function setTime($time)
    {
        $this->container['time'] = $time;

        return $this;
    }

    /**
     * Gets object_id
     * @return string
     */
    public function getObjectId()
    {
        return $this->container['object_id'];
    }

    /**
     * Sets object_id
     * @param string $object_id ID of object acted upon.
     * @return $this
     */
    public function setObjectId($object_id)
    {
        $this->container['object_id'] = $object_id;

        return $this;
    }

    /**
     * Gets actor_id
     * @return string
     */
    public function getActorId()
    {
        return $this->container['actor_id'];
    }

    /**
     * Sets actor_id
     * @param string $actor_id ID of entity performing action.
     * @return $this
     */
    public function setActorId($actor_id)
    {
        $this->container['actor_id'] = $actor_id;

        return $this;
    }

    /**
     * Gets acct_id
     * @return string
     */
    public function getAcctId()
    {
        return $this->container['acct_id'];
    }

    /**
     * Sets acct_id
     * @param string $acct_id Account ID of the account this audit log applies to.
     * @return $this
     */
    public function setAcctId($acct_id)
    {
        $this->container['acct_id'] = $acct_id;

        return $this;
    }

    /**
     * Gets group_ids
     * @return string[]
     */
    public function getGroupIds()
    {
        return $this->container['group_ids'];
    }

    /**
     * Sets group_ids
     * @param string[] $group_ids
     * @return $this
     */
    public function setGroupIds($group_ids)
    {
        $this->container['group_ids'] = $group_ids;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


