<?php
/**
 * CipherMode
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

/**
 * CipherMode Class Doc Comment
 *
 * @category    Class
 * @description Type of cipher mode, required for symmetric key algorithms.
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class CipherMode
{
    /**
     * Possible values of this enum
     */
    const ECB = 'ECB';
    const CBC = 'CBC';
    const CBCNOPAD = 'CBCNOPAD';
    const CFB = 'CFB';
    const OFB = 'OFB';
    const CTR = 'CTR';
    const GCM = 'GCM';
    const CCM = 'CCM';
    const KW = 'KW';
    const KWP = 'KWP';
    
    /**
     * Gets allowable values of the enum
     * @return string[]
     */
    public static function getAllowableEnumValues()
    {
        return [
            self::ECB,
            self::CBC,
            self::CBCNOPAD,
            self::CFB,
            self::OFB,
            self::CTR,
            self::GCM,
            self::CCM,
            self::KW,
            self::KWP,
        ];
    }
}


