<?php
/**
 * CryptMode
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

/**
 * CryptMode Class Doc Comment
 *
 * @category    Class
 * @description &#x60;CipherMode&#x60; or &#x60;RsaEncryptionPadding&#x60;, depending on the encryption algorithm
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class CryptMode
{
    /**
     * Possible values of this enum
     */
    const ECB = 'ECB';
    const CBC = 'CBC';
    const CBCNOPAD = 'CBCNOPAD';
    const CFB = 'CFB';
    const CTR = 'CTR';
    const OFB = 'OFB';
    const GCM = 'GCM';
    const CCM = 'CCM';
    const PKCS1_V15 = 'PKCS1_V15';
    const OAEP_MGF1_SHA1 = 'OAEP_MGF1_SHA1';
    const OAEP_MGF1_SHA256 = 'OAEP_MGF1_SHA256';
    const OAEP_MGF1_SHA384 = 'OAEP_MGF1_SHA384';
    const OAEP_MGF1_SHA512 = 'OAEP_MGF1_SHA512';
    const FPE = 'FPE';
    const KW = 'KW';
    const KWP = 'KWP';
    
    /**
     * Gets allowable values of the enum
     * @return string[]
     */
    public static function getAllowableEnumValues()
    {
        return [
            self::ECB,
            self::CBC,
            self::CBCNOPAD,
            self::CFB,
            self::CTR,
            self::OFB,
            self::GCM,
            self::CCM,
            self::PKCS1_V15,
            self::OAEP_MGF1_SHA1,
            self::OAEP_MGF1_SHA256,
            self::OAEP_MGF1_SHA384,
            self::OAEP_MGF1_SHA512,
            self::FPE,
            self::KW,
            self::KWP,
        ];
    }
}


