<?php
/**
 * FpeCompoundPart
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * FpeCompoundPart Class Doc Comment
 *
 * @category    Class
 * @description Structure of a compound portion of a complex tokenization data type, itself composed of smaller parts. Note that there are three variants here:  - Or -- representing an OR of multiple structures  - Concat -- representing a concatenation of multiple structures  - Multiple -- representing a part possibly repeated multiple times, where the part to be repeated is under the &#x60;multiple&#x60; field  These three variants correspond to the &#x60;or&#x60;, &#x60;concat&#x60;, and &#x60;multiple&#x60; fields, respectively; one of these fields must be specified. It is an error to try to specify more than one variant (e.g., having both an &#x60;or&#x60; and a &#x60;concat&#x60; field).  ***Implementation note: for Or variants, the parser will go in the order of the choices (see description of the &#x60;or&#x60; field below), and for Multiple variants, the parser will try to (locally) match as many repetitions as possible. (See the description of &#x60;FpeDataPart&#x60; for more information about why this matters.)***
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class FpeCompoundPart implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'FpeCompoundPart';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'or' => '\SdkmsClient\Model\FpeDataPart[]',
        'concat' => '\SdkmsClient\Model\FpeDataPart[]',
        'multiple' => '\SdkmsClient\Model\FpeDataPart',
        'min_repetitions' => 'int',
        'max_repetitions' => 'int',
        'constraints' => '\SdkmsClient\Model\FpeConstraints',
        'preserve' => 'bool',
        'mask' => 'bool',
        'min_length' => 'int',
        'max_length' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'or' => null,
        'concat' => null,
        'multiple' => null,
        'min_repetitions' => null,
        'max_repetitions' => null,
        'constraints' => null,
        'preserve' => null,
        'mask' => null,
        'min_length' => 'int32',
        'max_length' => 'int32'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'or' => 'or',
        'concat' => 'concat',
        'multiple' => 'multiple',
        'min_repetitions' => 'min_repetitions',
        'max_repetitions' => 'max_repetitions',
        'constraints' => 'constraints',
        'preserve' => 'preserve',
        'mask' => 'mask',
        'min_length' => 'min_length',
        'max_length' => 'max_length'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'or' => 'setOr',
        'concat' => 'setConcat',
        'multiple' => 'setMultiple',
        'min_repetitions' => 'setMinRepetitions',
        'max_repetitions' => 'setMaxRepetitions',
        'constraints' => 'setConstraints',
        'preserve' => 'setPreserve',
        'mask' => 'setMask',
        'min_length' => 'setMinLength',
        'max_length' => 'setMaxLength'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'or' => 'getOr',
        'concat' => 'getConcat',
        'multiple' => 'getMultiple',
        'min_repetitions' => 'getMinRepetitions',
        'max_repetitions' => 'getMaxRepetitions',
        'constraints' => 'getConstraints',
        'preserve' => 'getPreserve',
        'mask' => 'getMask',
        'min_length' => 'getMinLength',
        'max_length' => 'getMaxLength'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['or'] = isset($data['or']) ? $data['or'] : null;
        $this->container['concat'] = isset($data['concat']) ? $data['concat'] : null;
        $this->container['multiple'] = isset($data['multiple']) ? $data['multiple'] : null;
        $this->container['min_repetitions'] = isset($data['min_repetitions']) ? $data['min_repetitions'] : null;
        $this->container['max_repetitions'] = isset($data['max_repetitions']) ? $data['max_repetitions'] : null;
        $this->container['constraints'] = isset($data['constraints']) ? $data['constraints'] : null;
        $this->container['preserve'] = isset($data['preserve']) ? $data['preserve'] : null;
        $this->container['mask'] = isset($data['mask']) ? $data['mask'] : null;
        $this->container['min_length'] = isset($data['min_length']) ? $data['min_length'] : null;
        $this->container['max_length'] = isset($data['max_length']) ? $data['max_length'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        return true;
    }


    /**
     * Gets or
     * @return \SdkmsClient\Model\FpeDataPart[]
     */
    public function getOr()
    {
        return $this->container['or'];
    }

    /**
     * Sets or
     * @param \SdkmsClient\Model\FpeDataPart[] $or Represents an OR of multiple structures. This cannot be specified alongside the `concat` or `multiple` fields.  ***Implementation note: the order of the choices matters, as the parser will pick the first structure that matches. (The parser is locally \"greedy\"; see the description of `FpeDataPart` for more information about why this matters.)***
     * @return $this
     */
    public function setOr($or)
    {
        $this->container['or'] = $or;

        return $this;
    }

    /**
     * Gets concat
     * @return \SdkmsClient\Model\FpeDataPart[]
     */
    public function getConcat()
    {
        return $this->container['concat'];
    }

    /**
     * Sets concat
     * @param \SdkmsClient\Model\FpeDataPart[] $concat Represents a concatentation of multiple structures (in a particular order). This cannot be specified alongside the `or` or `multiple` fields.
     * @return $this
     */
    public function setConcat($concat)
    {
        $this->container['concat'] = $concat;

        return $this;
    }

    /**
     * Gets multiple
     * @return \SdkmsClient\Model\FpeDataPart
     */
    public function getMultiple()
    {
        return $this->container['multiple'];
    }

    /**
     * Sets multiple
     * @param \SdkmsClient\Model\FpeDataPart $multiple
     * @return $this
     */
    public function setMultiple($multiple)
    {
        $this->container['multiple'] = $multiple;

        return $this;
    }

    /**
     * Gets min_repetitions
     * @return int
     */
    public function getMinRepetitions()
    {
        return $this->container['min_repetitions'];
    }

    /**
     * Sets min_repetitions
     * @param int $min_repetitions The minimum number of times the subpart can be repeated. This field should only be used if the `multiple` field is being used.
     * @return $this
     */
    public function setMinRepetitions($min_repetitions)
    {
        $this->container['min_repetitions'] = $min_repetitions;

        return $this;
    }

    /**
     * Gets max_repetitions
     * @return int
     */
    public function getMaxRepetitions()
    {
        return $this->container['max_repetitions'];
    }

    /**
     * Sets max_repetitions
     * @param int $max_repetitions The maximum number of times the subpart can be repeated. This field should only be used if the `multiple` field is being used.
     * @return $this
     */
    public function setMaxRepetitions($max_repetitions)
    {
        $this->container['max_repetitions'] = $max_repetitions;

        return $this;
    }

    /**
     * Gets constraints
     * @return \SdkmsClient\Model\FpeConstraints
     */
    public function getConstraints()
    {
        return $this->container['constraints'];
    }

    /**
     * Sets constraints
     * @param \SdkmsClient\Model\FpeConstraints $constraints
     * @return $this
     */
    public function setConstraints($constraints)
    {
        $this->container['constraints'] = $constraints;

        return $this;
    }

    /**
     * Gets preserve
     * @return bool
     */
    public function getPreserve()
    {
        return $this->container['preserve'];
    }

    /**
     * Sets preserve
     * @param bool $preserve Whether the entire part should be preserved as-is (i.e., not tokenized). If this is set, any descendant subparts cannot contain any preserve-related fields set.
     * @return $this
     */
    public function setPreserve($preserve)
    {
        $this->container['preserve'] = $preserve;

        return $this;
    }

    /**
     * Gets mask
     * @return bool
     */
    public function getMask()
    {
        return $this->container['mask'];
    }

    /**
     * Sets mask
     * @param bool $mask Whether the entire part should be masked when doing masked decryption. If this is set, any descendant subparts cannot contain any mask-related fields set.
     * @return $this
     */
    public function setMask($mask)
    {
        $this->container['mask'] = $mask;

        return $this;
    }

    /**
     * Gets min_length
     * @return int
     */
    public function getMinLength()
    {
        return $this->container['min_length'];
    }

    /**
     * Sets min_length
     * @param int $min_length The minimum allowed length for this part (in chars).
     * @return $this
     */
    public function setMinLength($min_length)
    {
        $this->container['min_length'] = $min_length;

        return $this;
    }

    /**
     * Gets max_length
     * @return int
     */
    public function getMaxLength()
    {
        return $this->container['max_length'];
    }

    /**
     * Sets max_length
     * @param int $max_length The minimum allowed length for this part (in chars).
     * @return $this
     */
    public function setMaxLength($max_length)
    {
        $this->container['max_length'] = $max_length;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


