<?php
/**
 * FpeConstraints
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * FpeConstraints Class Doc Comment
 *
 * @category    Class
 * @description Constraints on a portion of a complex tokenization data type.
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class FpeConstraints implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'FpeConstraints';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'luhn_check' => 'bool',
        'num_gt' => 'int',
        'num_lt' => 'int',
        'num_ne' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'luhn_check' => null,
        'num_gt' => null,
        'num_lt' => null,
        'num_ne' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'luhn_check' => 'luhn_check',
        'num_gt' => 'num_gt',
        'num_lt' => 'num_lt',
        'num_ne' => 'num_ne'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'luhn_check' => 'setLuhnCheck',
        'num_gt' => 'setNumGt',
        'num_lt' => 'setNumLt',
        'num_ne' => 'setNumNe'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'luhn_check' => 'getLuhnCheck',
        'num_gt' => 'getNumGt',
        'num_lt' => 'getNumLt',
        'num_ne' => 'getNumNe'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['luhn_check'] = isset($data['luhn_check']) ? $data['luhn_check'] : null;
        $this->container['num_gt'] = isset($data['num_gt']) ? $data['num_gt'] : null;
        $this->container['num_lt'] = isset($data['num_lt']) ? $data['num_lt'] : null;
        $this->container['num_ne'] = isset($data['num_ne']) ? $data['num_ne'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        return true;
    }


    /**
     * Gets luhn_check
     * @return bool
     */
    public function getLuhnCheck()
    {
        return $this->container['luhn_check'];
    }

    /**
     * Sets luhn_check
     * @param bool $luhn_check Whether the token should satisfy the Luhn checksum. It is an error to apply this constraint to non-numeric parts, or for an encrypted part to be under more than one Luhn check constraint. Also, if an encrypted part has a Luhn check constraint applied to it and may contain at least one digit that is not preserved, it must not specify any other constraints.
     * @return $this
     */
    public function setLuhnCheck($luhn_check)
    {
        $this->container['luhn_check'] = $luhn_check;

        return $this;
    }

    /**
     * Gets num_gt
     * @return int
     */
    public function getNumGt()
    {
        return $this->container['num_gt'];
    }

    /**
     * Sets num_gt
     * @param int $num_gt Number that the token part should be greater than. This constraint can only be specified on (non-compound) numeric encrypted parts that are guaranteed to preserve either everything or nothing at all.
     * @return $this
     */
    public function setNumGt($num_gt)
    {
        $this->container['num_gt'] = $num_gt;

        return $this;
    }

    /**
     * Gets num_lt
     * @return int
     */
    public function getNumLt()
    {
        return $this->container['num_lt'];
    }

    /**
     * Sets num_lt
     * @param int $num_lt Number that the token part should be smaller than. This constraint can only be specified on (non-compound) numeric encrypted parts that are guaranteed to preserve either everything or nothing at all.
     * @return $this
     */
    public function setNumLt($num_lt)
    {
        $this->container['num_lt'] = $num_lt;

        return $this;
    }

    /**
     * Gets num_ne
     * @return int
     */
    public function getNumNe()
    {
        return $this->container['num_ne'];
    }

    /**
     * Sets num_ne
     * @param int $num_ne Numbers that the token part should not be equal to. It is an error to apply this constraint to non-numeric parts.
     * @return $this
     */
    public function setNumNe($num_ne)
    {
        $this->container['num_ne'] = $num_ne;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


