<?php
/**
 * FpeDate
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * FpeDate Class Doc Comment
 *
 * @category    Class
 * @description A structure for indicating that a token part represents a date. The part should be a concatenation that matches one of the three variants below:  - DayMonthYear date -- contains a Day part and a Month part; this corresponds with the &#x60;dmy_date&#x60; field  - MonthYear date -- contains a Month part and a Year part; this corresponds with the &#x60;month_day_date&#x60; field  - MonthDay date -- contains a Day part, a Month part, and a Year part; this corresponds with the &#x60;month_year_date&#x60; field  (with this constraint applying to those subparts). Notice how each variant above corresponds with a particular field; using the wrong field, or multiple fields, is an error. The individual Month, Day, and/or Year parts that comprise the date cannot appear under Or or the Multiple compound part descendants of the overall Date part (i.e., when applying the date constraint, the \&quot;paths\&quot; from the Date part to the Month, Day, and/or Year parts can only \&quot;go through\&quot; concatenations, and not \&quot;through\&quot; Or or Multiple parts). Those parts also have additional restrictions on how they may be preserved; the exact rules are as such:  - A DayMonthYear date may preserve its Year part, and may preserve both its Month and Day parts at the same time. (The Day    part cannot be preserved if the Month part is not, and vice versa.)  - A MonthDay date cannot preserve only its Month part or only its Day part.  - A MonthYear date may preserve its Year part, but cannot preserve its Month part by itself.   It is an error to \&quot;share\&quot; Day, Month, or Year parts across multiple dates.
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class FpeDate implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'FpeDate';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'dmy_date' => '\SdkmsClient\Model\FpeDateWithBounds',
        'month_day_date' => '\SdkmsClient\Model\FpeDateWithBounds',
        'month_year_date' => '\SdkmsClient\Model\FpeDateWithBounds'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'dmy_date' => null,
        'month_day_date' => null,
        'month_year_date' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'dmy_date' => 'dmy_date',
        'month_day_date' => 'month_day_date',
        'month_year_date' => 'month_year_date'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'dmy_date' => 'setDmyDate',
        'month_day_date' => 'setMonthDayDate',
        'month_year_date' => 'setMonthYearDate'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'dmy_date' => 'getDmyDate',
        'month_day_date' => 'getMonthDayDate',
        'month_year_date' => 'getMonthYearDate'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['dmy_date'] = isset($data['dmy_date']) ? $data['dmy_date'] : null;
        $this->container['month_day_date'] = isset($data['month_day_date']) ? $data['month_day_date'] : null;
        $this->container['month_year_date'] = isset($data['month_year_date']) ? $data['month_year_date'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        return true;
    }


    /**
     * Gets dmy_date
     * @return \SdkmsClient\Model\FpeDateWithBounds
     */
    public function getDmyDate()
    {
        return $this->container['dmy_date'];
    }

    /**
     * Sets dmy_date
     * @param \SdkmsClient\Model\FpeDateWithBounds $dmy_date
     * @return $this
     */
    public function setDmyDate($dmy_date)
    {
        $this->container['dmy_date'] = $dmy_date;

        return $this;
    }

    /**
     * Gets month_day_date
     * @return \SdkmsClient\Model\FpeDateWithBounds
     */
    public function getMonthDayDate()
    {
        return $this->container['month_day_date'];
    }

    /**
     * Sets month_day_date
     * @param \SdkmsClient\Model\FpeDateWithBounds $month_day_date
     * @return $this
     */
    public function setMonthDayDate($month_day_date)
    {
        $this->container['month_day_date'] = $month_day_date;

        return $this;
    }

    /**
     * Gets month_year_date
     * @return \SdkmsClient\Model\FpeDateWithBounds
     */
    public function getMonthYearDate()
    {
        return $this->container['month_year_date'];
    }

    /**
     * Sets month_year_date
     * @param \SdkmsClient\Model\FpeDateWithBounds $month_year_date
     * @return $this
     */
    public function setMonthYearDate($month_year_date)
    {
        $this->container['month_year_date'] = $month_year_date;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


