<?php
/**
 * GroupRequest
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * GroupRequest Class Doc Comment
 *
 * @category    Class
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class GroupRequest implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'GroupRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'name' => 'string',
        'description' => 'string',
        'acct_id' => 'string',
        'add_hmg' => '\SdkmsClient\Model\HmgConfig[]',
        'mod_hmg' => 'map[string,\SdkmsClient\Model\HmgConfig]',
        'del_hmg' => 'string[]',
        'key_undo_policy' => '\SdkmsClient\Model\KeyUndoPolicy'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'name' => null,
        'description' => null,
        'acct_id' => null,
        'add_hmg' => null,
        'mod_hmg' => null,
        'del_hmg' => null,
        'key_undo_policy' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'name' => 'name',
        'description' => 'description',
        'acct_id' => 'acct_id',
        'add_hmg' => 'add_hmg',
        'mod_hmg' => 'mod_hmg',
        'del_hmg' => 'del_hmg',
        'key_undo_policy' => 'key_undo_policy'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'name' => 'setName',
        'description' => 'setDescription',
        'acct_id' => 'setAcctId',
        'add_hmg' => 'setAddHmg',
        'mod_hmg' => 'setModHmg',
        'del_hmg' => 'setDelHmg',
        'key_undo_policy' => 'setKeyUndoPolicy'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'name' => 'getName',
        'description' => 'getDescription',
        'acct_id' => 'getAcctId',
        'add_hmg' => 'getAddHmg',
        'mod_hmg' => 'getModHmg',
        'del_hmg' => 'getDelHmg',
        'key_undo_policy' => 'getKeyUndoPolicy'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['description'] = isset($data['description']) ? $data['description'] : null;
        $this->container['acct_id'] = isset($data['acct_id']) ? $data['acct_id'] : null;
        $this->container['add_hmg'] = isset($data['add_hmg']) ? $data['add_hmg'] : null;
        $this->container['mod_hmg'] = isset($data['mod_hmg']) ? $data['mod_hmg'] : null;
        $this->container['del_hmg'] = isset($data['del_hmg']) ? $data['del_hmg'] : null;
        $this->container['key_undo_policy'] = isset($data['key_undo_policy']) ? $data['key_undo_policy'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['name'] === null) {
            $invalid_properties[] = "'name' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['name'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     * @param string $name Name of the group. Group names must be unique within an account.
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     * @param string $description Description of the group.
     * @return $this
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets acct_id
     * @return string
     */
    public function getAcctId()
    {
        return $this->container['acct_id'];
    }

    /**
     * Sets acct_id
     * @param string $acct_id Account ID of the account the new group will belong to.
     * @return $this
     */
    public function setAcctId($acct_id)
    {
        $this->container['acct_id'] = $acct_id;

        return $this;
    }

    /**
     * Gets add_hmg
     * @return \SdkmsClient\Model\HmgConfig[]
     */
    public function getAddHmg()
    {
        return $this->container['add_hmg'];
    }

    /**
     * Sets add_hmg
     * @param \SdkmsClient\Model\HmgConfig[] $add_hmg List of HmgConfig objects to add
     * @return $this
     */
    public function setAddHmg($add_hmg)
    {
        $this->container['add_hmg'] = $add_hmg;

        return $this;
    }

    /**
     * Gets mod_hmg
     * @return map[string,\SdkmsClient\Model\HmgConfig]
     */
    public function getModHmg()
    {
        return $this->container['mod_hmg'];
    }

    /**
     * Sets mod_hmg
     * @param map[string,\SdkmsClient\Model\HmgConfig] $mod_hmg Map from UUIDs to HmgConfig objects to update
     * @return $this
     */
    public function setModHmg($mod_hmg)
    {
        $this->container['mod_hmg'] = $mod_hmg;

        return $this;
    }

    /**
     * Gets del_hmg
     * @return string[]
     */
    public function getDelHmg()
    {
        return $this->container['del_hmg'];
    }

    /**
     * Sets del_hmg
     * @param string[] $del_hmg List of HmgConfig UUIDs to delete
     * @return $this
     */
    public function setDelHmg($del_hmg)
    {
        $this->container['del_hmg'] = $del_hmg;

        return $this;
    }

    /**
     * Gets key_undo_policy
     * @return \SdkmsClient\Model\KeyUndoPolicy
     */
    public function getKeyUndoPolicy()
    {
        return $this->container['key_undo_policy'];
    }

    /**
     * Sets key_undo_policy
     * @param \SdkmsClient\Model\KeyUndoPolicy $key_undo_policy
     * @return $this
     */
    public function setKeyUndoPolicy($key_undo_policy)
    {
        $this->container['key_undo_policy'] = $key_undo_policy;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


