<?php
/**
 * KeyObject
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * KeyObject Class Doc Comment
 *
 * @category    Class
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class KeyObject implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'KeyObject';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'name' => 'string',
        'description' => 'string',
        'key_size' => 'int',
        'elliptic_curve' => '\SdkmsClient\Model\EllipticCurve',
        'acct_id' => 'string',
        'group_id' => 'string',
        'creator' => '\SdkmsClient\Model\CreatorType',
        'kid' => 'string',
        'obj_type' => '\SdkmsClient\Model\ObjectType',
        'key_ops' => '\SdkmsClient\Model\KeyOperations[]',
        'custom_metadata' => 'map[string,string]',
        'origin' => '\SdkmsClient\Model\ObjectOrigin',
        'pub_key' => 'string',
        'value' => 'string',
        'enabled' => 'bool',
        'compliant_with_policies' => 'bool',
        'created_at' => 'string',
        'lastused_at' => 'string',
        'transient_key' => 'string',
        'never_exportable' => 'bool',
        'rsa' => '\SdkmsClient\Model\RsaOptions',
        'kcv' => 'string',
        'state' => '\SdkmsClient\Model\KeyObjectState',
        'history' => '\SdkmsClient\Model\HistoryItem[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'name' => null,
        'description' => null,
        'key_size' => 'int32',
        'elliptic_curve' => null,
        'acct_id' => null,
        'group_id' => null,
        'creator' => null,
        'kid' => null,
        'obj_type' => null,
        'key_ops' => null,
        'custom_metadata' => null,
        'origin' => null,
        'pub_key' => 'byte',
        'value' => 'byte',
        'enabled' => null,
        'compliant_with_policies' => null,
        'created_at' => 'dateTime',
        'lastused_at' => 'dateTime',
        'transient_key' => null,
        'never_exportable' => null,
        'rsa' => null,
        'kcv' => null,
        'state' => null,
        'history' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'name' => 'name',
        'description' => 'description',
        'key_size' => 'key_size',
        'elliptic_curve' => 'elliptic_curve',
        'acct_id' => 'acct_id',
        'group_id' => 'group_id',
        'creator' => 'creator',
        'kid' => 'kid',
        'obj_type' => 'obj_type',
        'key_ops' => 'key_ops',
        'custom_metadata' => 'custom_metadata',
        'origin' => 'origin',
        'pub_key' => 'pub_key',
        'value' => 'value',
        'enabled' => 'enabled',
        'compliant_with_policies' => 'compliant_with_policies',
        'created_at' => 'created_at',
        'lastused_at' => 'lastused_at',
        'transient_key' => 'transient_key',
        'never_exportable' => 'never_exportable',
        'rsa' => 'rsa',
        'kcv' => 'kcv',
        'state' => 'state',
        'history' => 'history'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'name' => 'setName',
        'description' => 'setDescription',
        'key_size' => 'setKeySize',
        'elliptic_curve' => 'setEllipticCurve',
        'acct_id' => 'setAcctId',
        'group_id' => 'setGroupId',
        'creator' => 'setCreator',
        'kid' => 'setKid',
        'obj_type' => 'setObjType',
        'key_ops' => 'setKeyOps',
        'custom_metadata' => 'setCustomMetadata',
        'origin' => 'setOrigin',
        'pub_key' => 'setPubKey',
        'value' => 'setValue',
        'enabled' => 'setEnabled',
        'compliant_with_policies' => 'setCompliantWithPolicies',
        'created_at' => 'setCreatedAt',
        'lastused_at' => 'setLastusedAt',
        'transient_key' => 'setTransientKey',
        'never_exportable' => 'setNeverExportable',
        'rsa' => 'setRsa',
        'kcv' => 'setKcv',
        'state' => 'setState',
        'history' => 'setHistory'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'name' => 'getName',
        'description' => 'getDescription',
        'key_size' => 'getKeySize',
        'elliptic_curve' => 'getEllipticCurve',
        'acct_id' => 'getAcctId',
        'group_id' => 'getGroupId',
        'creator' => 'getCreator',
        'kid' => 'getKid',
        'obj_type' => 'getObjType',
        'key_ops' => 'getKeyOps',
        'custom_metadata' => 'getCustomMetadata',
        'origin' => 'getOrigin',
        'pub_key' => 'getPubKey',
        'value' => 'getValue',
        'enabled' => 'getEnabled',
        'compliant_with_policies' => 'getCompliantWithPolicies',
        'created_at' => 'getCreatedAt',
        'lastused_at' => 'getLastusedAt',
        'transient_key' => 'getTransientKey',
        'never_exportable' => 'getNeverExportable',
        'rsa' => 'getRsa',
        'kcv' => 'getKcv',
        'state' => 'getState',
        'history' => 'getHistory'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['description'] = isset($data['description']) ? $data['description'] : null;
        $this->container['key_size'] = isset($data['key_size']) ? $data['key_size'] : null;
        $this->container['elliptic_curve'] = isset($data['elliptic_curve']) ? $data['elliptic_curve'] : null;
        $this->container['acct_id'] = isset($data['acct_id']) ? $data['acct_id'] : null;
        $this->container['group_id'] = isset($data['group_id']) ? $data['group_id'] : null;
        $this->container['creator'] = isset($data['creator']) ? $data['creator'] : null;
        $this->container['kid'] = isset($data['kid']) ? $data['kid'] : null;
        $this->container['obj_type'] = isset($data['obj_type']) ? $data['obj_type'] : null;
        $this->container['key_ops'] = isset($data['key_ops']) ? $data['key_ops'] : null;
        $this->container['custom_metadata'] = isset($data['custom_metadata']) ? $data['custom_metadata'] : null;
        $this->container['origin'] = isset($data['origin']) ? $data['origin'] : null;
        $this->container['pub_key'] = isset($data['pub_key']) ? $data['pub_key'] : null;
        $this->container['value'] = isset($data['value']) ? $data['value'] : null;
        $this->container['enabled'] = isset($data['enabled']) ? $data['enabled'] : null;
        $this->container['compliant_with_policies'] = isset($data['compliant_with_policies']) ? $data['compliant_with_policies'] : null;
        $this->container['created_at'] = isset($data['created_at']) ? $data['created_at'] : null;
        $this->container['lastused_at'] = isset($data['lastused_at']) ? $data['lastused_at'] : null;
        $this->container['transient_key'] = isset($data['transient_key']) ? $data['transient_key'] : null;
        $this->container['never_exportable'] = isset($data['never_exportable']) ? $data['never_exportable'] : null;
        $this->container['rsa'] = isset($data['rsa']) ? $data['rsa'] : null;
        $this->container['kcv'] = isset($data['kcv']) ? $data['kcv'] : null;
        $this->container['state'] = isset($data['state']) ? $data['state'] : null;
        $this->container['history'] = isset($data['history']) ? $data['history'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['name'] === null) {
            $invalid_properties[] = "'name' can't be null";
        }
        if ($this->container['acct_id'] === null) {
            $invalid_properties[] = "'acct_id' can't be null";
        }
        if ($this->container['creator'] === null) {
            $invalid_properties[] = "'creator' can't be null";
        }
        if ($this->container['obj_type'] === null) {
            $invalid_properties[] = "'obj_type' can't be null";
        }
        if ($this->container['origin'] === null) {
            $invalid_properties[] = "'origin' can't be null";
        }
        if (!is_null($this->container['pub_key']) && !preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $this->container['pub_key'])) {
            $invalid_properties[] = "invalid value for 'pub_key', must be conform to the pattern /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.";
        }

        if (!is_null($this->container['value']) && !preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $this->container['value'])) {
            $invalid_properties[] = "invalid value for 'value', must be conform to the pattern /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.";
        }

        if ($this->container['enabled'] === null) {
            $invalid_properties[] = "'enabled' can't be null";
        }
        if ($this->container['created_at'] === null) {
            $invalid_properties[] = "'created_at' can't be null";
        }
        if ($this->container['lastused_at'] === null) {
            $invalid_properties[] = "'lastused_at' can't be null";
        }
        if ($this->container['never_exportable'] === null) {
            $invalid_properties[] = "'never_exportable' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['name'] === null) {
            return false;
        }
        if ($this->container['acct_id'] === null) {
            return false;
        }
        if ($this->container['creator'] === null) {
            return false;
        }
        if ($this->container['obj_type'] === null) {
            return false;
        }
        if ($this->container['origin'] === null) {
            return false;
        }
        if (!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $this->container['pub_key'])) {
            return false;
        }
        if (!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $this->container['value'])) {
            return false;
        }
        if ($this->container['enabled'] === null) {
            return false;
        }
        if ($this->container['created_at'] === null) {
            return false;
        }
        if ($this->container['lastused_at'] === null) {
            return false;
        }
        if ($this->container['never_exportable'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     * @param string $name Name of the security object.
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     * @param string $description Description of the security object.
     * @return $this
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets key_size
     * @return int
     */
    public function getKeySize()
    {
        return $this->container['key_size'];
    }

    /**
     * Sets key_size
     * @param int $key_size For objects which are not elliptic curves, this is the size in bits (not bytes) of the object. This field is not returned for elliptic curves.
     * @return $this
     */
    public function setKeySize($key_size)
    {
        $this->container['key_size'] = $key_size;

        return $this;
    }

    /**
     * Gets elliptic_curve
     * @return \SdkmsClient\Model\EllipticCurve
     */
    public function getEllipticCurve()
    {
        return $this->container['elliptic_curve'];
    }

    /**
     * Sets elliptic_curve
     * @param \SdkmsClient\Model\EllipticCurve $elliptic_curve
     * @return $this
     */
    public function setEllipticCurve($elliptic_curve)
    {
        $this->container['elliptic_curve'] = $elliptic_curve;

        return $this;
    }

    /**
     * Gets acct_id
     * @return string
     */
    public function getAcctId()
    {
        return $this->container['acct_id'];
    }

    /**
     * Sets acct_id
     * @param string $acct_id Account ID of the account this security object belongs to.
     * @return $this
     */
    public function setAcctId($acct_id)
    {
        $this->container['acct_id'] = $acct_id;

        return $this;
    }

    /**
     * Gets group_id
     * @return string
     */
    public function getGroupId()
    {
        return $this->container['group_id'];
    }

    /**
     * Sets group_id
     * @param string $group_id Group ID of the security group that this security object belongs to.
     * @return $this
     */
    public function setGroupId($group_id)
    {
        $this->container['group_id'] = $group_id;

        return $this;
    }

    /**
     * Gets creator
     * @return \SdkmsClient\Model\CreatorType
     */
    public function getCreator()
    {
        return $this->container['creator'];
    }

    /**
     * Sets creator
     * @param \SdkmsClient\Model\CreatorType $creator
     * @return $this
     */
    public function setCreator($creator)
    {
        $this->container['creator'] = $creator;

        return $this;
    }

    /**
     * Gets kid
     * @return string
     */
    public function getKid()
    {
        return $this->container['kid'];
    }

    /**
     * Sets kid
     * @param string $kid Key ID uniquely identifying this security object.
     * @return $this
     */
    public function setKid($kid)
    {
        $this->container['kid'] = $kid;

        return $this;
    }

    /**
     * Gets obj_type
     * @return \SdkmsClient\Model\ObjectType
     */
    public function getObjType()
    {
        return $this->container['obj_type'];
    }

    /**
     * Sets obj_type
     * @param \SdkmsClient\Model\ObjectType $obj_type
     * @return $this
     */
    public function setObjType($obj_type)
    {
        $this->container['obj_type'] = $obj_type;

        return $this;
    }

    /**
     * Gets key_ops
     * @return \SdkmsClient\Model\KeyOperations[]
     */
    public function getKeyOps()
    {
        return $this->container['key_ops'];
    }

    /**
     * Sets key_ops
     * @param \SdkmsClient\Model\KeyOperations[] $key_ops Array of key operations enabled for this security object.
     * @return $this
     */
    public function setKeyOps($key_ops)
    {
        $this->container['key_ops'] = $key_ops;

        return $this;
    }

    /**
     * Gets custom_metadata
     * @return map[string,string]
     */
    public function getCustomMetadata()
    {
        return $this->container['custom_metadata'];
    }

    /**
     * Sets custom_metadata
     * @param map[string,string] $custom_metadata User-defined metadata for this key. Stored as key-value pairs.
     * @return $this
     */
    public function setCustomMetadata($custom_metadata)
    {
        $this->container['custom_metadata'] = $custom_metadata;

        return $this;
    }

    /**
     * Gets origin
     * @return \SdkmsClient\Model\ObjectOrigin
     */
    public function getOrigin()
    {
        return $this->container['origin'];
    }

    /**
     * Sets origin
     * @param \SdkmsClient\Model\ObjectOrigin $origin
     * @return $this
     */
    public function setOrigin($origin)
    {
        $this->container['origin'] = $origin;

        return $this;
    }

    /**
     * Gets pub_key
     * @return string
     */
    public function getPubKey()
    {
        return $this->container['pub_key'];
    }

    /**
     * Sets pub_key
     * @param string $pub_key This field is returned only for asymmetric keys. It contains the public key.
     * @return $this
     */
    public function setPubKey($pub_key)
    {

        if (!is_null($pub_key) && (!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $pub_key))) {
            throw new \InvalidArgumentException("invalid value for $pub_key when calling KeyObject., must conform to the pattern /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.");
        }

        $this->container['pub_key'] = $pub_key;

        return $this;
    }

    /**
     * Gets value
     * @return string
     */
    public function getValue()
    {
        return $this->container['value'];
    }

    /**
     * Sets value
     * @param string $value This field is returned only for opaque and secret objects. It contains the contents of the object.
     * @return $this
     */
    public function setValue($value)
    {

        if (!is_null($value) && (!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $value))) {
            throw new \InvalidArgumentException("invalid value for $value when calling KeyObject., must conform to the pattern /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.");
        }

        $this->container['value'] = $value;

        return $this;
    }

    /**
     * Gets enabled
     * @return bool
     */
    public function getEnabled()
    {
        return $this->container['enabled'];
    }

    /**
     * Sets enabled
     * @param bool $enabled Whether this security object has cryptographic operations enabled.
     * @return $this
     */
    public function setEnabled($enabled)
    {
        $this->container['enabled'] = $enabled;

        return $this;
    }

    /**
     * Gets compliant_with_policies
     * @return bool
     */
    public function getCompliantWithPolicies()
    {
        return $this->container['compliant_with_policies'];
    }

    /**
     * Sets compliant_with_policies
     * @param bool $compliant_with_policies Whether this security object is compliant with cryptographic policies or not.
     * @return $this
     */
    public function setCompliantWithPolicies($compliant_with_policies)
    {
        $this->container['compliant_with_policies'] = $compliant_with_policies;

        return $this;
    }

    /**
     * Gets created_at
     * @return string
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     * @param string $created_at When this security object was created.
     * @return $this
     */
    public function setCreatedAt($created_at)
    {
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets lastused_at
     * @return string
     */
    public function getLastusedAt()
    {
        return $this->container['lastused_at'];
    }

    /**
     * Sets lastused_at
     * @param string $lastused_at When this security object was last used.
     * @return $this
     */
    public function setLastusedAt($lastused_at)
    {
        $this->container['lastused_at'] = $lastused_at;

        return $this;
    }

    /**
     * Gets transient_key
     * @return string
     */
    public function getTransientKey()
    {
        return $this->container['transient_key'];
    }

    /**
     * Sets transient_key
     * @param string $transient_key Transient key blob.
     * @return $this
     */
    public function setTransientKey($transient_key)
    {
        $this->container['transient_key'] = $transient_key;

        return $this;
    }

    /**
     * Gets never_exportable
     * @return bool
     */
    public function getNeverExportable()
    {
        return $this->container['never_exportable'];
    }

    /**
     * Sets never_exportable
     * @param bool $never_exportable True if this key's operations have never contained EXPORT.
     * @return $this
     */
    public function setNeverExportable($never_exportable)
    {
        $this->container['never_exportable'] = $never_exportable;

        return $this;
    }

    /**
     * Gets rsa
     * @return \SdkmsClient\Model\RsaOptions
     */
    public function getRsa()
    {
        return $this->container['rsa'];
    }

    /**
     * Sets rsa
     * @param \SdkmsClient\Model\RsaOptions $rsa
     * @return $this
     */
    public function setRsa($rsa)
    {
        $this->container['rsa'] = $rsa;

        return $this;
    }

    /**
     * Gets kcv
     * @return string
     */
    public function getKcv()
    {
        return $this->container['kcv'];
    }

    /**
     * Sets kcv
     * @param string $kcv KCV for the Security Object
     * @return $this
     */
    public function setKcv($kcv)
    {
        $this->container['kcv'] = $kcv;

        return $this;
    }

    /**
     * Gets state
     * @return \SdkmsClient\Model\KeyObjectState
     */
    public function getState()
    {
        return $this->container['state'];
    }

    /**
     * Sets state
     * @param \SdkmsClient\Model\KeyObjectState $state
     * @return $this
     */
    public function setState($state)
    {
        $this->container['state'] = $state;

        return $this;
    }

    /**
     * Gets history
     * @return \SdkmsClient\Model\HistoryItem[]
     */
    public function getHistory()
    {
        return $this->container['history'];
    }

    /**
     * Sets history
     * @param \SdkmsClient\Model\HistoryItem[] $history When a Key Undo Policy is in place, a list of (non-expired) history items is returned. Each history item represents a passed key state that can be reverted to.
     * @return $this
     */
    public function setHistory($history)
    {
        $this->container['history'] = $history;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


