<?php
/**
 * MfaChallenge
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * MfaChallenge Class Doc Comment
 *
 * @category    Class
 * @description Challenge for registring or authenticating with a U2F two factor device.
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class MfaChallenge implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'MfaChallenge';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'u2f_challenge' => 'string',
        'u2f_keys' => '\SdkmsClient\Model\U2fKey[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'u2f_challenge' => null,
        'u2f_keys' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'u2f_challenge' => 'u2f_challenge',
        'u2f_keys' => 'u2f_keys'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'u2f_challenge' => 'setU2fChallenge',
        'u2f_keys' => 'setU2fKeys'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'u2f_challenge' => 'getU2fChallenge',
        'u2f_keys' => 'getU2fKeys'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['u2f_challenge'] = isset($data['u2f_challenge']) ? $data['u2f_challenge'] : null;
        $this->container['u2f_keys'] = isset($data['u2f_keys']) ? $data['u2f_keys'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['u2f_challenge'] === null) {
            $invalid_properties[] = "'u2f_challenge' can't be null";
        }
        if ($this->container['u2f_keys'] === null) {
            $invalid_properties[] = "'u2f_keys' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['u2f_challenge'] === null) {
            return false;
        }
        if ($this->container['u2f_keys'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets u2f_challenge
     * @return string
     */
    public function getU2fChallenge()
    {
        return $this->container['u2f_challenge'];
    }

    /**
     * Sets u2f_challenge
     * @param string $u2f_challenge
     * @return $this
     */
    public function setU2fChallenge($u2f_challenge)
    {
        $this->container['u2f_challenge'] = $u2f_challenge;

        return $this;
    }

    /**
     * Gets u2f_keys
     * @return \SdkmsClient\Model\U2fKey[]
     */
    public function getU2fKeys()
    {
        return $this->container['u2f_keys'];
    }

    /**
     * Sets u2f_keys
     * @param \SdkmsClient\Model\U2fKey[] $u2f_keys
     * @return $this
     */
    public function setU2fKeys($u2f_keys)
    {
        $this->container['u2f_keys'] = $u2f_keys;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


