<?php
/**
 * PluginRequest
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * PluginRequest Class Doc Comment
 *
 * @category    Class
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class PluginRequest implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'PluginRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'name' => 'string',
        'description' => 'string',
        'add_groups' => 'string[]',
        'del_groups' => 'string[]',
        'default_group' => 'string',
        'source' => '\SdkmsClient\Model\PluginSource',
        'enabled' => 'bool',
        'plugin_type' => '\SdkmsClient\Model\PluginType'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'name' => null,
        'description' => null,
        'add_groups' => null,
        'del_groups' => null,
        'default_group' => null,
        'source' => null,
        'enabled' => null,
        'plugin_type' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'name' => 'name',
        'description' => 'description',
        'add_groups' => 'add_groups',
        'del_groups' => 'del_groups',
        'default_group' => 'default_group',
        'source' => 'source',
        'enabled' => 'enabled',
        'plugin_type' => 'plugin_type'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'name' => 'setName',
        'description' => 'setDescription',
        'add_groups' => 'setAddGroups',
        'del_groups' => 'setDelGroups',
        'default_group' => 'setDefaultGroup',
        'source' => 'setSource',
        'enabled' => 'setEnabled',
        'plugin_type' => 'setPluginType'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'name' => 'getName',
        'description' => 'getDescription',
        'add_groups' => 'getAddGroups',
        'del_groups' => 'getDelGroups',
        'default_group' => 'getDefaultGroup',
        'source' => 'getSource',
        'enabled' => 'getEnabled',
        'plugin_type' => 'getPluginType'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['description'] = isset($data['description']) ? $data['description'] : null;
        $this->container['add_groups'] = isset($data['add_groups']) ? $data['add_groups'] : null;
        $this->container['del_groups'] = isset($data['del_groups']) ? $data['del_groups'] : null;
        $this->container['default_group'] = isset($data['default_group']) ? $data['default_group'] : null;
        $this->container['source'] = isset($data['source']) ? $data['source'] : null;
        $this->container['enabled'] = isset($data['enabled']) ? $data['enabled'] : null;
        $this->container['plugin_type'] = isset($data['plugin_type']) ? $data['plugin_type'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['name'] === null) {
            $invalid_properties[] = "'name' can't be null";
        }
        if ($this->container['add_groups'] === null) {
            $invalid_properties[] = "'add_groups' can't be null";
        }
        if ($this->container['default_group'] === null) {
            $invalid_properties[] = "'default_group' can't be null";
        }
        if ($this->container['source'] === null) {
            $invalid_properties[] = "'source' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['name'] === null) {
            return false;
        }
        if ($this->container['add_groups'] === null) {
            return false;
        }
        if ($this->container['default_group'] === null) {
            return false;
        }
        if ($this->container['source'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     * @param string $name Name of the plugin. Plugin names must be unique within an account.
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     * @param string $description Description of this plugin.
     * @return $this
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets add_groups
     * @return string[]
     */
    public function getAddGroups()
    {
        return $this->container['add_groups'];
    }

    /**
     * Sets add_groups
     * @param string[] $add_groups An array of Security Group IDs to add to this plugin.
     * @return $this
     */
    public function setAddGroups($add_groups)
    {
        $this->container['add_groups'] = $add_groups;

        return $this;
    }

    /**
     * Gets del_groups
     * @return string[]
     */
    public function getDelGroups()
    {
        return $this->container['del_groups'];
    }

    /**
     * Sets del_groups
     * @param string[] $del_groups An array of security group IDs to remove from this plugin.
     * @return $this
     */
    public function setDelGroups($del_groups)
    {
        $this->container['del_groups'] = $del_groups;

        return $this;
    }

    /**
     * Gets default_group
     * @return string
     */
    public function getDefaultGroup()
    {
        return $this->container['default_group'];
    }

    /**
     * Sets default_group
     * @param string $default_group The default group of this plugin. This is the group where security objects will be created by default by this plugin.
     * @return $this
     */
    public function setDefaultGroup($default_group)
    {
        $this->container['default_group'] = $default_group;

        return $this;
    }

    /**
     * Gets source
     * @return \SdkmsClient\Model\PluginSource
     */
    public function getSource()
    {
        return $this->container['source'];
    }

    /**
     * Sets source
     * @param \SdkmsClient\Model\PluginSource $source
     * @return $this
     */
    public function setSource($source)
    {
        $this->container['source'] = $source;

        return $this;
    }

    /**
     * Gets enabled
     * @return bool
     */
    public function getEnabled()
    {
        return $this->container['enabled'];
    }

    /**
     * Sets enabled
     * @param bool $enabled Whether this plugin is enabled.
     * @return $this
     */
    public function setEnabled($enabled)
    {
        $this->container['enabled'] = $enabled;

        return $this;
    }

    /**
     * Gets plugin_type
     * @return \SdkmsClient\Model\PluginType
     */
    public function getPluginType()
    {
        return $this->container['plugin_type'];
    }

    /**
     * Sets plugin_type
     * @param \SdkmsClient\Model\PluginType $plugin_type
     * @return $this
     */
    public function setPluginType($plugin_type)
    {
        $this->container['plugin_type'] = $plugin_type;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


