<?php
/**
 * UnwrapKeyRequest
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * UnwrapKeyRequest Class Doc Comment
 *
 * @category    Class
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class UnwrapKeyRequest implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'UnwrapKeyRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'alg' => '\SdkmsClient\Model\ObjectType',
        'group_id' => 'string',
        'obj_type' => '\SdkmsClient\Model\ObjectType',
        'wrapped_key' => 'string',
        'mode' => '\SdkmsClient\Model\CryptMode',
        'iv' => 'string',
        'ad' => 'string',
        'tag' => 'string',
        'name' => 'string',
        'description' => 'string',
        'key_ops' => '\SdkmsClient\Model\KeyOperations[]',
        'custom_metadata' => 'map[string,string]',
        'enabled' => 'bool',
        'transient' => 'bool',
        'rsa' => '\SdkmsClient\Model\RsaOptions'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'alg' => null,
        'group_id' => null,
        'obj_type' => null,
        'wrapped_key' => 'byte',
        'mode' => null,
        'iv' => 'byte',
        'ad' => 'byte',
        'tag' => 'byte',
        'name' => null,
        'description' => null,
        'key_ops' => null,
        'custom_metadata' => null,
        'enabled' => null,
        'transient' => null,
        'rsa' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'alg' => 'alg',
        'group_id' => 'group_id',
        'obj_type' => 'obj_type',
        'wrapped_key' => 'wrapped_key',
        'mode' => 'mode',
        'iv' => 'iv',
        'ad' => 'ad',
        'tag' => 'tag',
        'name' => 'name',
        'description' => 'description',
        'key_ops' => 'key_ops',
        'custom_metadata' => 'custom_metadata',
        'enabled' => 'enabled',
        'transient' => 'transient',
        'rsa' => 'rsa'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'alg' => 'setAlg',
        'group_id' => 'setGroupId',
        'obj_type' => 'setObjType',
        'wrapped_key' => 'setWrappedKey',
        'mode' => 'setMode',
        'iv' => 'setIv',
        'ad' => 'setAd',
        'tag' => 'setTag',
        'name' => 'setName',
        'description' => 'setDescription',
        'key_ops' => 'setKeyOps',
        'custom_metadata' => 'setCustomMetadata',
        'enabled' => 'setEnabled',
        'transient' => 'setTransient',
        'rsa' => 'setRsa'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'alg' => 'getAlg',
        'group_id' => 'getGroupId',
        'obj_type' => 'getObjType',
        'wrapped_key' => 'getWrappedKey',
        'mode' => 'getMode',
        'iv' => 'getIv',
        'ad' => 'getAd',
        'tag' => 'getTag',
        'name' => 'getName',
        'description' => 'getDescription',
        'key_ops' => 'getKeyOps',
        'custom_metadata' => 'getCustomMetadata',
        'enabled' => 'getEnabled',
        'transient' => 'getTransient',
        'rsa' => 'getRsa'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['alg'] = isset($data['alg']) ? $data['alg'] : null;
        $this->container['group_id'] = isset($data['group_id']) ? $data['group_id'] : null;
        $this->container['obj_type'] = isset($data['obj_type']) ? $data['obj_type'] : null;
        $this->container['wrapped_key'] = isset($data['wrapped_key']) ? $data['wrapped_key'] : null;
        $this->container['mode'] = isset($data['mode']) ? $data['mode'] : null;
        $this->container['iv'] = isset($data['iv']) ? $data['iv'] : null;
        $this->container['ad'] = isset($data['ad']) ? $data['ad'] : null;
        $this->container['tag'] = isset($data['tag']) ? $data['tag'] : null;
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['description'] = isset($data['description']) ? $data['description'] : null;
        $this->container['key_ops'] = isset($data['key_ops']) ? $data['key_ops'] : null;
        $this->container['custom_metadata'] = isset($data['custom_metadata']) ? $data['custom_metadata'] : null;
        $this->container['enabled'] = isset($data['enabled']) ? $data['enabled'] : null;
        $this->container['transient'] = isset($data['transient']) ? $data['transient'] : null;
        $this->container['rsa'] = isset($data['rsa']) ? $data['rsa'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['alg'] === null) {
            $invalid_properties[] = "'alg' can't be null";
        }
        if ($this->container['obj_type'] === null) {
            $invalid_properties[] = "'obj_type' can't be null";
        }
        if ($this->container['wrapped_key'] === null) {
            $invalid_properties[] = "'wrapped_key' can't be null";
        }
        if (!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $this->container['wrapped_key'])) {
            $invalid_properties[] = "invalid value for 'wrapped_key', must be conform to the pattern /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.";
        }

        if (!is_null($this->container['iv']) && !preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $this->container['iv'])) {
            $invalid_properties[] = "invalid value for 'iv', must be conform to the pattern /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.";
        }

        if (!is_null($this->container['ad']) && !preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $this->container['ad'])) {
            $invalid_properties[] = "invalid value for 'ad', must be conform to the pattern /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.";
        }

        if (!is_null($this->container['tag']) && !preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $this->container['tag'])) {
            $invalid_properties[] = "invalid value for 'tag', must be conform to the pattern /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.";
        }

        if ($this->container['name'] === null) {
            $invalid_properties[] = "'name' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['alg'] === null) {
            return false;
        }
        if ($this->container['obj_type'] === null) {
            return false;
        }
        if ($this->container['wrapped_key'] === null) {
            return false;
        }
        if (!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $this->container['wrapped_key'])) {
            return false;
        }
        if (!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $this->container['iv'])) {
            return false;
        }
        if (!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $this->container['ad'])) {
            return false;
        }
        if (!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $this->container['tag'])) {
            return false;
        }
        if ($this->container['name'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets alg
     * @return \SdkmsClient\Model\ObjectType
     */
    public function getAlg()
    {
        return $this->container['alg'];
    }

    /**
     * Sets alg
     * @param \SdkmsClient\Model\ObjectType $alg
     * @return $this
     */
    public function setAlg($alg)
    {
        $this->container['alg'] = $alg;

        return $this;
    }

    /**
     * Gets group_id
     * @return string
     */
    public function getGroupId()
    {
        return $this->container['group_id'];
    }

    /**
     * Sets group_id
     * @param string $group_id Group ID (not name) of the security group that this security object should belong to. The user or application creating this security object must be a member of this group. If no group is specified, the default group for the user or application will be used.
     * @return $this
     */
    public function setGroupId($group_id)
    {
        $this->container['group_id'] = $group_id;

        return $this;
    }

    /**
     * Gets obj_type
     * @return \SdkmsClient\Model\ObjectType
     */
    public function getObjType()
    {
        return $this->container['obj_type'];
    }

    /**
     * Sets obj_type
     * @param \SdkmsClient\Model\ObjectType $obj_type
     * @return $this
     */
    public function setObjType($obj_type)
    {
        $this->container['obj_type'] = $obj_type;

        return $this;
    }

    /**
     * Gets wrapped_key
     * @return string
     */
    public function getWrappedKey()
    {
        return $this->container['wrapped_key'];
    }

    /**
     * Sets wrapped_key
     * @param string $wrapped_key A Security Object previously wrapped with another key.
     * @return $this
     */
    public function setWrappedKey($wrapped_key)
    {

        if ((!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $wrapped_key))) {
            throw new \InvalidArgumentException("invalid value for $wrapped_key when calling UnwrapKeyRequest., must conform to the pattern /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.");
        }

        $this->container['wrapped_key'] = $wrapped_key;

        return $this;
    }

    /**
     * Gets mode
     * @return \SdkmsClient\Model\CryptMode
     */
    public function getMode()
    {
        return $this->container['mode'];
    }

    /**
     * Sets mode
     * @param \SdkmsClient\Model\CryptMode $mode
     * @return $this
     */
    public function setMode($mode)
    {
        $this->container['mode'] = $mode;

        return $this;
    }

    /**
     * Gets iv
     * @return string
     */
    public function getIv()
    {
        return $this->container['iv'];
    }

    /**
     * Sets iv
     * @param string $iv The initialization value used to encrypt this ciphertext. This field is required for symmetric ciphers, and ignored for asymmetric ciphers.
     * @return $this
     */
    public function setIv($iv)
    {

        if (!is_null($iv) && (!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $iv))) {
            throw new \InvalidArgumentException("invalid value for $iv when calling UnwrapKeyRequest., must conform to the pattern /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.");
        }

        $this->container['iv'] = $iv;

        return $this;
    }

    /**
     * Gets ad
     * @return string
     */
    public function getAd()
    {
        return $this->container['ad'];
    }

    /**
     * Sets ad
     * @param string $ad The authenticated data used with this ciphertext and authentication tag. This field is required for symmetric ciphers using cipher mode GCM or CCM, and must not be specified for all other ciphers.
     * @return $this
     */
    public function setAd($ad)
    {

        if (!is_null($ad) && (!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $ad))) {
            throw new \InvalidArgumentException("invalid value for $ad when calling UnwrapKeyRequest., must conform to the pattern /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.");
        }

        $this->container['ad'] = $ad;

        return $this;
    }

    /**
     * Gets tag
     * @return string
     */
    public function getTag()
    {
        return $this->container['tag'];
    }

    /**
     * Sets tag
     * @param string $tag The authentication tag used with this ciphertext and authenticated data. This field is required for symmetric ciphers using cipher mode GCM or CCM, and must not be specified for all other ciphers.
     * @return $this
     */
    public function setTag($tag)
    {

        if (!is_null($tag) && (!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $tag))) {
            throw new \InvalidArgumentException("invalid value for $tag when calling UnwrapKeyRequest., must conform to the pattern /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.");
        }

        $this->container['tag'] = $tag;

        return $this;
    }

    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     * @param string $name Name of the security object to unwrap. Security object names must be unique within an account.
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     * @param string $description Description of the Security object to unwrap.
     * @return $this
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets key_ops
     * @return \SdkmsClient\Model\KeyOperations[]
     */
    public function getKeyOps()
    {
        return $this->container['key_ops'];
    }

    /**
     * Sets key_ops
     * @param \SdkmsClient\Model\KeyOperations[] $key_ops Optional array of key operations to be enabled for this security object. If this property is not provided, the SDKMS server will provide a default set of key operations. Note that if you provide an empty array, all key operations will be disabled.
     * @return $this
     */
    public function setKeyOps($key_ops)
    {
        $this->container['key_ops'] = $key_ops;

        return $this;
    }

    /**
     * Gets custom_metadata
     * @return map[string,string]
     */
    public function getCustomMetadata()
    {
        return $this->container['custom_metadata'];
    }

    /**
     * Sets custom_metadata
     * @param map[string,string] $custom_metadata User-defined metadata for this key. Stored as key-value pairs.
     * @return $this
     */
    public function setCustomMetadata($custom_metadata)
    {
        $this->container['custom_metadata'] = $custom_metadata;

        return $this;
    }

    /**
     * Gets enabled
     * @return bool
     */
    public function getEnabled()
    {
        return $this->container['enabled'];
    }

    /**
     * Sets enabled
     * @param bool $enabled Whether the new security object should be enabled. Disabled security objects may not perform cryptographic operations.
     * @return $this
     */
    public function setEnabled($enabled)
    {
        $this->container['enabled'] = $enabled;

        return $this;
    }

    /**
     * Gets transient
     * @return bool
     */
    public function getTransient()
    {
        return $this->container['transient'];
    }

    /**
     * Sets transient
     * @param bool $transient If this is true, SDKMS will unwrap a transient key.
     * @return $this
     */
    public function setTransient($transient)
    {
        $this->container['transient'] = $transient;

        return $this;
    }

    /**
     * Gets rsa
     * @return \SdkmsClient\Model\RsaOptions
     */
    public function getRsa()
    {
        return $this->container['rsa'];
    }

    /**
     * Sets rsa
     * @param \SdkmsClient\Model\RsaOptions $rsa
     * @return $this
     */
    public function setRsa($rsa)
    {
        $this->container['rsa'] = $rsa;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


