<?php
/**
 * VersionResponse
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * VersionResponse Class Doc Comment
 *
 * @category    Class
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class VersionResponse implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'VersionResponse';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'version' => 'string',
        'api_version' => 'string',
        'server_mode' => '\SdkmsClient\Model\ServerMode',
        'fips_level' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'version' => null,
        'api_version' => null,
        'server_mode' => null,
        'fips_level' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'version' => 'version',
        'api_version' => 'api_version',
        'server_mode' => 'server_mode',
        'fips_level' => 'fips_level'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'version' => 'setVersion',
        'api_version' => 'setApiVersion',
        'server_mode' => 'setServerMode',
        'fips_level' => 'setFipsLevel'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'version' => 'getVersion',
        'api_version' => 'getApiVersion',
        'server_mode' => 'getServerMode',
        'fips_level' => 'getFipsLevel'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['version'] = isset($data['version']) ? $data['version'] : null;
        $this->container['api_version'] = isset($data['api_version']) ? $data['api_version'] : null;
        $this->container['server_mode'] = isset($data['server_mode']) ? $data['server_mode'] : null;
        $this->container['fips_level'] = isset($data['fips_level']) ? $data['fips_level'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['version'] === null) {
            $invalid_properties[] = "'version' can't be null";
        }
        if ($this->container['api_version'] === null) {
            $invalid_properties[] = "'api_version' can't be null";
        }
        if ($this->container['server_mode'] === null) {
            $invalid_properties[] = "'server_mode' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['version'] === null) {
            return false;
        }
        if ($this->container['api_version'] === null) {
            return false;
        }
        if ($this->container['server_mode'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets version
     * @return string
     */
    public function getVersion()
    {
        return $this->container['version'];
    }

    /**
     * Sets version
     * @param string $version The SDKMS server version. This is encoded as major.minor.build. For example, 1.0.25.
     * @return $this
     */
    public function setVersion($version)
    {
        $this->container['version'] = $version;

        return $this;
    }

    /**
     * Gets api_version
     * @return string
     */
    public function getApiVersion()
    {
        return $this->container['api_version'];
    }

    /**
     * Sets api_version
     * @param string $api_version The API version implemented by this server.
     * @return $this
     */
    public function setApiVersion($api_version)
    {
        $this->container['api_version'] = $api_version;

        return $this;
    }

    /**
     * Gets server_mode
     * @return \SdkmsClient\Model\ServerMode
     */
    public function getServerMode()
    {
        return $this->container['server_mode'];
    }

    /**
     * Sets server_mode
     * @param \SdkmsClient\Model\ServerMode $server_mode
     * @return $this
     */
    public function setServerMode($server_mode)
    {
        $this->container['server_mode'] = $server_mode;

        return $this;
    }

    /**
     * Gets fips_level
     * @return int
     */
    public function getFipsLevel()
    {
        return $this->container['fips_level'];
    }

    /**
     * Sets fips_level
     * @param int $fips_level FIPS level at which SDKMS in running. If this field is absent, then SDKMS is not running in FIPS compliant mode.
     * @return $this
     */
    public function setFipsLevel($fips_level)
    {
        $this->container['fips_level'] = $fips_level;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


