<?php
/**
 * SecurityObjectsApiTest
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Please update the test case below to test the endpoint.
 */

namespace SdkmsClient;

use \SdkmsClient\Configuration;
use \SdkmsClient\ApiClient;
use \SdkmsClient\ApiException;
use \SdkmsClient\ObjectSerializer;

/**
 * SecurityObjectsApiTest Class Doc Comment
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class SecurityObjectsApiTest extends \PHPUnit_Framework_TestCase
{

    /**
     * Setup before running any test cases
     */
    public static function setUpBeforeClass()
    {
    }

    /**
     * Setup before running each test case
     */
    public function setUp()
    {
    }

    /**
     * Clean up after running each test case
     */
    public function tearDown()
    {
    }

    /**
     * Clean up after running all test cases
     */
    public static function tearDownAfterClass()
    {
    }

    /**
     * Test case for activateSecurityObject
     *
     * Transitions immediately a security object to Active state.
     *
     */
    public function testActivateSecurityObject()
    {
    }

    /**
     * Test case for agreeKey
     *
     * Agree on a key from two other keys.
     *
     */
    public function testAgreeKey()
    {
    }

    /**
     * Test case for deletePrivateKey
     *
     * Remove / Destroy private half of the asymmetric key.
     *
     */
    public function testDeletePrivateKey()
    {
    }

    /**
     * Test case for deleteSecurityObject
     *
     * Delete a security object.
     *
     */
    public function testDeleteSecurityObject()
    {
    }

    /**
     * Test case for deriveKey
     *
     * Derive a key from another key.
     *
     */
    public function testDeriveKey()
    {
    }

    /**
     * Test case for deriveKeyEx
     *
     * Derive a key from another key.
     *
     */
    public function testDeriveKeyEx()
    {
    }

    /**
     * Test case for destroySecurityObject
     *
     * Destroys a security object, leaving its metadata in place.
     *
     */
    public function testDestroySecurityObject()
    {
    }

    /**
     * Test case for exportSobjectComponents
     *
     * export key components.
     *
     */
    public function testExportSobjectComponents()
    {
    }

    /**
     * Test case for generateSecurityObject
     *
     * Generate a new security object.
     *
     */
    public function testGenerateSecurityObject()
    {
    }

    /**
     * Test case for getSecurityObject
     *
     * Get a specific security object.
     *
     */
    public function testGetSecurityObject()
    {
    }

    /**
     * Test case for getSecurityObjectDigest
     *
     * Retrieve the digest (hash) of the value of an exportable security object.
     *
     */
    public function testGetSecurityObjectDigest()
    {
    }

    /**
     * Test case for getSecurityObjectKcv
     *
     * Get the key check value (KCV) of a symmetric key.
     *
     */
    public function testGetSecurityObjectKcv()
    {
    }

    /**
     * Test case for getSecurityObjectValue
     *
     * Retrieve the value of an exportable security object.
     *
     */
    public function testGetSecurityObjectValue()
    {
    }

    /**
     * Test case for getSecurityObjectValueEx
     *
     * Retrieve the value of an exportable security object.
     *
     */
    public function testGetSecurityObjectValueEx()
    {
    }

    /**
     * Test case for getSecurityObjects
     *
     * Get all security objects.
     *
     */
    public function testGetSecurityObjects()
    {
    }

    /**
     * Test case for importSecurityObject
     *
     * Import a security object.
     *
     */
    public function testImportSecurityObject()
    {
    }

    /**
     * Test case for importSobjectComponents
     *
     * import key components.
     *
     */
    public function testImportSobjectComponents()
    {
    }

    /**
     * Test case for persistSecurityObject
     *
     * Persist a transient key..
     *
     */
    public function testPersistSecurityObject()
    {
    }

    /**
     * Test case for revertHistoryItem
     *
     * Reverts a security object to a previous state.
     *
     */
    public function testRevertHistoryItem()
    {
    }

    /**
     * Test case for revokeSecurityObject
     *
     * Transitions immediately a security object to Deactivated or Compromised state.
     *
     */
    public function testRevokeSecurityObject()
    {
    }

    /**
     * Test case for rotateSecurityObject
     *
     * Rotate a key..
     *
     */
    public function testRotateSecurityObject()
    {
    }

    /**
     * Test case for updateSecurityObject
     *
     * Update a security object.
     *
     */
    public function testUpdateSecurityObject()
    {
    }

    /**
     * Test case for verifyKcv
     *
     * Verify that the KCV of the provided key material matches the provided KCV.
     *
     */
    public function testVerifyKcv()
    {
    }
}
