# SdkmsClient\ApprovalRequestsApi

All URIs are relative to *https://apps.smartkey.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**approve**](ApprovalRequestsApi.md#approve) | **POST** /sys/v1/approval_requests/{request-id}/approve | Approve a request.
[**createApprovalRequest**](ApprovalRequestsApi.md#createApprovalRequest) | **POST** /sys/v1/approval_requests | Create approval request
[**deleteApprovalRequest**](ApprovalRequestsApi.md#deleteApprovalRequest) | **DELETE** /sys/v1/approval_requests/{request-id} | Delete an approval request.
[**deny**](ApprovalRequestsApi.md#deny) | **POST** /sys/v1/approval_requests/{request-id}/deny | Deny a request.
[**getApprovalRequest**](ApprovalRequestsApi.md#getApprovalRequest) | **GET** /sys/v1/approval_requests/{request-id} | Get an approval request.
[**getApprovalRequests**](ApprovalRequestsApi.md#getApprovalRequests) | **GET** /sys/v1/approval_requests | Get all approval requests
[**getResult**](ApprovalRequestsApi.md#getResult) | **POST** /sys/v1/approval_requests/{request-id}/result | Get the result for an approved or failed request.


# **approve**
> approve($request_id, $body)

Approve a request.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\ApprovalRequestsApi();
$request_id = "request_id_example"; // string | Approval Request Identifier
$body = new \SdkmsClient\Model\ApproveRequest(); // \SdkmsClient\Model\ApproveRequest | Approve an approval request

try {
    $api_instance->approve($request_id, $body);
} catch (Exception $e) {
    echo 'Exception when calling ApprovalRequestsApi->approve: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **request_id** | **string**| Approval Request Identifier |
 **body** | [**\SdkmsClient\Model\ApproveRequest**](../Model/ApproveRequest.md)| Approve an approval request | [optional]

### Return type

void (empty response body)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **createApprovalRequest**
> \SdkmsClient\Model\ApprovalRequest createApprovalRequest($body)

Create approval request

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\ApprovalRequestsApi();
$body = new \SdkmsClient\Model\ApprovalRequestRequest(); // \SdkmsClient\Model\ApprovalRequestRequest | Request to create an approval request.

try {
    $result = $api_instance->createApprovalRequest($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ApprovalRequestsApi->createApprovalRequest: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\ApprovalRequestRequest**](../Model/ApprovalRequestRequest.md)| Request to create an approval request. |

### Return type

[**\SdkmsClient\Model\ApprovalRequest**](../Model/ApprovalRequest.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **deleteApprovalRequest**
> deleteApprovalRequest($request_id)

Delete an approval request.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\ApprovalRequestsApi();
$request_id = "request_id_example"; // string | Approval Request Identifier

try {
    $api_instance->deleteApprovalRequest($request_id);
} catch (Exception $e) {
    echo 'Exception when calling ApprovalRequestsApi->deleteApprovalRequest: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **request_id** | **string**| Approval Request Identifier |

### Return type

void (empty response body)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **deny**
> deny($request_id)

Deny a request.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\ApprovalRequestsApi();
$request_id = "request_id_example"; // string | Approval Request Identifier

try {
    $api_instance->deny($request_id);
} catch (Exception $e) {
    echo 'Exception when calling ApprovalRequestsApi->deny: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **request_id** | **string**| Approval Request Identifier |

### Return type

void (empty response body)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getApprovalRequest**
> \SdkmsClient\Model\ApprovalRequest getApprovalRequest($request_id)

Get an approval request.

Get the details and status of a particular approval request.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\ApprovalRequestsApi();
$request_id = "request_id_example"; // string | Approval Request Identifier

try {
    $result = $api_instance->getApprovalRequest($request_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ApprovalRequestsApi->getApprovalRequest: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **request_id** | **string**| Approval Request Identifier |

### Return type

[**\SdkmsClient\Model\ApprovalRequest**](../Model/ApprovalRequest.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getApprovalRequests**
> \SdkmsClient\Model\ApprovalRequest[] getApprovalRequests($requester, $reviewer, $subject, $status)

Get all approval requests

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\ApprovalRequestsApi();
$requester = "requester_example"; // string | Only retrieve approval requests with the specified requester ID
$reviewer = "reviewer_example"; // string | Only retrieve approval requests with the specified reviewer ID
$subject = "subject_example"; // string | Only retrieve approval requests with the specified subject ID
$status = "status_example"; // string | Only retrieve approval requests with the specified approval status

try {
    $result = $api_instance->getApprovalRequests($requester, $reviewer, $subject, $status);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ApprovalRequestsApi->getApprovalRequests: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **requester** | **string**| Only retrieve approval requests with the specified requester ID | [optional]
 **reviewer** | **string**| Only retrieve approval requests with the specified reviewer ID | [optional]
 **subject** | **string**| Only retrieve approval requests with the specified subject ID | [optional]
 **status** | **string**| Only retrieve approval requests with the specified approval status | [optional]

### Return type

[**\SdkmsClient\Model\ApprovalRequest[]**](../Model/ApprovalRequest.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getResult**
> \SdkmsClient\Model\ApprovableResult getResult($request_id)

Get the result for an approved or failed request.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\ApprovalRequestsApi();
$request_id = "request_id_example"; // string | Approval Request Identifier

try {
    $result = $api_instance->getResult($request_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ApprovalRequestsApi->getResult: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **request_id** | **string**| Approval Request Identifier |

### Return type

[**\SdkmsClient\Model\ApprovableResult**](../Model/ApprovableResult.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

