# SdkmsClient\LogsApi

All URIs are relative to *https://apps.smartkey.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getAuditLogs**](LogsApi.md#getAuditLogs) | **GET** /sys/v1/logs | Get audit logs


# **getAuditLogs**
> \SdkmsClient\Model\AuditLogResponse getAuditLogs($size, $from, $action_type, $actor_type, $actor_id, $object_id, $severity, $range_from, $range_to)

Get audit logs

Get audit log entries matching the requested filters.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\LogsApi();
$size = 56; // int | Maximum number of entries to return
$from = 56; // int | For pagination, starting offset
$action_type = "action_type_example"; // string | Event action type
$actor_type = "actor_type_example"; // string | Event actor type
$actor_id = "actor_id_example"; // string | Actor (User or App) Identifier
$object_id = "object_id_example"; // string | Object (User or App) Identifier for event
$severity = "severity_example"; // string | Event severity type
$range_from = 56; // int | Starting time for search , this is EPOCH value
$range_to = 56; // int | Ending time for search , this is EPOCH value

try {
    $result = $api_instance->getAuditLogs($size, $from, $action_type, $actor_type, $actor_id, $object_id, $severity, $range_from, $range_to);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling LogsApi->getAuditLogs: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **size** | **int**| Maximum number of entries to return | [optional]
 **from** | **int**| For pagination, starting offset | [optional]
 **action_type** | **string**| Event action type | [optional]
 **actor_type** | **string**| Event actor type | [optional]
 **actor_id** | **string**| Actor (User or App) Identifier | [optional]
 **object_id** | **string**| Object (User or App) Identifier for event | [optional]
 **severity** | **string**| Event severity type | [optional]
 **range_from** | **int**| Starting time for search , this is EPOCH value | [optional]
 **range_to** | **int**| Ending time for search , this is EPOCH value | [optional]

### Return type

[**\SdkmsClient\Model\AuditLogResponse**](../Model/AuditLogResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

