# SdkmsClient\PluginsApi

All URIs are relative to *https://apps.smartkey.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createPlugin**](PluginsApi.md#createPlugin) | **POST** /sys/v1/plugins | Create a new plugin
[**deletePlugin**](PluginsApi.md#deletePlugin) | **DELETE** /sys/v1/plugins/{plugin-id} | Delete plugin
[**getPlugin**](PluginsApi.md#getPlugin) | **GET** /sys/v1/plugins/{plugin-id} | Get a specific plugin
[**getPlugins**](PluginsApi.md#getPlugins) | **GET** /sys/v1/plugins | Get all plugins
[**invokePlugin**](PluginsApi.md#invokePlugin) | **POST** /sys/v1/plugins/{plugin-id} | Invoke a plugin
[**sysV1PluginsInvokePluginIdGet**](PluginsApi.md#sysV1PluginsInvokePluginIdGet) | **GET** /sys/v1/plugins/invoke/{plugin-id} | Invoke a plugin using GET.
[**updatePlugin**](PluginsApi.md#updatePlugin) | **PATCH** /sys/v1/plugins/{plugin-id} | Update a plugin


# **createPlugin**
> \SdkmsClient\Model\Plugin createPlugin($body)

Create a new plugin

Create a new plugin with the specified properties.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\PluginsApi();
$body = new \SdkmsClient\Model\PluginRequest(); // \SdkmsClient\Model\PluginRequest | Properties of plugin to create

try {
    $result = $api_instance->createPlugin($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling PluginsApi->createPlugin: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\SdkmsClient\Model\PluginRequest**](../Model/PluginRequest.md)| Properties of plugin to create |

### Return type

[**\SdkmsClient\Model\Plugin**](../Model/Plugin.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **deletePlugin**
> deletePlugin($plugin_id)

Delete plugin

Remove a plugin from SDKMS.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\PluginsApi();
$plugin_id = "plugin_id_example"; // string | Plugin Identifier

try {
    $api_instance->deletePlugin($plugin_id);
} catch (Exception $e) {
    echo 'Exception when calling PluginsApi->deletePlugin: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **plugin_id** | **string**| Plugin Identifier |

### Return type

void (empty response body)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getPlugin**
> \SdkmsClient\Model\Plugin getPlugin($plugin_id)

Get a specific plugin

Look up plugin by plugin ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\PluginsApi();
$plugin_id = "plugin_id_example"; // string | Plugin Identifier

try {
    $result = $api_instance->getPlugin($plugin_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling PluginsApi->getPlugin: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **plugin_id** | **string**| Plugin Identifier |

### Return type

[**\SdkmsClient\Model\Plugin**](../Model/Plugin.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getPlugins**
> \SdkmsClient\Model\Plugin[] getPlugins($group_id, $sort, $start, $limit, $offset)

Get all plugins

Get details of all plugins the current user has access to.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\PluginsApi();
$group_id = "group_id_example"; // string | Only retrieve plugins in the specified group.
$sort = "sort_example"; // string | This specifies the property (`plugin_id` only, for now) and order (ascending or descending) with which to sort the apps. By default, plugins are sorted by `plugin_id` in ascending order. The syntax is \"<property>:[asc|desc]\" (e.g. \"plugin_id:desc\") or just \"<property>\" (ascending order by default).
$start = "start_example"; // string | If provided, this must be a value of the property specified in `sort`. Returned apps will begin just above or just below this value (for asc/desc order resp.).
$limit = 56; // int | Maximum number of apps to return. If not provided, the limit is 100.
$offset = 56; // int | Number of apps past `start` to skip.

try {
    $result = $api_instance->getPlugins($group_id, $sort, $start, $limit, $offset);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling PluginsApi->getPlugins: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **group_id** | **string**| Only retrieve plugins in the specified group. | [optional]
 **sort** | **string**| This specifies the property (&#x60;plugin_id&#x60; only, for now) and order (ascending or descending) with which to sort the apps. By default, plugins are sorted by &#x60;plugin_id&#x60; in ascending order. The syntax is \&quot;&lt;property&gt;:[asc|desc]\&quot; (e.g. \&quot;plugin_id:desc\&quot;) or just \&quot;&lt;property&gt;\&quot; (ascending order by default). | [optional]
 **start** | **string**| If provided, this must be a value of the property specified in &#x60;sort&#x60;. Returned apps will begin just above or just below this value (for asc/desc order resp.). | [optional]
 **limit** | **int**| Maximum number of apps to return. If not provided, the limit is 100. | [optional]
 **offset** | **int**| Number of apps past &#x60;start&#x60; to skip. | [optional]

### Return type

[**\SdkmsClient\Model\Plugin[]**](../Model/Plugin.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **invokePlugin**
> \SdkmsClient\Model\PluginInvokeResponse invokePlugin($plugin_id, $body)

Invoke a plugin

Invokes a plugin execution with the provided request body as input to the plugin.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\PluginsApi();
$plugin_id = "plugin_id_example"; // string | Plugin Identifier
$body = new \SdkmsClient\Model\PluginInvokeRequest(); // \SdkmsClient\Model\PluginInvokeRequest | Object to be passed to plugin as input

try {
    $result = $api_instance->invokePlugin($plugin_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling PluginsApi->invokePlugin: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **plugin_id** | **string**| Plugin Identifier |
 **body** | [**\SdkmsClient\Model\PluginInvokeRequest**](../Model/PluginInvokeRequest.md)| Object to be passed to plugin as input |

### Return type

[**\SdkmsClient\Model\PluginInvokeResponse**](../Model/PluginInvokeResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **sysV1PluginsInvokePluginIdGet**
> \SdkmsClient\Model\PluginInvokeResponse sysV1PluginsInvokePluginIdGet($plugin_id)

Invoke a plugin using GET.

Invokes a plugin with empty input.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\PluginsApi();
$plugin_id = "plugin_id_example"; // string | Plugin Identifier

try {
    $result = $api_instance->sysV1PluginsInvokePluginIdGet($plugin_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling PluginsApi->sysV1PluginsInvokePluginIdGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **plugin_id** | **string**| Plugin Identifier |

### Return type

[**\SdkmsClient\Model\PluginInvokeResponse**](../Model/PluginInvokeResponse.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **updatePlugin**
> \SdkmsClient\Model\App updatePlugin($plugin_id, $body)

Update a plugin

Change a plugin's properties, such as name, description, code, or group membership.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: bearerToken
SdkmsClient\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// SdkmsClient\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$api_instance = new SdkmsClient\Api\PluginsApi();
$plugin_id = "plugin_id_example"; // string | Plugin Identifier
$body = new \SdkmsClient\Model\PluginRequest(); // \SdkmsClient\Model\PluginRequest | Properties of plugin to create

try {
    $result = $api_instance->updatePlugin($plugin_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling PluginsApi->updatePlugin: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **plugin_id** | **string**| Plugin Identifier |
 **body** | [**\SdkmsClient\Model\PluginRequest**](../Model/PluginRequest.md)| Properties of plugin to create |

### Return type

[**\SdkmsClient\Model\App**](../Model/App.md)

### Authorization

[bearerToken](../../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

