# DeriveKeyRequest

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**name** | **string** | Name of the derived key. Key names must be unique within an account. | 
**group_id** | **string** | Group ID (not name) of the security group that this security object should belong to. The user or application creating this security object must be a member of this group. If no group is specified, the default group for the user or application will be used. | [optional] 
**key_size** | **int** | Key size of the derived key in bits (not bytes). | 
**key_type** | [**\SdkmsClient\Model\ObjectType**](ObjectType.md) |  | 
**mechanism** | [**\SdkmsClient\Model\DeriveKeyMechanism**](DeriveKeyMechanism.md) |  | 
**enabled** | **bool** | Whether the derived key should have cryptographic operations enabled. | [optional] 
**description** | **string** | Description for the new key. | [optional] 
**key_ops** | [**\SdkmsClient\Model\KeyOperations[]**](KeyOperations.md) | Optional array of key operations to be enabled for this security object. If this property is not provided, the SDKMS server will provide a default set of key operations. Note that if you provide an empty array, all key operations will be disabled. | [optional] 
**custom_metadata** | **map[string,string]** | User-defined metadata for this key. Stored as key-value pairs. | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


