# KeyObject

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**name** | **string** | Name of the security object. | 
**description** | **string** | Description of the security object. | [optional] 
**key_size** | **int** | For objects which are not elliptic curves, this is the size in bits (not bytes) of the object. This field is not returned for elliptic curves. | [optional] 
**elliptic_curve** | [**\SdkmsClient\Model\EllipticCurve**](EllipticCurve.md) |  | [optional] 
**acct_id** | **string** | Account ID of the account this security object belongs to. | 
**group_id** | **string** | Group ID of the security group that this security object belongs to. | [optional] 
**creator** | [**\SdkmsClient\Model\CreatorType**](CreatorType.md) |  | 
**kid** | **string** | Key ID uniquely identifying this security object. | [optional] 
**obj_type** | [**\SdkmsClient\Model\ObjectType**](ObjectType.md) |  | 
**key_ops** | [**\SdkmsClient\Model\KeyOperations[]**](KeyOperations.md) | Array of key operations enabled for this security object. | [optional] 
**custom_metadata** | **map[string,string]** | User-defined metadata for this key. Stored as key-value pairs. | [optional] 
**origin** | [**\SdkmsClient\Model\ObjectOrigin**](ObjectOrigin.md) |  | 
**pub_key** | **string** | This field is returned only for asymmetric keys. It contains the public key. | [optional] 
**value** | **string** | This field is returned only for opaque and secret objects. It contains the contents of the object. | [optional] 
**enabled** | **bool** | Whether this security object has cryptographic operations enabled. | 
**compliant_with_policies** | **bool** | Whether this security object is compliant with cryptographic policies or not. | [optional] 
**created_at** | **string** | When this security object was created. | 
**lastused_at** | **string** | When this security object was last used. | 
**transient_key** | **string** | Transient key blob. | [optional] 
**never_exportable** | **bool** | True if this key&#39;s operations have never contained EXPORT. | 
**rsa** | [**\SdkmsClient\Model\RsaOptions**](RsaOptions.md) |  | [optional] 
**kcv** | **string** | KCV for the Security Object | [optional] 
**state** | [**\SdkmsClient\Model\KeyObjectState**](KeyObjectState.md) |  | [optional] 
**history** | [**\SdkmsClient\Model\HistoryItem[]**](HistoryItem.md) | When a Key Undo Policy is in place, a list of (non-expired) history items is returned. Each history item represents a passed key state that can be reverted to. | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


