# SobjectRequest

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**name** | **string** | Name of the security object to create or import. Security object names must be unique within an account. | 
**description** | **string** | Description of the security object to create or import. | [optional] 
**key_size** | **int** | Size in bits (not bytes) of the security object to create or import. Required for symmetric keys. For DSA keys, it represents the size of &#x60;p&#x60;; allowed values are 2048 or 3072. Deprecated for RSA keys, specify it in &#x60;RsaOptions&#x60; instead. | [optional] 
**pub_exponent** | **int** | For RSA keys only. Deprecated. Specify in &#x60;RsaOptions&#x60; instead. Public exponent to use when generating an RSA key. | [optional] 
**elliptic_curve** | [**\SdkmsClient\Model\EllipticCurve**](EllipticCurve.md) |  | [optional] 
**rsa** | [**\SdkmsClient\Model\RsaOptions**](RsaOptions.md) |  | [optional] 
**dsa** | [**\SdkmsClient\Model\DsaOptions**](DsaOptions.md) |  | [optional] 
**fpe** | [**\SdkmsClient\Model\FpeOptions**](FpeOptions.md) |  | [optional] 
**group_id** | **string** | Group ID (not name) of the security group that this security object should belong to. The user or application creating this security object must be a member of this group. If no group is specified, the default group for the user or application will be used. | [optional] 
**rotation_policy** | [**\SdkmsClient\Model\RotationPolicy**](RotationPolicy.md) |  | [optional] 
**obj_type** | [**\SdkmsClient\Model\ObjectType**](ObjectType.md) |  | 
**key_ops** | [**\SdkmsClient\Model\KeyOperations[]**](KeyOperations.md) | Optional array of key operations to be enabled for this security object. If this property is not provided, the SDKMS server will provide a default set of key operations. Note that if you provide an empty array, all key operations will be disabled. | [optional] 
**custom_metadata** | **map[string,string]** | User-defined metadata for this key. Stored as key-value pairs. | [optional] 
**value** | **string** | When importing a security object, this field contains the binary contents to import. When creating a security object, this field is unused. The value of an OPAQUE or CERTIFICATE object is always returned. For other objects, the value is returned only with &#x60;/crypto/v1/keys/export&#x60; API (if the object is exportable). | [optional] 
**enabled** | **bool** | Whether the new security object should be enabled. Disabled security objects may not perform cryptographic operations. | [optional] 
**transient** | **bool** | If this is true, SDKMS will create a transient key. | [optional] 
**deterministic_signatures** | **bool** |  | [optional] 
**state** | [**\SdkmsClient\Model\KeyObjectState**](KeyObjectState.md) |  | [optional] 
**deactivation_date** | **string** | When this object will be deactivated. | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


