<?php
/**
 * ApprovalRequestsApi
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Api;

use \SdkmsClient\ApiClient;
use \SdkmsClient\ApiException;
use \SdkmsClient\Configuration;
use \SdkmsClient\ObjectSerializer;

/**
 * ApprovalRequestsApi Class Doc Comment
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class ApprovalRequestsApi
{
    /**
     * API Client
     *
     * @var \SdkmsClient\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \SdkmsClient\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\SdkmsClient\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \SdkmsClient\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \SdkmsClient\ApiClient $apiClient set the API client
     *
     * @return ApprovalRequestsApi
     */
    public function setApiClient(\SdkmsClient\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation approve
     *
     * Approve a request.
     *
     * @param string $request_id Approval Request Identifier (required)
     * @param \SdkmsClient\Model\ApproveRequest $body Approve an approval request (optional)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return void
     */
    public function approve($request_id, $body = null)
    {
        list($response) = $this->approveWithHttpInfo($request_id, $body);
        return $response;
    }

    /**
     * Operation approveWithHttpInfo
     *
     * Approve a request.
     *
     * @param string $request_id Approval Request Identifier (required)
     * @param \SdkmsClient\Model\ApproveRequest $body Approve an approval request (optional)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function approveWithHttpInfo($request_id, $body = null)
    {
        // verify the required parameter 'request_id' is set
        if ($request_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $request_id when calling approve');
        }
        // parse inputs
        $resourcePath = "/sys/v1/approval_requests/{request-id}/approve";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($request_id !== null) {
            $resourcePath = str_replace(
                "{" . "request-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($request_id),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                null,
                '/sys/v1/approval_requests/{request-id}/approve'
            );

            return [null, $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation createApprovalRequest
     *
     * Create approval request
     *
     * @param \SdkmsClient\Model\ApprovalRequestRequest $body Request to create an approval request. (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\ApprovalRequest
     */
    public function createApprovalRequest($body)
    {
        list($response) = $this->createApprovalRequestWithHttpInfo($body);
        return $response;
    }

    /**
     * Operation createApprovalRequestWithHttpInfo
     *
     * Create approval request
     *
     * @param \SdkmsClient\Model\ApprovalRequestRequest $body Request to create an approval request. (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\ApprovalRequest, HTTP status code, HTTP response headers (array of strings)
     */
    public function createApprovalRequestWithHttpInfo($body)
    {
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling createApprovalRequest');
        }
        // parse inputs
        $resourcePath = "/sys/v1/approval_requests";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\ApprovalRequest',
                '/sys/v1/approval_requests'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\ApprovalRequest', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 201:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\ApprovalRequest', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation deleteApprovalRequest
     *
     * Delete an approval request.
     *
     * @param string $request_id Approval Request Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return void
     */
    public function deleteApprovalRequest($request_id)
    {
        list($response) = $this->deleteApprovalRequestWithHttpInfo($request_id);
        return $response;
    }

    /**
     * Operation deleteApprovalRequestWithHttpInfo
     *
     * Delete an approval request.
     *
     * @param string $request_id Approval Request Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteApprovalRequestWithHttpInfo($request_id)
    {
        // verify the required parameter 'request_id' is set
        if ($request_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $request_id when calling deleteApprovalRequest');
        }
        // parse inputs
        $resourcePath = "/sys/v1/approval_requests/{request-id}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($request_id !== null) {
            $resourcePath = str_replace(
                "{" . "request-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($request_id),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'DELETE',
                $queryParams,
                $httpBody,
                $headerParams,
                null,
                '/sys/v1/approval_requests/{request-id}'
            );

            return [null, $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation deny
     *
     * Deny a request.
     *
     * @param string $request_id Approval Request Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return void
     */
    public function deny($request_id)
    {
        list($response) = $this->denyWithHttpInfo($request_id);
        return $response;
    }

    /**
     * Operation denyWithHttpInfo
     *
     * Deny a request.
     *
     * @param string $request_id Approval Request Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function denyWithHttpInfo($request_id)
    {
        // verify the required parameter 'request_id' is set
        if ($request_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $request_id when calling deny');
        }
        // parse inputs
        $resourcePath = "/sys/v1/approval_requests/{request-id}/deny";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($request_id !== null) {
            $resourcePath = str_replace(
                "{" . "request-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($request_id),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                null,
                '/sys/v1/approval_requests/{request-id}/deny'
            );

            return [null, $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getApprovalRequest
     *
     * Get an approval request.
     *
     * @param string $request_id Approval Request Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\ApprovalRequest
     */
    public function getApprovalRequest($request_id)
    {
        list($response) = $this->getApprovalRequestWithHttpInfo($request_id);
        return $response;
    }

    /**
     * Operation getApprovalRequestWithHttpInfo
     *
     * Get an approval request.
     *
     * @param string $request_id Approval Request Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\ApprovalRequest, HTTP status code, HTTP response headers (array of strings)
     */
    public function getApprovalRequestWithHttpInfo($request_id)
    {
        // verify the required parameter 'request_id' is set
        if ($request_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $request_id when calling getApprovalRequest');
        }
        // parse inputs
        $resourcePath = "/sys/v1/approval_requests/{request-id}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($request_id !== null) {
            $resourcePath = str_replace(
                "{" . "request-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($request_id),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\ApprovalRequest',
                '/sys/v1/approval_requests/{request-id}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\ApprovalRequest', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\ApprovalRequest', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getApprovalRequests
     *
     * Get all approval requests
     *
     * @param string $requester Only retrieve approval requests with the specified requester ID (optional)
     * @param string $reviewer Only retrieve approval requests with the specified reviewer ID (optional)
     * @param string $subject Only retrieve approval requests with the specified subject ID (optional)
     * @param string $status Only retrieve approval requests with the specified approval status (optional)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\ApprovalRequest[]
     */
    public function getApprovalRequests($requester = null, $reviewer = null, $subject = null, $status = null)
    {
        list($response) = $this->getApprovalRequestsWithHttpInfo($requester, $reviewer, $subject, $status);
        return $response;
    }

    /**
     * Operation getApprovalRequestsWithHttpInfo
     *
     * Get all approval requests
     *
     * @param string $requester Only retrieve approval requests with the specified requester ID (optional)
     * @param string $reviewer Only retrieve approval requests with the specified reviewer ID (optional)
     * @param string $subject Only retrieve approval requests with the specified subject ID (optional)
     * @param string $status Only retrieve approval requests with the specified approval status (optional)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\ApprovalRequest[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getApprovalRequestsWithHttpInfo($requester = null, $reviewer = null, $subject = null, $status = null)
    {
        // parse inputs
        $resourcePath = "/sys/v1/approval_requests";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // query params
        if ($requester !== null) {
            $queryParams['requester'] = $this->apiClient->getSerializer()->toQueryValue($requester);
        }
        // query params
        if ($reviewer !== null) {
            $queryParams['reviewer'] = $this->apiClient->getSerializer()->toQueryValue($reviewer);
        }
        // query params
        if ($subject !== null) {
            $queryParams['subject'] = $this->apiClient->getSerializer()->toQueryValue($subject);
        }
        // query params
        if ($status !== null) {
            $queryParams['status'] = $this->apiClient->getSerializer()->toQueryValue($status);
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\ApprovalRequest[]',
                '/sys/v1/approval_requests'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\ApprovalRequest[]', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\ApprovalRequest[]', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getResult
     *
     * Get the result for an approved or failed request.
     *
     * @param string $request_id Approval Request Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\ApprovableResult
     */
    public function getResult($request_id)
    {
        list($response) = $this->getResultWithHttpInfo($request_id);
        return $response;
    }

    /**
     * Operation getResultWithHttpInfo
     *
     * Get the result for an approved or failed request.
     *
     * @param string $request_id Approval Request Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\ApprovableResult, HTTP status code, HTTP response headers (array of strings)
     */
    public function getResultWithHttpInfo($request_id)
    {
        // verify the required parameter 'request_id' is set
        if ($request_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $request_id when calling getResult');
        }
        // parse inputs
        $resourcePath = "/sys/v1/approval_requests/{request-id}/result";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($request_id !== null) {
            $resourcePath = str_replace(
                "{" . "request-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($request_id),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\ApprovableResult',
                '/sys/v1/approval_requests/{request-id}/result'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\ApprovableResult', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\ApprovableResult', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
