<?php
/**
 * LogsApi
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Api;

use \SdkmsClient\ApiClient;
use \SdkmsClient\ApiException;
use \SdkmsClient\Configuration;
use \SdkmsClient\ObjectSerializer;

/**
 * LogsApi Class Doc Comment
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class LogsApi
{
    /**
     * API Client
     *
     * @var \SdkmsClient\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \SdkmsClient\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\SdkmsClient\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \SdkmsClient\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \SdkmsClient\ApiClient $apiClient set the API client
     *
     * @return LogsApi
     */
    public function setApiClient(\SdkmsClient\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation getAuditLogs
     *
     * Get audit logs
     *
     * @param int $size Maximum number of entries to return (optional)
     * @param int $from For pagination, starting offset (optional)
     * @param string $action_type Event action type (optional)
     * @param string $actor_type Event actor type (optional)
     * @param string $actor_id Actor (User or App) Identifier (optional)
     * @param string $object_id Object (User or App) Identifier for event (optional)
     * @param string $severity Event severity type (optional)
     * @param int $range_from Starting time for search , this is EPOCH value (optional)
     * @param int $range_to Ending time for search , this is EPOCH value (optional)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\AuditLogResponse
     */
    public function getAuditLogs($size = null, $from = null, $action_type = null, $actor_type = null, $actor_id = null, $object_id = null, $severity = null, $range_from = null, $range_to = null)
    {
        list($response) = $this->getAuditLogsWithHttpInfo($size, $from, $action_type, $actor_type, $actor_id, $object_id, $severity, $range_from, $range_to);
        return $response;
    }

    /**
     * Operation getAuditLogsWithHttpInfo
     *
     * Get audit logs
     *
     * @param int $size Maximum number of entries to return (optional)
     * @param int $from For pagination, starting offset (optional)
     * @param string $action_type Event action type (optional)
     * @param string $actor_type Event actor type (optional)
     * @param string $actor_id Actor (User or App) Identifier (optional)
     * @param string $object_id Object (User or App) Identifier for event (optional)
     * @param string $severity Event severity type (optional)
     * @param int $range_from Starting time for search , this is EPOCH value (optional)
     * @param int $range_to Ending time for search , this is EPOCH value (optional)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\AuditLogResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function getAuditLogsWithHttpInfo($size = null, $from = null, $action_type = null, $actor_type = null, $actor_id = null, $object_id = null, $severity = null, $range_from = null, $range_to = null)
    {
        // parse inputs
        $resourcePath = "/sys/v1/logs";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // query params
        if ($size !== null) {
            $queryParams['size'] = $this->apiClient->getSerializer()->toQueryValue($size);
        }
        // query params
        if ($from !== null) {
            $queryParams['from'] = $this->apiClient->getSerializer()->toQueryValue($from);
        }
        // query params
        if ($action_type !== null) {
            $queryParams['action_type'] = $this->apiClient->getSerializer()->toQueryValue($action_type);
        }
        // query params
        if ($actor_type !== null) {
            $queryParams['actor_type'] = $this->apiClient->getSerializer()->toQueryValue($actor_type);
        }
        // query params
        if ($actor_id !== null) {
            $queryParams['actor_id'] = $this->apiClient->getSerializer()->toQueryValue($actor_id);
        }
        // query params
        if ($object_id !== null) {
            $queryParams['object_id'] = $this->apiClient->getSerializer()->toQueryValue($object_id);
        }
        // query params
        if ($severity !== null) {
            $queryParams['severity'] = $this->apiClient->getSerializer()->toQueryValue($severity);
        }
        // query params
        if ($range_from !== null) {
            $queryParams['range_from'] = $this->apiClient->getSerializer()->toQueryValue($range_from);
        }
        // query params
        if ($range_to !== null) {
            $queryParams['range_to'] = $this->apiClient->getSerializer()->toQueryValue($range_to);
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\AuditLogResponse',
                '/sys/v1/logs'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\AuditLogResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\AuditLogResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
