<?php
/**
 * PluginsApi
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Api;

use \SdkmsClient\ApiClient;
use \SdkmsClient\ApiException;
use \SdkmsClient\Configuration;
use \SdkmsClient\ObjectSerializer;

/**
 * PluginsApi Class Doc Comment
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class PluginsApi
{
    /**
     * API Client
     *
     * @var \SdkmsClient\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \SdkmsClient\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\SdkmsClient\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \SdkmsClient\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \SdkmsClient\ApiClient $apiClient set the API client
     *
     * @return PluginsApi
     */
    public function setApiClient(\SdkmsClient\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation createPlugin
     *
     * Create a new plugin
     *
     * @param \SdkmsClient\Model\PluginRequest $body Properties of plugin to create (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\Plugin
     */
    public function createPlugin($body)
    {
        list($response) = $this->createPluginWithHttpInfo($body);
        return $response;
    }

    /**
     * Operation createPluginWithHttpInfo
     *
     * Create a new plugin
     *
     * @param \SdkmsClient\Model\PluginRequest $body Properties of plugin to create (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\Plugin, HTTP status code, HTTP response headers (array of strings)
     */
    public function createPluginWithHttpInfo($body)
    {
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling createPlugin');
        }
        // parse inputs
        $resourcePath = "/sys/v1/plugins";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\Plugin',
                '/sys/v1/plugins'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\Plugin', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 201:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Plugin', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation deletePlugin
     *
     * Delete plugin
     *
     * @param string $plugin_id Plugin Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return void
     */
    public function deletePlugin($plugin_id)
    {
        list($response) = $this->deletePluginWithHttpInfo($plugin_id);
        return $response;
    }

    /**
     * Operation deletePluginWithHttpInfo
     *
     * Delete plugin
     *
     * @param string $plugin_id Plugin Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function deletePluginWithHttpInfo($plugin_id)
    {
        // verify the required parameter 'plugin_id' is set
        if ($plugin_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $plugin_id when calling deletePlugin');
        }
        // parse inputs
        $resourcePath = "/sys/v1/plugins/{plugin-id}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($plugin_id !== null) {
            $resourcePath = str_replace(
                "{" . "plugin-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($plugin_id),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'DELETE',
                $queryParams,
                $httpBody,
                $headerParams,
                null,
                '/sys/v1/plugins/{plugin-id}'
            );

            return [null, $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getPlugin
     *
     * Get a specific plugin
     *
     * @param string $plugin_id Plugin Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\Plugin
     */
    public function getPlugin($plugin_id)
    {
        list($response) = $this->getPluginWithHttpInfo($plugin_id);
        return $response;
    }

    /**
     * Operation getPluginWithHttpInfo
     *
     * Get a specific plugin
     *
     * @param string $plugin_id Plugin Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\Plugin, HTTP status code, HTTP response headers (array of strings)
     */
    public function getPluginWithHttpInfo($plugin_id)
    {
        // verify the required parameter 'plugin_id' is set
        if ($plugin_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $plugin_id when calling getPlugin');
        }
        // parse inputs
        $resourcePath = "/sys/v1/plugins/{plugin-id}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($plugin_id !== null) {
            $resourcePath = str_replace(
                "{" . "plugin-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($plugin_id),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\Plugin',
                '/sys/v1/plugins/{plugin-id}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\Plugin', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Plugin', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getPlugins
     *
     * Get all plugins
     *
     * @param string $group_id Only retrieve plugins in the specified group. (optional)
     * @param string $sort This specifies the property (&#x60;plugin_id&#x60; only, for now) and order (ascending or descending) with which to sort the apps. By default, plugins are sorted by &#x60;plugin_id&#x60; in ascending order. The syntax is \&quot;&lt;property&gt;:[asc|desc]\&quot; (e.g. \&quot;plugin_id:desc\&quot;) or just \&quot;&lt;property&gt;\&quot; (ascending order by default). (optional)
     * @param string $start If provided, this must be a value of the property specified in &#x60;sort&#x60;. Returned apps will begin just above or just below this value (for asc/desc order resp.). (optional)
     * @param int $limit Maximum number of apps to return. If not provided, the limit is 100. (optional)
     * @param int $offset Number of apps past &#x60;start&#x60; to skip. (optional)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\Plugin[]
     */
    public function getPlugins($group_id = null, $sort = null, $start = null, $limit = null, $offset = null)
    {
        list($response) = $this->getPluginsWithHttpInfo($group_id, $sort, $start, $limit, $offset);
        return $response;
    }

    /**
     * Operation getPluginsWithHttpInfo
     *
     * Get all plugins
     *
     * @param string $group_id Only retrieve plugins in the specified group. (optional)
     * @param string $sort This specifies the property (&#x60;plugin_id&#x60; only, for now) and order (ascending or descending) with which to sort the apps. By default, plugins are sorted by &#x60;plugin_id&#x60; in ascending order. The syntax is \&quot;&lt;property&gt;:[asc|desc]\&quot; (e.g. \&quot;plugin_id:desc\&quot;) or just \&quot;&lt;property&gt;\&quot; (ascending order by default). (optional)
     * @param string $start If provided, this must be a value of the property specified in &#x60;sort&#x60;. Returned apps will begin just above or just below this value (for asc/desc order resp.). (optional)
     * @param int $limit Maximum number of apps to return. If not provided, the limit is 100. (optional)
     * @param int $offset Number of apps past &#x60;start&#x60; to skip. (optional)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\Plugin[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getPluginsWithHttpInfo($group_id = null, $sort = null, $start = null, $limit = null, $offset = null)
    {
        // parse inputs
        $resourcePath = "/sys/v1/plugins";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // query params
        if ($group_id !== null) {
            $queryParams['group_id'] = $this->apiClient->getSerializer()->toQueryValue($group_id);
        }
        // query params
        if ($sort !== null) {
            $queryParams['sort'] = $this->apiClient->getSerializer()->toQueryValue($sort);
        }
        // query params
        if ($start !== null) {
            $queryParams['start'] = $this->apiClient->getSerializer()->toQueryValue($start);
        }
        // query params
        if ($limit !== null) {
            $queryParams['limit'] = $this->apiClient->getSerializer()->toQueryValue($limit);
        }
        // query params
        if ($offset !== null) {
            $queryParams['offset'] = $this->apiClient->getSerializer()->toQueryValue($offset);
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\Plugin[]',
                '/sys/v1/plugins'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\Plugin[]', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Plugin[]', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation invokePlugin
     *
     * Invoke a plugin
     *
     * @param string $plugin_id Plugin Identifier (required)
     * @param \SdkmsClient\Model\PluginInvokeRequest $body Object to be passed to plugin as input (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\PluginInvokeResponse
     */
    public function invokePlugin($plugin_id, $body)
    {
        list($response) = $this->invokePluginWithHttpInfo($plugin_id, $body);
        return $response;
    }

    /**
     * Operation invokePluginWithHttpInfo
     *
     * Invoke a plugin
     *
     * @param string $plugin_id Plugin Identifier (required)
     * @param \SdkmsClient\Model\PluginInvokeRequest $body Object to be passed to plugin as input (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\PluginInvokeResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function invokePluginWithHttpInfo($plugin_id, $body)
    {
        // verify the required parameter 'plugin_id' is set
        if ($plugin_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $plugin_id when calling invokePlugin');
        }
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling invokePlugin');
        }
        // parse inputs
        $resourcePath = "/sys/v1/plugins/{plugin-id}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($plugin_id !== null) {
            $resourcePath = str_replace(
                "{" . "plugin-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($plugin_id),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\PluginInvokeResponse',
                '/sys/v1/plugins/{plugin-id}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\PluginInvokeResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\PluginInvokeResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation sysV1PluginsInvokePluginIdGet
     *
     * Invoke a plugin using GET.
     *
     * @param string $plugin_id Plugin Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\PluginInvokeResponse
     */
    public function sysV1PluginsInvokePluginIdGet($plugin_id)
    {
        list($response) = $this->sysV1PluginsInvokePluginIdGetWithHttpInfo($plugin_id);
        return $response;
    }

    /**
     * Operation sysV1PluginsInvokePluginIdGetWithHttpInfo
     *
     * Invoke a plugin using GET.
     *
     * @param string $plugin_id Plugin Identifier (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\PluginInvokeResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function sysV1PluginsInvokePluginIdGetWithHttpInfo($plugin_id)
    {
        // verify the required parameter 'plugin_id' is set
        if ($plugin_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $plugin_id when calling sysV1PluginsInvokePluginIdGet');
        }
        // parse inputs
        $resourcePath = "/sys/v1/plugins/invoke/{plugin-id}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($plugin_id !== null) {
            $resourcePath = str_replace(
                "{" . "plugin-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($plugin_id),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\PluginInvokeResponse',
                '/sys/v1/plugins/invoke/{plugin-id}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\PluginInvokeResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\PluginInvokeResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation updatePlugin
     *
     * Update a plugin
     *
     * @param string $plugin_id Plugin Identifier (required)
     * @param \SdkmsClient\Model\PluginRequest $body Properties of plugin to create (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return \SdkmsClient\Model\App
     */
    public function updatePlugin($plugin_id, $body)
    {
        list($response) = $this->updatePluginWithHttpInfo($plugin_id, $body);
        return $response;
    }

    /**
     * Operation updatePluginWithHttpInfo
     *
     * Update a plugin
     *
     * @param string $plugin_id Plugin Identifier (required)
     * @param \SdkmsClient\Model\PluginRequest $body Properties of plugin to create (required)
     * @throws \SdkmsClient\ApiException on non-2xx response
     * @return array of \SdkmsClient\Model\App, HTTP status code, HTTP response headers (array of strings)
     */
    public function updatePluginWithHttpInfo($plugin_id, $body)
    {
        // verify the required parameter 'plugin_id' is set
        if ($plugin_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $plugin_id when calling updatePlugin');
        }
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling updatePlugin');
        }
        // parse inputs
        $resourcePath = "/sys/v1/plugins/{plugin-id}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($plugin_id !== null) {
            $resourcePath = str_replace(
                "{" . "plugin-id" . "}",
                $this->apiClient->getSerializer()->toPathValue($plugin_id),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires API key authentication
        $apiKey = $this->apiClient->getApiKeyWithPrefix('Authorization');
        if (strlen($apiKey) !== 0) {
            $headerParams['Authorization'] = $apiKey;
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'PATCH',
                $queryParams,
                $httpBody,
                $headerParams,
                '\SdkmsClient\Model\App',
                '/sys/v1/plugins/{plugin-id}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\SdkmsClient\Model\App', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\App', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\SdkmsClient\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
