<?php
/**
 * Account
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * Account Class Doc Comment
 *
 * @category    Class
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class Account implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'Account';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'name' => 'string',
        'acct_id' => 'string',
        'description' => 'string',
        'organization' => 'string',
        'country' => 'string',
        'phone' => 'string',
        'notification_pref' => '\SdkmsClient\Model\NotificationPref',
        'auth_config' => '\SdkmsClient\Model\AuthConfig',
        'subscription' => '\SdkmsClient\Model\SubscriptionType',
        'state' => '\SdkmsClient\Model\AccountState',
        'auth_type' => '\SdkmsClient\Model\AuthType',
        'logging_configs' => 'map[string,\SdkmsClient\Model\LoggingConfig]',
        'enabled' => 'bool',
        'created_at' => 'string',
        'initial_purchase_at' => 'string',
        'pending_subscription_change_request' => '\SdkmsClient\Model\SubscriptionChangeRequest',
        'custom_metadata' => 'map[string,string]',
        'key_undo_policy' => '\SdkmsClient\Model\KeyUndoPolicy'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'name' => null,
        'acct_id' => null,
        'description' => null,
        'organization' => null,
        'country' => null,
        'phone' => null,
        'notification_pref' => null,
        'auth_config' => null,
        'subscription' => null,
        'state' => null,
        'auth_type' => null,
        'logging_configs' => null,
        'enabled' => null,
        'created_at' => 'dateTime',
        'initial_purchase_at' => 'dateTime',
        'pending_subscription_change_request' => null,
        'custom_metadata' => null,
        'key_undo_policy' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'name' => 'name',
        'acct_id' => 'acct_id',
        'description' => 'description',
        'organization' => 'organization',
        'country' => 'country',
        'phone' => 'phone',
        'notification_pref' => 'notification_pref',
        'auth_config' => 'auth_config',
        'subscription' => 'subscription',
        'state' => 'state',
        'auth_type' => 'auth_type',
        'logging_configs' => 'logging_configs',
        'enabled' => 'enabled',
        'created_at' => 'created_at',
        'initial_purchase_at' => 'initial_purchase_at',
        'pending_subscription_change_request' => 'pending_subscription_change_request',
        'custom_metadata' => 'custom_metadata',
        'key_undo_policy' => 'key_undo_policy'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'name' => 'setName',
        'acct_id' => 'setAcctId',
        'description' => 'setDescription',
        'organization' => 'setOrganization',
        'country' => 'setCountry',
        'phone' => 'setPhone',
        'notification_pref' => 'setNotificationPref',
        'auth_config' => 'setAuthConfig',
        'subscription' => 'setSubscription',
        'state' => 'setState',
        'auth_type' => 'setAuthType',
        'logging_configs' => 'setLoggingConfigs',
        'enabled' => 'setEnabled',
        'created_at' => 'setCreatedAt',
        'initial_purchase_at' => 'setInitialPurchaseAt',
        'pending_subscription_change_request' => 'setPendingSubscriptionChangeRequest',
        'custom_metadata' => 'setCustomMetadata',
        'key_undo_policy' => 'setKeyUndoPolicy'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'name' => 'getName',
        'acct_id' => 'getAcctId',
        'description' => 'getDescription',
        'organization' => 'getOrganization',
        'country' => 'getCountry',
        'phone' => 'getPhone',
        'notification_pref' => 'getNotificationPref',
        'auth_config' => 'getAuthConfig',
        'subscription' => 'getSubscription',
        'state' => 'getState',
        'auth_type' => 'getAuthType',
        'logging_configs' => 'getLoggingConfigs',
        'enabled' => 'getEnabled',
        'created_at' => 'getCreatedAt',
        'initial_purchase_at' => 'getInitialPurchaseAt',
        'pending_subscription_change_request' => 'getPendingSubscriptionChangeRequest',
        'custom_metadata' => 'getCustomMetadata',
        'key_undo_policy' => 'getKeyUndoPolicy'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['acct_id'] = isset($data['acct_id']) ? $data['acct_id'] : null;
        $this->container['description'] = isset($data['description']) ? $data['description'] : null;
        $this->container['organization'] = isset($data['organization']) ? $data['organization'] : null;
        $this->container['country'] = isset($data['country']) ? $data['country'] : null;
        $this->container['phone'] = isset($data['phone']) ? $data['phone'] : null;
        $this->container['notification_pref'] = isset($data['notification_pref']) ? $data['notification_pref'] : null;
        $this->container['auth_config'] = isset($data['auth_config']) ? $data['auth_config'] : null;
        $this->container['subscription'] = isset($data['subscription']) ? $data['subscription'] : null;
        $this->container['state'] = isset($data['state']) ? $data['state'] : null;
        $this->container['auth_type'] = isset($data['auth_type']) ? $data['auth_type'] : null;
        $this->container['logging_configs'] = isset($data['logging_configs']) ? $data['logging_configs'] : null;
        $this->container['enabled'] = isset($data['enabled']) ? $data['enabled'] : null;
        $this->container['created_at'] = isset($data['created_at']) ? $data['created_at'] : null;
        $this->container['initial_purchase_at'] = isset($data['initial_purchase_at']) ? $data['initial_purchase_at'] : null;
        $this->container['pending_subscription_change_request'] = isset($data['pending_subscription_change_request']) ? $data['pending_subscription_change_request'] : null;
        $this->container['custom_metadata'] = isset($data['custom_metadata']) ? $data['custom_metadata'] : null;
        $this->container['key_undo_policy'] = isset($data['key_undo_policy']) ? $data['key_undo_policy'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['name'] === null) {
            $invalid_properties[] = "'name' can't be null";
        }
        if ($this->container['acct_id'] === null) {
            $invalid_properties[] = "'acct_id' can't be null";
        }
        if ($this->container['subscription'] === null) {
            $invalid_properties[] = "'subscription' can't be null";
        }
        if ($this->container['state'] === null) {
            $invalid_properties[] = "'state' can't be null";
        }
        if ($this->container['auth_type'] === null) {
            $invalid_properties[] = "'auth_type' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['name'] === null) {
            return false;
        }
        if ($this->container['acct_id'] === null) {
            return false;
        }
        if ($this->container['subscription'] === null) {
            return false;
        }
        if ($this->container['state'] === null) {
            return false;
        }
        if ($this->container['auth_type'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     * @param string $name Name of the account. Account names must be unique within an SDKMS instance.
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets acct_id
     * @return string
     */
    public function getAcctId()
    {
        return $this->container['acct_id'];
    }

    /**
     * Sets acct_id
     * @param string $acct_id Account ID uniquely identifying this account.
     * @return $this
     */
    public function setAcctId($acct_id)
    {
        $this->container['acct_id'] = $acct_id;

        return $this;
    }

    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     * @param string $description Description of this account.
     * @return $this
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets organization
     * @return string
     */
    public function getOrganization()
    {
        return $this->container['organization'];
    }

    /**
     * Sets organization
     * @param string $organization Organization (e.g. company name) that owns this account
     * @return $this
     */
    public function setOrganization($organization)
    {
        $this->container['organization'] = $organization;

        return $this;
    }

    /**
     * Gets country
     * @return string
     */
    public function getCountry()
    {
        return $this->container['country'];
    }

    /**
     * Sets country
     * @param string $country Main country associated with this account
     * @return $this
     */
    public function setCountry($country)
    {
        $this->container['country'] = $country;

        return $this;
    }

    /**
     * Gets phone
     * @return string
     */
    public function getPhone()
    {
        return $this->container['phone'];
    }

    /**
     * Sets phone
     * @param string $phone Contact phone number associated with this account
     * @return $this
     */
    public function setPhone($phone)
    {
        $this->container['phone'] = $phone;

        return $this;
    }

    /**
     * Gets notification_pref
     * @return \SdkmsClient\Model\NotificationPref
     */
    public function getNotificationPref()
    {
        return $this->container['notification_pref'];
    }

    /**
     * Sets notification_pref
     * @param \SdkmsClient\Model\NotificationPref $notification_pref
     * @return $this
     */
    public function setNotificationPref($notification_pref)
    {
        $this->container['notification_pref'] = $notification_pref;

        return $this;
    }

    /**
     * Gets auth_config
     * @return \SdkmsClient\Model\AuthConfig
     */
    public function getAuthConfig()
    {
        return $this->container['auth_config'];
    }

    /**
     * Sets auth_config
     * @param \SdkmsClient\Model\AuthConfig $auth_config
     * @return $this
     */
    public function setAuthConfig($auth_config)
    {
        $this->container['auth_config'] = $auth_config;

        return $this;
    }

    /**
     * Gets subscription
     * @return \SdkmsClient\Model\SubscriptionType
     */
    public function getSubscription()
    {
        return $this->container['subscription'];
    }

    /**
     * Sets subscription
     * @param \SdkmsClient\Model\SubscriptionType $subscription
     * @return $this
     */
    public function setSubscription($subscription)
    {
        $this->container['subscription'] = $subscription;

        return $this;
    }

    /**
     * Gets state
     * @return \SdkmsClient\Model\AccountState
     */
    public function getState()
    {
        return $this->container['state'];
    }

    /**
     * Sets state
     * @param \SdkmsClient\Model\AccountState $state
     * @return $this
     */
    public function setState($state)
    {
        $this->container['state'] = $state;

        return $this;
    }

    /**
     * Gets auth_type
     * @return \SdkmsClient\Model\AuthType
     */
    public function getAuthType()
    {
        return $this->container['auth_type'];
    }

    /**
     * Sets auth_type
     * @param \SdkmsClient\Model\AuthType $auth_type
     * @return $this
     */
    public function setAuthType($auth_type)
    {
        $this->container['auth_type'] = $auth_type;

        return $this;
    }

    /**
     * Gets logging_configs
     * @return map[string,\SdkmsClient\Model\LoggingConfig]
     */
    public function getLoggingConfigs()
    {
        return $this->container['logging_configs'];
    }

    /**
     * Sets logging_configs
     * @param map[string,\SdkmsClient\Model\LoggingConfig] $logging_configs Map from UUIDs to LoggingConfig objects
     * @return $this
     */
    public function setLoggingConfigs($logging_configs)
    {
        $this->container['logging_configs'] = $logging_configs;

        return $this;
    }

    /**
     * Gets enabled
     * @return bool
     */
    public function getEnabled()
    {
        return $this->container['enabled'];
    }

    /**
     * Sets enabled
     * @param bool $enabled Whether this account is enabled. This may only be changed by sysadmins.
     * @return $this
     */
    public function setEnabled($enabled)
    {
        $this->container['enabled'] = $enabled;

        return $this;
    }

    /**
     * Gets created_at
     * @return string
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     * @param string $created_at When this account was created.
     * @return $this
     */
    public function setCreatedAt($created_at)
    {
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets initial_purchase_at
     * @return string
     */
    public function getInitialPurchaseAt()
    {
        return $this->container['initial_purchase_at'];
    }

    /**
     * Sets initial_purchase_at
     * @param string $initial_purchase_at When this accout was upgraded a paid subscription.
     * @return $this
     */
    public function setInitialPurchaseAt($initial_purchase_at)
    {
        $this->container['initial_purchase_at'] = $initial_purchase_at;

        return $this;
    }

    /**
     * Gets pending_subscription_change_request
     * @return \SdkmsClient\Model\SubscriptionChangeRequest
     */
    public function getPendingSubscriptionChangeRequest()
    {
        return $this->container['pending_subscription_change_request'];
    }

    /**
     * Sets pending_subscription_change_request
     * @param \SdkmsClient\Model\SubscriptionChangeRequest $pending_subscription_change_request
     * @return $this
     */
    public function setPendingSubscriptionChangeRequest($pending_subscription_change_request)
    {
        $this->container['pending_subscription_change_request'] = $pending_subscription_change_request;

        return $this;
    }

    /**
     * Gets custom_metadata
     * @return map[string,string]
     */
    public function getCustomMetadata()
    {
        return $this->container['custom_metadata'];
    }

    /**
     * Sets custom_metadata
     * @param map[string,string] $custom_metadata Sysadmin-defined metadata for this account. Stored as key-value pairs. This field is only visible to sysadmin users.
     * @return $this
     */
    public function setCustomMetadata($custom_metadata)
    {
        $this->container['custom_metadata'] = $custom_metadata;

        return $this;
    }

    /**
     * Gets key_undo_policy
     * @return \SdkmsClient\Model\KeyUndoPolicy
     */
    public function getKeyUndoPolicy()
    {
        return $this->container['key_undo_policy'];
    }

    /**
     * Sets key_undo_policy
     * @param \SdkmsClient\Model\KeyUndoPolicy $key_undo_policy
     * @return $this
     */
    public function setKeyUndoPolicy($key_undo_policy)
    {
        $this->container['key_undo_policy'] = $key_undo_policy;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


