<?php
/**
 * AppRequest
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * AppRequest Class Doc Comment
 *
 * @category    Class
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class AppRequest implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'AppRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'name' => 'string',
        'description' => 'string',
        'add_groups' => 'map[string,\SdkmsClient\Model\AppPermissions[]]',
        'del_groups' => 'string[]',
        'mod_groups' => 'map[string,\SdkmsClient\Model\AppPermissions[]]',
        'default_group' => 'string',
        'enabled' => 'bool',
        'app_oauth_config' => '\SdkmsClient\Model\AppOauthConfig',
        'interface' => 'string',
        'app_type' => 'string',
        'credential' => '\SdkmsClient\Model\AppCredential',
        'secret_size' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'name' => null,
        'description' => null,
        'add_groups' => null,
        'del_groups' => null,
        'mod_groups' => null,
        'default_group' => null,
        'enabled' => null,
        'app_oauth_config' => null,
        'interface' => null,
        'app_type' => null,
        'credential' => null,
        'secret_size' => 'int32'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'name' => 'name',
        'description' => 'description',
        'add_groups' => 'add_groups',
        'del_groups' => 'del_groups',
        'mod_groups' => 'mod_groups',
        'default_group' => 'default_group',
        'enabled' => 'enabled',
        'app_oauth_config' => 'AppOauthConfig',
        'interface' => 'interface',
        'app_type' => 'app_type',
        'credential' => 'credential',
        'secret_size' => 'secret_size'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'name' => 'setName',
        'description' => 'setDescription',
        'add_groups' => 'setAddGroups',
        'del_groups' => 'setDelGroups',
        'mod_groups' => 'setModGroups',
        'default_group' => 'setDefaultGroup',
        'enabled' => 'setEnabled',
        'app_oauth_config' => 'setAppOauthConfig',
        'interface' => 'setInterface',
        'app_type' => 'setAppType',
        'credential' => 'setCredential',
        'secret_size' => 'setSecretSize'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'name' => 'getName',
        'description' => 'getDescription',
        'add_groups' => 'getAddGroups',
        'del_groups' => 'getDelGroups',
        'mod_groups' => 'getModGroups',
        'default_group' => 'getDefaultGroup',
        'enabled' => 'getEnabled',
        'app_oauth_config' => 'getAppOauthConfig',
        'interface' => 'getInterface',
        'app_type' => 'getAppType',
        'credential' => 'getCredential',
        'secret_size' => 'getSecretSize'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['description'] = isset($data['description']) ? $data['description'] : null;
        $this->container['add_groups'] = isset($data['add_groups']) ? $data['add_groups'] : null;
        $this->container['del_groups'] = isset($data['del_groups']) ? $data['del_groups'] : null;
        $this->container['mod_groups'] = isset($data['mod_groups']) ? $data['mod_groups'] : null;
        $this->container['default_group'] = isset($data['default_group']) ? $data['default_group'] : null;
        $this->container['enabled'] = isset($data['enabled']) ? $data['enabled'] : null;
        $this->container['app_oauth_config'] = isset($data['app_oauth_config']) ? $data['app_oauth_config'] : null;
        $this->container['interface'] = isset($data['interface']) ? $data['interface'] : null;
        $this->container['app_type'] = isset($data['app_type']) ? $data['app_type'] : null;
        $this->container['credential'] = isset($data['credential']) ? $data['credential'] : null;
        $this->container['secret_size'] = isset($data['secret_size']) ? $data['secret_size'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['name'] === null) {
            $invalid_properties[] = "'name' can't be null";
        }
        if ($this->container['add_groups'] === null) {
            $invalid_properties[] = "'add_groups' can't be null";
        }
        if ($this->container['default_group'] === null) {
            $invalid_properties[] = "'default_group' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['name'] === null) {
            return false;
        }
        if ($this->container['add_groups'] === null) {
            return false;
        }
        if ($this->container['default_group'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     * @param string $name Name of this application. Application names must be unique within an account.
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     * @param string $description Description of this application.
     * @return $this
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets add_groups
     * @return map[string,\SdkmsClient\Model\AppPermissions[]]
     */
    public function getAddGroups()
    {
        return $this->container['add_groups'];
    }

    /**
     * Sets add_groups
     * @param map[string,\SdkmsClient\Model\AppPermissions[]] $add_groups Map from UUIDs to group permissions
     * @return $this
     */
    public function setAddGroups($add_groups)
    {
        $this->container['add_groups'] = $add_groups;

        return $this;
    }

    /**
     * Gets del_groups
     * @return string[]
     */
    public function getDelGroups()
    {
        return $this->container['del_groups'];
    }

    /**
     * Sets del_groups
     * @param string[] $del_groups Array of UUID of group
     * @return $this
     */
    public function setDelGroups($del_groups)
    {
        $this->container['del_groups'] = $del_groups;

        return $this;
    }

    /**
     * Gets mod_groups
     * @return map[string,\SdkmsClient\Model\AppPermissions[]]
     */
    public function getModGroups()
    {
        return $this->container['mod_groups'];
    }

    /**
     * Sets mod_groups
     * @param map[string,\SdkmsClient\Model\AppPermissions[]] $mod_groups Map from UUIDs to group permissions
     * @return $this
     */
    public function setModGroups($mod_groups)
    {
        $this->container['mod_groups'] = $mod_groups;

        return $this;
    }

    /**
     * Gets default_group
     * @return string
     */
    public function getDefaultGroup()
    {
        return $this->container['default_group'];
    }

    /**
     * Sets default_group
     * @param string $default_group The default group of this application. This is the group where security objects will be created by default by this application.
     * @return $this
     */
    public function setDefaultGroup($default_group)
    {
        $this->container['default_group'] = $default_group;

        return $this;
    }

    /**
     * Gets enabled
     * @return bool
     */
    public function getEnabled()
    {
        return $this->container['enabled'];
    }

    /**
     * Sets enabled
     * @param bool $enabled Whether this application is enabled
     * @return $this
     */
    public function setEnabled($enabled)
    {
        $this->container['enabled'] = $enabled;

        return $this;
    }

    /**
     * Gets app_oauth_config
     * @return \SdkmsClient\Model\AppOauthConfig
     */
    public function getAppOauthConfig()
    {
        return $this->container['app_oauth_config'];
    }

    /**
     * Sets app_oauth_config
     * @param \SdkmsClient\Model\AppOauthConfig $app_oauth_config
     * @return $this
     */
    public function setAppOauthConfig($app_oauth_config)
    {
        $this->container['app_oauth_config'] = $app_oauth_config;

        return $this;
    }

    /**
     * Gets interface
     * @return string
     */
    public function getInterface()
    {
        return $this->container['interface'];
    }

    /**
     * Sets interface
     * @param string $interface Interface used with this application (PKCS11, CNG, JCE, KMIP, etc.).
     * @return $this
     */
    public function setInterface($interface)
    {
        $this->container['interface'] = $interface;

        return $this;
    }

    /**
     * Gets app_type
     * @return string
     */
    public function getAppType()
    {
        return $this->container['app_type'];
    }

    /**
     * Sets app_type
     * @param string $app_type The user-defined type of this application.
     * @return $this
     */
    public function setAppType($app_type)
    {
        $this->container['app_type'] = $app_type;

        return $this;
    }

    /**
     * Gets credential
     * @return \SdkmsClient\Model\AppCredential
     */
    public function getCredential()
    {
        return $this->container['credential'];
    }

    /**
     * Sets credential
     * @param \SdkmsClient\Model\AppCredential $credential
     * @return $this
     */
    public function setCredential($credential)
    {
        $this->container['credential'] = $credential;

        return $this;
    }

    /**
     * Gets secret_size
     * @return int
     */
    public function getSecretSize()
    {
        return $this->container['secret_size'];
    }

    /**
     * Sets secret_size
     * @param int $secret_size Size in bytes of app's secret.
     * @return $this
     */
    public function setSecretSize($secret_size)
    {
        $this->container['secret_size'] = $secret_size;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


