<?php
/**
 * ChildAccountUserRequest
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * ChildAccountUserRequest Class Doc Comment
 *
 * @category    Class
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class ChildAccountUserRequest implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'ChildAccountUserRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'child_acct_id' => 'string',
        'user_email' => 'string',
        'account_role' => '\SdkmsClient\Model\UserAccountFlags[]',
        'add_groups' => '\SdkmsClient\Model\UserGroupMap',
        'del_groups' => '\SdkmsClient\Model\UserGroupMap',
        'mod_groups' => '\SdkmsClient\Model\UserGroupMap',
        'enabled' => 'bool'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'child_acct_id' => null,
        'user_email' => null,
        'account_role' => null,
        'add_groups' => null,
        'del_groups' => null,
        'mod_groups' => null,
        'enabled' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'child_acct_id' => 'child_acct_id',
        'user_email' => 'user_email',
        'account_role' => 'account_role',
        'add_groups' => 'add_groups',
        'del_groups' => 'del_groups',
        'mod_groups' => 'mod_groups',
        'enabled' => 'enabled'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'child_acct_id' => 'setChildAcctId',
        'user_email' => 'setUserEmail',
        'account_role' => 'setAccountRole',
        'add_groups' => 'setAddGroups',
        'del_groups' => 'setDelGroups',
        'mod_groups' => 'setModGroups',
        'enabled' => 'setEnabled'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'child_acct_id' => 'getChildAcctId',
        'user_email' => 'getUserEmail',
        'account_role' => 'getAccountRole',
        'add_groups' => 'getAddGroups',
        'del_groups' => 'getDelGroups',
        'mod_groups' => 'getModGroups',
        'enabled' => 'getEnabled'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['child_acct_id'] = isset($data['child_acct_id']) ? $data['child_acct_id'] : null;
        $this->container['user_email'] = isset($data['user_email']) ? $data['user_email'] : null;
        $this->container['account_role'] = isset($data['account_role']) ? $data['account_role'] : null;
        $this->container['add_groups'] = isset($data['add_groups']) ? $data['add_groups'] : null;
        $this->container['del_groups'] = isset($data['del_groups']) ? $data['del_groups'] : null;
        $this->container['mod_groups'] = isset($data['mod_groups']) ? $data['mod_groups'] : null;
        $this->container['enabled'] = isset($data['enabled']) ? $data['enabled'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['child_acct_id'] === null) {
            $invalid_properties[] = "'child_acct_id' can't be null";
        }
        if ($this->container['user_email'] === null) {
            $invalid_properties[] = "'user_email' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['child_acct_id'] === null) {
            return false;
        }
        if ($this->container['user_email'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets child_acct_id
     * @return string
     */
    public function getChildAcctId()
    {
        return $this->container['child_acct_id'];
    }

    /**
     * Sets child_acct_id
     * @param string $child_acct_id Account id of child account
     * @return $this
     */
    public function setChildAcctId($child_acct_id)
    {
        $this->container['child_acct_id'] = $child_acct_id;

        return $this;
    }

    /**
     * Gets user_email
     * @return string
     */
    public function getUserEmail()
    {
        return $this->container['user_email'];
    }

    /**
     * Sets user_email
     * @param string $user_email User's email address.
     * @return $this
     */
    public function setUserEmail($user_email)
    {
        $this->container['user_email'] = $user_email;

        return $this;
    }

    /**
     * Gets account_role
     * @return \SdkmsClient\Model\UserAccountFlags[]
     */
    public function getAccountRole()
    {
        return $this->container['account_role'];
    }

    /**
     * Sets account_role
     * @param \SdkmsClient\Model\UserAccountFlags[] $account_role
     * @return $this
     */
    public function setAccountRole($account_role)
    {
        $this->container['account_role'] = $account_role;

        return $this;
    }

    /**
     * Gets add_groups
     * @return \SdkmsClient\Model\UserGroupMap
     */
    public function getAddGroups()
    {
        return $this->container['add_groups'];
    }

    /**
     * Sets add_groups
     * @param \SdkmsClient\Model\UserGroupMap $add_groups The user will be added to the specified security groups with the specified roles.
     * @return $this
     */
    public function setAddGroups($add_groups)
    {
        $this->container['add_groups'] = $add_groups;

        return $this;
    }

    /**
     * Gets del_groups
     * @return \SdkmsClient\Model\UserGroupMap
     */
    public function getDelGroups()
    {
        return $this->container['del_groups'];
    }

    /**
     * Sets del_groups
     * @param \SdkmsClient\Model\UserGroupMap $del_groups The user will be removed from the specified security groups.
     * @return $this
     */
    public function setDelGroups($del_groups)
    {
        $this->container['del_groups'] = $del_groups;

        return $this;
    }

    /**
     * Gets mod_groups
     * @return \SdkmsClient\Model\UserGroupMap
     */
    public function getModGroups()
    {
        return $this->container['mod_groups'];
    }

    /**
     * Sets mod_groups
     * @param \SdkmsClient\Model\UserGroupMap $mod_groups The user's role in the specified groups will be updated to the specified roles.
     * @return $this
     */
    public function setModGroups($mod_groups)
    {
        $this->container['mod_groups'] = $mod_groups;

        return $this;
    }

    /**
     * Gets enabled
     * @return bool
     */
    public function getEnabled()
    {
        return $this->container['enabled'];
    }

    /**
     * Sets enabled
     * @param bool $enabled Whether this application is enabled.
     * @return $this
     */
    public function setEnabled($enabled)
    {
        $this->container['enabled'] = $enabled;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


