<?php
/**
 * DigestAlgorithm
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

/**
 * DigestAlgorithm Class Doc Comment
 *
 * @category    Class
 * @description Message digest algorithm.
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class DigestAlgorithm
{
    /**
     * Possible values of this enum
     */
    const BLAKE2B256 = 'Blake2b256';
    const BLAKE2B384 = 'Blake2b384';
    const BLAKE2B512 = 'Blake2b512';
    const BLAKE2S256 = 'Blake2s256';
    const RIPEMD160 = 'RIPEMD160';
    const SHA1 = 'SHA1';
    const SHA256 = 'SHA256';
    const SHA384 = 'SHA384';
    const SHA512 = 'SHA512';
    const SHA3_224 = 'SHA3_224';
    const SHA3_256 = 'SHA3_256';
    const SHA3_384 = 'SHA3_384';
    const SHA3_512 = 'SHA3_512';
    const SSL3 = 'Ssl3';
    const STREEBOG256 = 'Streebog256';
    const STREEBOG512 = 'Streebog512';
    
    /**
     * Gets allowable values of the enum
     * @return string[]
     */
    public static function getAllowableEnumValues()
    {
        return [
            self::BLAKE2B256,
            self::BLAKE2B384,
            self::BLAKE2B512,
            self::BLAKE2S256,
            self::RIPEMD160,
            self::SHA1,
            self::SHA256,
            self::SHA384,
            self::SHA512,
            self::SHA3_224,
            self::SHA3_256,
            self::SHA3_384,
            self::SHA3_512,
            self::SSL3,
            self::STREEBOG256,
            self::STREEBOG512,
        ];
    }
}


