<?php
/**
 * EllipticCurve
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

/**
 * EllipticCurve Class Doc Comment
 *
 * @category    Class
 * @description Identifies a standardized elliptic curve. Required for operations involving EC keys.
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class EllipticCurve
{
    /**
     * Possible values of this enum
     */
    const SEC_P192_K1 = 'SecP192K1';
    const SEC_P224_K1 = 'SecP224K1';
    const SEC_P256_K1 = 'SecP256K1';
    const NIST_P192 = 'NistP192';
    const NIST_P224 = 'NistP224';
    const NIST_P256 = 'NistP256';
    const NIST_P384 = 'NistP384';
    const NIST_P521 = 'NistP521';
    const GOST256_A = 'Gost256A';
    const ED25519 = 'Ed25519';
    const X25519 = 'X25519';
    const X448 = 'X448';
    
    /**
     * Gets allowable values of the enum
     * @return string[]
     */
    public static function getAllowableEnumValues()
    {
        return [
            self::SEC_P192_K1,
            self::SEC_P224_K1,
            self::SEC_P256_K1,
            self::NIST_P192,
            self::NIST_P224,
            self::NIST_P256,
            self::NIST_P384,
            self::NIST_P521,
            self::GOST256_A,
            self::ED25519,
            self::X25519,
            self::X448,
        ];
    }
}


