<?php
/**
 * FpeDateBound
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * FpeDateBound Class Doc Comment
 *
 * @category    Class
 * @description A structure for specifying a particular date, used as an upper or lower bound for date parts. Note that depending on the &#x60;FpeDate&#x60; variant used, the &#x60;day&#x60; or &#x60;year&#x60; fields may be ignored. (For example, a Day-Month date would not require a &#x60;year&#x60; field, so specifying a year in a Day-Month date&#39;s upper bound is meaningless.)
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class FpeDateBound implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'FpeDateBound';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'year' => 'int',
        'month' => 'int',
        'day' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'year' => null,
        'month' => null,
        'day' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'year' => 'year',
        'month' => 'month',
        'day' => 'day'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'year' => 'setYear',
        'month' => 'setMonth',
        'day' => 'setDay'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'year' => 'getYear',
        'month' => 'getMonth',
        'day' => 'getDay'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['year'] = isset($data['year']) ? $data['year'] : null;
        $this->container['month'] = isset($data['month']) ? $data['month'] : null;
        $this->container['day'] = isset($data['day']) ? $data['day'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if (!is_null($this->container['year']) && ($this->container['year'] > 99999)) {
            $invalid_properties[] = "invalid value for 'year', must be smaller than or equal to 99999.";
        }

        if (!is_null($this->container['year']) && ($this->container['year'] < 0)) {
            $invalid_properties[] = "invalid value for 'year', must be bigger than or equal to 0.";
        }

        if ($this->container['month'] === null) {
            $invalid_properties[] = "'month' can't be null";
        }
        if (($this->container['month'] > 12)) {
            $invalid_properties[] = "invalid value for 'month', must be smaller than or equal to 12.";
        }

        if (($this->container['month'] < 1)) {
            $invalid_properties[] = "invalid value for 'month', must be bigger than or equal to 1.";
        }

        if (!is_null($this->container['day']) && ($this->container['day'] > 31)) {
            $invalid_properties[] = "invalid value for 'day', must be smaller than or equal to 31.";
        }

        if (!is_null($this->container['day']) && ($this->container['day'] < 1)) {
            $invalid_properties[] = "invalid value for 'day', must be bigger than or equal to 1.";
        }

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['year'] > 99999) {
            return false;
        }
        if ($this->container['year'] < 0) {
            return false;
        }
        if ($this->container['month'] === null) {
            return false;
        }
        if ($this->container['month'] > 12) {
            return false;
        }
        if ($this->container['month'] < 1) {
            return false;
        }
        if ($this->container['day'] > 31) {
            return false;
        }
        if ($this->container['day'] < 1) {
            return false;
        }
        return true;
    }


    /**
     * Gets year
     * @return int
     */
    public function getYear()
    {
        return $this->container['year'];
    }

    /**
     * Sets year
     * @param int $year The year, which should be a number less than 100000. Zero is treated as a leap year.
     * @return $this
     */
    public function setYear($year)
    {

        if (!is_null($year) && ($year > 99999)) {
            throw new \InvalidArgumentException('invalid value for $year when calling FpeDateBound., must be smaller than or equal to 99999.');
        }
        if (!is_null($year) && ($year < 0)) {
            throw new \InvalidArgumentException('invalid value for $year when calling FpeDateBound., must be bigger than or equal to 0.');
        }

        $this->container['year'] = $year;

        return $this;
    }

    /**
     * Gets month
     * @return int
     */
    public function getMonth()
    {
        return $this->container['month'];
    }

    /**
     * Sets month
     * @param int $month The month, which should be a number from 1 to 12.
     * @return $this
     */
    public function setMonth($month)
    {

        if (($month > 12)) {
            throw new \InvalidArgumentException('invalid value for $month when calling FpeDateBound., must be smaller than or equal to 12.');
        }
        if (($month < 1)) {
            throw new \InvalidArgumentException('invalid value for $month when calling FpeDateBound., must be bigger than or equal to 1.');
        }

        $this->container['month'] = $month;

        return $this;
    }

    /**
     * Gets day
     * @return int
     */
    public function getDay()
    {
        return $this->container['day'];
    }

    /**
     * Sets day
     * @param int $day The day, which should be a number from 1 to 31, and must not be out-of-range for the given month. February is considered to be 29 days long, unless the year, if specified, is not a leap year.
     * @return $this
     */
    public function setDay($day)
    {

        if (!is_null($day) && ($day > 31)) {
            throw new \InvalidArgumentException('invalid value for $day when calling FpeDateBound., must be smaller than or equal to 31.');
        }
        if (!is_null($day) && ($day < 1)) {
            throw new \InvalidArgumentException('invalid value for $day when calling FpeDateBound., must be bigger than or equal to 1.');
        }

        $this->container['day'] = $day;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


