<?php
/**
 * HistoryItemState
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * HistoryItemState Class Doc Comment
 *
 * @category    Class
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class HistoryItemState implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'HistoryItemState';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'activation_date' => 'string',
        'revocation_reason' => '\SdkmsClient\Model\RevocationReasonCode',
        'compromise_date' => 'string',
        'deactivation_date' => 'string',
        'destruction_date' => 'string',
        'deletion_date' => 'string',
        'state' => '\SdkmsClient\Model\KeyObjectState',
        'key_ops' => '\SdkmsClient\Model\KeyOperations[]',
        'public_only' => 'bool',
        'rotation_policy' => '\SdkmsClient\Model\RotationPolicy'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'activation_date' => 'dateTime',
        'revocation_reason' => null,
        'compromise_date' => 'dateTime',
        'deactivation_date' => 'dateTime',
        'destruction_date' => 'dateTime',
        'deletion_date' => 'dateTime',
        'state' => null,
        'key_ops' => null,
        'public_only' => null,
        'rotation_policy' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'activation_date' => 'activation_date',
        'revocation_reason' => 'revocation_reason',
        'compromise_date' => 'compromise_date',
        'deactivation_date' => 'deactivation_date',
        'destruction_date' => 'destruction_date',
        'deletion_date' => 'deletion_date',
        'state' => 'state',
        'key_ops' => 'key_ops',
        'public_only' => 'public_only',
        'rotation_policy' => 'rotation_policy'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'activation_date' => 'setActivationDate',
        'revocation_reason' => 'setRevocationReason',
        'compromise_date' => 'setCompromiseDate',
        'deactivation_date' => 'setDeactivationDate',
        'destruction_date' => 'setDestructionDate',
        'deletion_date' => 'setDeletionDate',
        'state' => 'setState',
        'key_ops' => 'setKeyOps',
        'public_only' => 'setPublicOnly',
        'rotation_policy' => 'setRotationPolicy'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'activation_date' => 'getActivationDate',
        'revocation_reason' => 'getRevocationReason',
        'compromise_date' => 'getCompromiseDate',
        'deactivation_date' => 'getDeactivationDate',
        'destruction_date' => 'getDestructionDate',
        'deletion_date' => 'getDeletionDate',
        'state' => 'getState',
        'key_ops' => 'getKeyOps',
        'public_only' => 'getPublicOnly',
        'rotation_policy' => 'getRotationPolicy'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['activation_date'] = isset($data['activation_date']) ? $data['activation_date'] : null;
        $this->container['revocation_reason'] = isset($data['revocation_reason']) ? $data['revocation_reason'] : null;
        $this->container['compromise_date'] = isset($data['compromise_date']) ? $data['compromise_date'] : null;
        $this->container['deactivation_date'] = isset($data['deactivation_date']) ? $data['deactivation_date'] : null;
        $this->container['destruction_date'] = isset($data['destruction_date']) ? $data['destruction_date'] : null;
        $this->container['deletion_date'] = isset($data['deletion_date']) ? $data['deletion_date'] : null;
        $this->container['state'] = isset($data['state']) ? $data['state'] : null;
        $this->container['key_ops'] = isset($data['key_ops']) ? $data['key_ops'] : null;
        $this->container['public_only'] = isset($data['public_only']) ? $data['public_only'] : null;
        $this->container['rotation_policy'] = isset($data['rotation_policy']) ? $data['rotation_policy'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        return true;
    }


    /**
     * Gets activation_date
     * @return string
     */
    public function getActivationDate()
    {
        return $this->container['activation_date'];
    }

    /**
     * Sets activation_date
     * @param string $activation_date When this KeyObject will become active
     * @return $this
     */
    public function setActivationDate($activation_date)
    {
        $this->container['activation_date'] = $activation_date;

        return $this;
    }

    /**
     * Gets revocation_reason
     * @return \SdkmsClient\Model\RevocationReasonCode
     */
    public function getRevocationReason()
    {
        return $this->container['revocation_reason'];
    }

    /**
     * Sets revocation_reason
     * @param \SdkmsClient\Model\RevocationReasonCode $revocation_reason
     * @return $this
     */
    public function setRevocationReason($revocation_reason)
    {
        $this->container['revocation_reason'] = $revocation_reason;

        return $this;
    }

    /**
     * Gets compromise_date
     * @return string
     */
    public function getCompromiseDate()
    {
        return $this->container['compromise_date'];
    }

    /**
     * Sets compromise_date
     * @param string $compromise_date When this security object was compromised.
     * @return $this
     */
    public function setCompromiseDate($compromise_date)
    {
        $this->container['compromise_date'] = $compromise_date;

        return $this;
    }

    /**
     * Gets deactivation_date
     * @return string
     */
    public function getDeactivationDate()
    {
        return $this->container['deactivation_date'];
    }

    /**
     * Sets deactivation_date
     * @param string $deactivation_date When this security object was deactivated
     * @return $this
     */
    public function setDeactivationDate($deactivation_date)
    {
        $this->container['deactivation_date'] = $deactivation_date;

        return $this;
    }

    /**
     * Gets destruction_date
     * @return string
     */
    public function getDestructionDate()
    {
        return $this->container['destruction_date'];
    }

    /**
     * Sets destruction_date
     * @param string $destruction_date When this security object was destroyed
     * @return $this
     */
    public function setDestructionDate($destruction_date)
    {
        $this->container['destruction_date'] = $destruction_date;

        return $this;
    }

    /**
     * Gets deletion_date
     * @return string
     */
    public function getDeletionDate()
    {
        return $this->container['deletion_date'];
    }

    /**
     * Sets deletion_date
     * @param string $deletion_date When the security object was deleted
     * @return $this
     */
    public function setDeletionDate($deletion_date)
    {
        $this->container['deletion_date'] = $deletion_date;

        return $this;
    }

    /**
     * Gets state
     * @return \SdkmsClient\Model\KeyObjectState
     */
    public function getState()
    {
        return $this->container['state'];
    }

    /**
     * Sets state
     * @param \SdkmsClient\Model\KeyObjectState $state
     * @return $this
     */
    public function setState($state)
    {
        $this->container['state'] = $state;

        return $this;
    }

    /**
     * Gets key_ops
     * @return \SdkmsClient\Model\KeyOperations[]
     */
    public function getKeyOps()
    {
        return $this->container['key_ops'];
    }

    /**
     * Sets key_ops
     * @param \SdkmsClient\Model\KeyOperations[] $key_ops Array of key operations enabled for this security object.
     * @return $this
     */
    public function setKeyOps($key_ops)
    {
        $this->container['key_ops'] = $key_ops;

        return $this;
    }

    /**
     * Gets public_only
     * @return bool
     */
    public function getPublicOnly()
    {
        return $this->container['public_only'];
    }

    /**
     * Sets public_only
     * @param bool $public_only Whether the key object contains only a public part
     * @return $this
     */
    public function setPublicOnly($public_only)
    {
        $this->container['public_only'] = $public_only;

        return $this;
    }

    /**
     * Gets rotation_policy
     * @return \SdkmsClient\Model\RotationPolicy
     */
    public function getRotationPolicy()
    {
        return $this->container['rotation_policy'];
    }

    /**
     * Sets rotation_policy
     * @param \SdkmsClient\Model\RotationPolicy $rotation_policy
     * @return $this
     */
    public function setRotationPolicy($rotation_policy)
    {
        $this->container['rotation_policy'] = $rotation_policy;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


