<?php
/**
 * ImportSobjectComponentsRequest
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * ImportSobjectComponentsRequest Class Doc Comment
 *
 * @category    Class
 * @description Request body to import security objcet components
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class ImportSobjectComponentsRequest implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'ImportSobjectComponentsRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'key' => '\SdkmsClient\Model\SobjectRequest',
        'unwrap_key_params' => '\SdkmsClient\Model\UnwrapKeyParams',
        'custodians' => '\SdkmsClient\Model\CreatorType[]',
        'components' => '\SdkmsClient\Model\SobjectComponent[]',
        'description' => 'string',
        'method' => '\SdkmsClient\Model\SplittingMethod'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'key' => null,
        'unwrap_key_params' => null,
        'custodians' => null,
        'components' => null,
        'description' => null,
        'method' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'key' => 'key',
        'unwrap_key_params' => 'unwrap_key_params',
        'custodians' => 'custodians',
        'components' => 'components',
        'description' => 'description',
        'method' => 'method'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'key' => 'setKey',
        'unwrap_key_params' => 'setUnwrapKeyParams',
        'custodians' => 'setCustodians',
        'components' => 'setComponents',
        'description' => 'setDescription',
        'method' => 'setMethod'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'key' => 'getKey',
        'unwrap_key_params' => 'getUnwrapKeyParams',
        'custodians' => 'getCustodians',
        'components' => 'getComponents',
        'description' => 'getDescription',
        'method' => 'getMethod'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['key'] = isset($data['key']) ? $data['key'] : null;
        $this->container['unwrap_key_params'] = isset($data['unwrap_key_params']) ? $data['unwrap_key_params'] : null;
        $this->container['custodians'] = isset($data['custodians']) ? $data['custodians'] : null;
        $this->container['components'] = isset($data['components']) ? $data['components'] : null;
        $this->container['description'] = isset($data['description']) ? $data['description'] : null;
        $this->container['method'] = isset($data['method']) ? $data['method'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['key'] === null) {
            $invalid_properties[] = "'key' can't be null";
        }
        if ($this->container['unwrap_key_params'] === null) {
            $invalid_properties[] = "'unwrap_key_params' can't be null";
        }
        if ($this->container['custodians'] === null) {
            $invalid_properties[] = "'custodians' can't be null";
        }
        if ($this->container['components'] === null) {
            $invalid_properties[] = "'components' can't be null";
        }
        if ($this->container['method'] === null) {
            $invalid_properties[] = "'method' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['key'] === null) {
            return false;
        }
        if ($this->container['unwrap_key_params'] === null) {
            return false;
        }
        if ($this->container['custodians'] === null) {
            return false;
        }
        if ($this->container['components'] === null) {
            return false;
        }
        if ($this->container['method'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets key
     * @return \SdkmsClient\Model\SobjectRequest
     */
    public function getKey()
    {
        return $this->container['key'];
    }

    /**
     * Sets key
     * @param \SdkmsClient\Model\SobjectRequest $key
     * @return $this
     */
    public function setKey($key)
    {
        $this->container['key'] = $key;

        return $this;
    }

    /**
     * Gets unwrap_key_params
     * @return \SdkmsClient\Model\UnwrapKeyParams
     */
    public function getUnwrapKeyParams()
    {
        return $this->container['unwrap_key_params'];
    }

    /**
     * Sets unwrap_key_params
     * @param \SdkmsClient\Model\UnwrapKeyParams $unwrap_key_params
     * @return $this
     */
    public function setUnwrapKeyParams($unwrap_key_params)
    {
        $this->container['unwrap_key_params'] = $unwrap_key_params;

        return $this;
    }

    /**
     * Gets custodians
     * @return \SdkmsClient\Model\CreatorType[]
     */
    public function getCustodians()
    {
        return $this->container['custodians'];
    }

    /**
     * Sets custodians
     * @param \SdkmsClient\Model\CreatorType[] $custodians Map from USER or App to its UUIDs
     * @return $this
     */
    public function setCustodians($custodians)
    {
        $this->container['custodians'] = $custodians;

        return $this;
    }

    /**
     * Gets components
     * @return \SdkmsClient\Model\SobjectComponent[]
     */
    public function getComponents()
    {
        return $this->container['components'];
    }

    /**
     * Sets components
     * @param \SdkmsClient\Model\SobjectComponent[] $components An array of Security Object components
     * @return $this
     */
    public function setComponents($components)
    {
        $this->container['components'] = $components;

        return $this;
    }

    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     * @param string $description
     * @return $this
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets method
     * @return \SdkmsClient\Model\SplittingMethod
     */
    public function getMethod()
    {
        return $this->container['method'];
    }

    /**
     * Sets method
     * @param \SdkmsClient\Model\SplittingMethod $method
     * @return $this
     */
    public function setMethod($method)
    {
        $this->container['method'] = $method;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


