<?php
/**
 * Plugin
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * Plugin Class Doc Comment
 *
 * @category    Class
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class Plugin implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'Plugin';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'name' => 'string',
        'plugin_id' => 'string',
        'description' => 'string',
        'acct_id' => 'string',
        'groups' => 'string[]',
        'default_group' => 'string',
        'source' => '\SdkmsClient\Model\PluginSource',
        'enabled' => 'bool',
        'plugin_type' => '\SdkmsClient\Model\PluginType',
        'creator' => '\SdkmsClient\Model\CreatorType',
        'created_at' => 'string',
        'lastrun_at' => 'string',
        'lastupdated_at' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'name' => null,
        'plugin_id' => null,
        'description' => null,
        'acct_id' => null,
        'groups' => null,
        'default_group' => null,
        'source' => null,
        'enabled' => null,
        'plugin_type' => null,
        'creator' => null,
        'created_at' => 'dateTime',
        'lastrun_at' => 'dateTime',
        'lastupdated_at' => 'dateTime'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'name' => 'name',
        'plugin_id' => 'plugin_id',
        'description' => 'description',
        'acct_id' => 'acct_id',
        'groups' => 'groups',
        'default_group' => 'default_group',
        'source' => 'source',
        'enabled' => 'enabled',
        'plugin_type' => 'plugin_type',
        'creator' => 'creator',
        'created_at' => 'created_at',
        'lastrun_at' => 'lastrun_at',
        'lastupdated_at' => 'lastupdated_at'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'name' => 'setName',
        'plugin_id' => 'setPluginId',
        'description' => 'setDescription',
        'acct_id' => 'setAcctId',
        'groups' => 'setGroups',
        'default_group' => 'setDefaultGroup',
        'source' => 'setSource',
        'enabled' => 'setEnabled',
        'plugin_type' => 'setPluginType',
        'creator' => 'setCreator',
        'created_at' => 'setCreatedAt',
        'lastrun_at' => 'setLastrunAt',
        'lastupdated_at' => 'setLastupdatedAt'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'name' => 'getName',
        'plugin_id' => 'getPluginId',
        'description' => 'getDescription',
        'acct_id' => 'getAcctId',
        'groups' => 'getGroups',
        'default_group' => 'getDefaultGroup',
        'source' => 'getSource',
        'enabled' => 'getEnabled',
        'plugin_type' => 'getPluginType',
        'creator' => 'getCreator',
        'created_at' => 'getCreatedAt',
        'lastrun_at' => 'getLastrunAt',
        'lastupdated_at' => 'getLastupdatedAt'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['plugin_id'] = isset($data['plugin_id']) ? $data['plugin_id'] : null;
        $this->container['description'] = isset($data['description']) ? $data['description'] : null;
        $this->container['acct_id'] = isset($data['acct_id']) ? $data['acct_id'] : null;
        $this->container['groups'] = isset($data['groups']) ? $data['groups'] : null;
        $this->container['default_group'] = isset($data['default_group']) ? $data['default_group'] : null;
        $this->container['source'] = isset($data['source']) ? $data['source'] : null;
        $this->container['enabled'] = isset($data['enabled']) ? $data['enabled'] : null;
        $this->container['plugin_type'] = isset($data['plugin_type']) ? $data['plugin_type'] : null;
        $this->container['creator'] = isset($data['creator']) ? $data['creator'] : null;
        $this->container['created_at'] = isset($data['created_at']) ? $data['created_at'] : null;
        $this->container['lastrun_at'] = isset($data['lastrun_at']) ? $data['lastrun_at'] : null;
        $this->container['lastupdated_at'] = isset($data['lastupdated_at']) ? $data['lastupdated_at'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['name'] === null) {
            $invalid_properties[] = "'name' can't be null";
        }
        if ($this->container['plugin_id'] === null) {
            $invalid_properties[] = "'plugin_id' can't be null";
        }
        if ($this->container['acct_id'] === null) {
            $invalid_properties[] = "'acct_id' can't be null";
        }
        if ($this->container['groups'] === null) {
            $invalid_properties[] = "'groups' can't be null";
        }
        if ($this->container['default_group'] === null) {
            $invalid_properties[] = "'default_group' can't be null";
        }
        if ($this->container['source'] === null) {
            $invalid_properties[] = "'source' can't be null";
        }
        if ($this->container['enabled'] === null) {
            $invalid_properties[] = "'enabled' can't be null";
        }
        if ($this->container['plugin_type'] === null) {
            $invalid_properties[] = "'plugin_type' can't be null";
        }
        if ($this->container['creator'] === null) {
            $invalid_properties[] = "'creator' can't be null";
        }
        if ($this->container['created_at'] === null) {
            $invalid_properties[] = "'created_at' can't be null";
        }
        if ($this->container['lastrun_at'] === null) {
            $invalid_properties[] = "'lastrun_at' can't be null";
        }
        if ($this->container['lastupdated_at'] === null) {
            $invalid_properties[] = "'lastupdated_at' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['name'] === null) {
            return false;
        }
        if ($this->container['plugin_id'] === null) {
            return false;
        }
        if ($this->container['acct_id'] === null) {
            return false;
        }
        if ($this->container['groups'] === null) {
            return false;
        }
        if ($this->container['default_group'] === null) {
            return false;
        }
        if ($this->container['source'] === null) {
            return false;
        }
        if ($this->container['enabled'] === null) {
            return false;
        }
        if ($this->container['plugin_type'] === null) {
            return false;
        }
        if ($this->container['creator'] === null) {
            return false;
        }
        if ($this->container['created_at'] === null) {
            return false;
        }
        if ($this->container['lastrun_at'] === null) {
            return false;
        }
        if ($this->container['lastupdated_at'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     * @param string $name Name of the plugin. Plugin names must be unique within an account.
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets plugin_id
     * @return string
     */
    public function getPluginId()
    {
        return $this->container['plugin_id'];
    }

    /**
     * Sets plugin_id
     * @param string $plugin_id Plugin ID uniquely identifying this plugin.
     * @return $this
     */
    public function setPluginId($plugin_id)
    {
        $this->container['plugin_id'] = $plugin_id;

        return $this;
    }

    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     * @param string $description Description of this plugin.
     * @return $this
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets acct_id
     * @return string
     */
    public function getAcctId()
    {
        return $this->container['acct_id'];
    }

    /**
     * Sets acct_id
     * @param string $acct_id The account ID of the account that this plugin belongs to.
     * @return $this
     */
    public function setAcctId($acct_id)
    {
        $this->container['acct_id'] = $acct_id;

        return $this;
    }

    /**
     * Gets groups
     * @return string[]
     */
    public function getGroups()
    {
        return $this->container['groups'];
    }

    /**
     * Sets groups
     * @param string[] $groups An array of security group IDs. The plugin belongs to each Security Group in this array.
     * @return $this
     */
    public function setGroups($groups)
    {
        $this->container['groups'] = $groups;

        return $this;
    }

    /**
     * Gets default_group
     * @return string
     */
    public function getDefaultGroup()
    {
        return $this->container['default_group'];
    }

    /**
     * Sets default_group
     * @param string $default_group The default group of this plugin. This is the group where security objects will be created by default by this plugin.
     * @return $this
     */
    public function setDefaultGroup($default_group)
    {
        $this->container['default_group'] = $default_group;

        return $this;
    }

    /**
     * Gets source
     * @return \SdkmsClient\Model\PluginSource
     */
    public function getSource()
    {
        return $this->container['source'];
    }

    /**
     * Sets source
     * @param \SdkmsClient\Model\PluginSource $source
     * @return $this
     */
    public function setSource($source)
    {
        $this->container['source'] = $source;

        return $this;
    }

    /**
     * Gets enabled
     * @return bool
     */
    public function getEnabled()
    {
        return $this->container['enabled'];
    }

    /**
     * Sets enabled
     * @param bool $enabled Whether this plugin is enabled.
     * @return $this
     */
    public function setEnabled($enabled)
    {
        $this->container['enabled'] = $enabled;

        return $this;
    }

    /**
     * Gets plugin_type
     * @return \SdkmsClient\Model\PluginType
     */
    public function getPluginType()
    {
        return $this->container['plugin_type'];
    }

    /**
     * Sets plugin_type
     * @param \SdkmsClient\Model\PluginType $plugin_type
     * @return $this
     */
    public function setPluginType($plugin_type)
    {
        $this->container['plugin_type'] = $plugin_type;

        return $this;
    }

    /**
     * Gets creator
     * @return \SdkmsClient\Model\CreatorType
     */
    public function getCreator()
    {
        return $this->container['creator'];
    }

    /**
     * Sets creator
     * @param \SdkmsClient\Model\CreatorType $creator
     * @return $this
     */
    public function setCreator($creator)
    {
        $this->container['creator'] = $creator;

        return $this;
    }

    /**
     * Gets created_at
     * @return string
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     * @param string $created_at When this plugin was created.
     * @return $this
     */
    public function setCreatedAt($created_at)
    {
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets lastrun_at
     * @return string
     */
    public function getLastrunAt()
    {
        return $this->container['lastrun_at'];
    }

    /**
     * Sets lastrun_at
     * @param string $lastrun_at When this plugin was last run.
     * @return $this
     */
    public function setLastrunAt($lastrun_at)
    {
        $this->container['lastrun_at'] = $lastrun_at;

        return $this;
    }

    /**
     * Gets lastupdated_at
     * @return string
     */
    public function getLastupdatedAt()
    {
        return $this->container['lastupdated_at'];
    }

    /**
     * Sets lastupdated_at
     * @param string $lastupdated_at When this plugin was last updated.
     * @return $this
     */
    public function setLastupdatedAt($lastupdated_at)
    {
        $this->container['lastupdated_at'] = $lastupdated_at;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


