<?php
/**
 * RsaOptions
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * RsaOptions Class Doc Comment
 *
 * @category    Class
 * @description RSA-specific options.
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class RsaOptions implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'RsaOptions';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'key_size' => 'int',
        'public_exponent' => 'int',
        'encryption_policy' => '\SdkmsClient\Model\RsaEncryptionPolicy[]',
        'signature_policy' => '\SdkmsClient\Model\RsaSignaturePolicy[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'key_size' => 'int32',
        'public_exponent' => 'int32',
        'encryption_policy' => null,
        'signature_policy' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'key_size' => 'key_size',
        'public_exponent' => 'public_exponent',
        'encryption_policy' => 'encryption_policy',
        'signature_policy' => 'signature_policy'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'key_size' => 'setKeySize',
        'public_exponent' => 'setPublicExponent',
        'encryption_policy' => 'setEncryptionPolicy',
        'signature_policy' => 'setSignaturePolicy'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'key_size' => 'getKeySize',
        'public_exponent' => 'getPublicExponent',
        'encryption_policy' => 'getEncryptionPolicy',
        'signature_policy' => 'getSignaturePolicy'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['key_size'] = isset($data['key_size']) ? $data['key_size'] : null;
        $this->container['public_exponent'] = isset($data['public_exponent']) ? $data['public_exponent'] : null;
        $this->container['encryption_policy'] = isset($data['encryption_policy']) ? $data['encryption_policy'] : null;
        $this->container['signature_policy'] = isset($data['signature_policy']) ? $data['signature_policy'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        return true;
    }


    /**
     * Gets key_size
     * @return int
     */
    public function getKeySize()
    {
        return $this->container['key_size'];
    }

    /**
     * Sets key_size
     * @param int $key_size Specify on Create only. Returned on Get. Size in bits (not bytes) of the RSA key.
     * @return $this
     */
    public function setKeySize($key_size)
    {
        $this->container['key_size'] = $key_size;

        return $this;
    }

    /**
     * Gets public_exponent
     * @return int
     */
    public function getPublicExponent()
    {
        return $this->container['public_exponent'];
    }

    /**
     * Sets public_exponent
     * @param int $public_exponent Specify on Create only. Public exponent to use for generating the RSA key.
     * @return $this
     */
    public function setPublicExponent($public_exponent)
    {
        $this->container['public_exponent'] = $public_exponent;

        return $this;
    }

    /**
     * Gets encryption_policy
     * @return \SdkmsClient\Model\RsaEncryptionPolicy[]
     */
    public function getEncryptionPolicy()
    {
        return $this->container['encryption_policy'];
    }

    /**
     * Sets encryption_policy
     * @param \SdkmsClient\Model\RsaEncryptionPolicy[] $encryption_policy Encryption policy for this RSA key. When doing an encryption or key wrapping operation, the policies are evaluated against the specified parameters one by one. If one matches, the operation is allowed. If none match, including if the policy list is empty, the operation is disallowed. Missing optional parameters will have their defaults specified according to the matched policy. The default for new keys is `[{\"padding\":{\"OAEP\":{}}]`. If (part of) a constraint is not specified, anything is allowed for that constraint. To impose no constraints, specify `[{}]`.
     * @return $this
     */
    public function setEncryptionPolicy($encryption_policy)
    {
        $this->container['encryption_policy'] = $encryption_policy;

        return $this;
    }

    /**
     * Gets signature_policy
     * @return \SdkmsClient\Model\RsaSignaturePolicy[]
     */
    public function getSignaturePolicy()
    {
        return $this->container['signature_policy'];
    }

    /**
     * Sets signature_policy
     * @param \SdkmsClient\Model\RsaSignaturePolicy[] $signature_policy Signature policy for this RSA key. When doing a signature operation, the policies are evaluated against the specified parameters one by one. If one matches, the operation is allowed. If none match, including if the policy list is empty, the operation is disallowed. Missing optional parameters will have their defaults specified according to the matched policy. The default for new keys is `[{}]` (no constraints). If (part of) a constraint is not specified, anything is allowed for that constraint.
     * @return $this
     */
    public function setSignaturePolicy($signature_policy)
    {
        $this->container['signature_policy'] = $signature_policy;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


