<?php
/**
 * SobjectRequest
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * SobjectRequest Class Doc Comment
 *
 * @category    Class
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class SobjectRequest implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'SobjectRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'name' => 'string',
        'description' => 'string',
        'key_size' => 'int',
        'pub_exponent' => 'int',
        'elliptic_curve' => '\SdkmsClient\Model\EllipticCurve',
        'rsa' => '\SdkmsClient\Model\RsaOptions',
        'dsa' => '\SdkmsClient\Model\DsaOptions',
        'fpe' => '\SdkmsClient\Model\FpeOptions',
        'group_id' => 'string',
        'rotation_policy' => '\SdkmsClient\Model\RotationPolicy',
        'obj_type' => '\SdkmsClient\Model\ObjectType',
        'key_ops' => '\SdkmsClient\Model\KeyOperations[]',
        'custom_metadata' => 'map[string,string]',
        'value' => 'string',
        'enabled' => 'bool',
        'transient' => 'bool',
        'deterministic_signatures' => 'bool',
        'state' => '\SdkmsClient\Model\KeyObjectState',
        'deactivation_date' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'name' => null,
        'description' => null,
        'key_size' => 'int32',
        'pub_exponent' => 'int32',
        'elliptic_curve' => null,
        'rsa' => null,
        'dsa' => null,
        'fpe' => null,
        'group_id' => null,
        'rotation_policy' => null,
        'obj_type' => null,
        'key_ops' => null,
        'custom_metadata' => null,
        'value' => 'byte',
        'enabled' => null,
        'transient' => null,
        'deterministic_signatures' => null,
        'state' => null,
        'deactivation_date' => 'dateTime'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'name' => 'name',
        'description' => 'description',
        'key_size' => 'key_size',
        'pub_exponent' => 'pub_exponent',
        'elliptic_curve' => 'elliptic_curve',
        'rsa' => 'rsa',
        'dsa' => 'dsa',
        'fpe' => 'fpe',
        'group_id' => 'group_id',
        'rotation_policy' => 'rotation_policy',
        'obj_type' => 'obj_type',
        'key_ops' => 'key_ops',
        'custom_metadata' => 'custom_metadata',
        'value' => 'value',
        'enabled' => 'enabled',
        'transient' => 'transient',
        'deterministic_signatures' => 'deterministic_signatures',
        'state' => 'state',
        'deactivation_date' => 'deactivation_date'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'name' => 'setName',
        'description' => 'setDescription',
        'key_size' => 'setKeySize',
        'pub_exponent' => 'setPubExponent',
        'elliptic_curve' => 'setEllipticCurve',
        'rsa' => 'setRsa',
        'dsa' => 'setDsa',
        'fpe' => 'setFpe',
        'group_id' => 'setGroupId',
        'rotation_policy' => 'setRotationPolicy',
        'obj_type' => 'setObjType',
        'key_ops' => 'setKeyOps',
        'custom_metadata' => 'setCustomMetadata',
        'value' => 'setValue',
        'enabled' => 'setEnabled',
        'transient' => 'setTransient',
        'deterministic_signatures' => 'setDeterministicSignatures',
        'state' => 'setState',
        'deactivation_date' => 'setDeactivationDate'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'name' => 'getName',
        'description' => 'getDescription',
        'key_size' => 'getKeySize',
        'pub_exponent' => 'getPubExponent',
        'elliptic_curve' => 'getEllipticCurve',
        'rsa' => 'getRsa',
        'dsa' => 'getDsa',
        'fpe' => 'getFpe',
        'group_id' => 'getGroupId',
        'rotation_policy' => 'getRotationPolicy',
        'obj_type' => 'getObjType',
        'key_ops' => 'getKeyOps',
        'custom_metadata' => 'getCustomMetadata',
        'value' => 'getValue',
        'enabled' => 'getEnabled',
        'transient' => 'getTransient',
        'deterministic_signatures' => 'getDeterministicSignatures',
        'state' => 'getState',
        'deactivation_date' => 'getDeactivationDate'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['description'] = isset($data['description']) ? $data['description'] : null;
        $this->container['key_size'] = isset($data['key_size']) ? $data['key_size'] : null;
        $this->container['pub_exponent'] = isset($data['pub_exponent']) ? $data['pub_exponent'] : null;
        $this->container['elliptic_curve'] = isset($data['elliptic_curve']) ? $data['elliptic_curve'] : null;
        $this->container['rsa'] = isset($data['rsa']) ? $data['rsa'] : null;
        $this->container['dsa'] = isset($data['dsa']) ? $data['dsa'] : null;
        $this->container['fpe'] = isset($data['fpe']) ? $data['fpe'] : null;
        $this->container['group_id'] = isset($data['group_id']) ? $data['group_id'] : null;
        $this->container['rotation_policy'] = isset($data['rotation_policy']) ? $data['rotation_policy'] : null;
        $this->container['obj_type'] = isset($data['obj_type']) ? $data['obj_type'] : null;
        $this->container['key_ops'] = isset($data['key_ops']) ? $data['key_ops'] : null;
        $this->container['custom_metadata'] = isset($data['custom_metadata']) ? $data['custom_metadata'] : null;
        $this->container['value'] = isset($data['value']) ? $data['value'] : null;
        $this->container['enabled'] = isset($data['enabled']) ? $data['enabled'] : null;
        $this->container['transient'] = isset($data['transient']) ? $data['transient'] : null;
        $this->container['deterministic_signatures'] = isset($data['deterministic_signatures']) ? $data['deterministic_signatures'] : null;
        $this->container['state'] = isset($data['state']) ? $data['state'] : null;
        $this->container['deactivation_date'] = isset($data['deactivation_date']) ? $data['deactivation_date'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['name'] === null) {
            $invalid_properties[] = "'name' can't be null";
        }
        if ($this->container['obj_type'] === null) {
            $invalid_properties[] = "'obj_type' can't be null";
        }
        if (!is_null($this->container['value']) && !preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $this->container['value'])) {
            $invalid_properties[] = "invalid value for 'value', must be conform to the pattern /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.";
        }

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['name'] === null) {
            return false;
        }
        if ($this->container['obj_type'] === null) {
            return false;
        }
        if (!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $this->container['value'])) {
            return false;
        }
        return true;
    }


    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     * @param string $name Name of the security object to create or import. Security object names must be unique within an account.
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     * @param string $description Description of the security object to create or import.
     * @return $this
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets key_size
     * @return int
     */
    public function getKeySize()
    {
        return $this->container['key_size'];
    }

    /**
     * Sets key_size
     * @param int $key_size Size in bits (not bytes) of the security object to create or import. Required for symmetric keys. For DSA keys, it represents the size of `p`; allowed values are 2048 or 3072. Deprecated for RSA keys, specify it in `RsaOptions` instead.
     * @return $this
     */
    public function setKeySize($key_size)
    {
        $this->container['key_size'] = $key_size;

        return $this;
    }

    /**
     * Gets pub_exponent
     * @return int
     */
    public function getPubExponent()
    {
        return $this->container['pub_exponent'];
    }

    /**
     * Sets pub_exponent
     * @param int $pub_exponent For RSA keys only. Deprecated. Specify in `RsaOptions` instead. Public exponent to use when generating an RSA key.
     * @return $this
     */
    public function setPubExponent($pub_exponent)
    {
        $this->container['pub_exponent'] = $pub_exponent;

        return $this;
    }

    /**
     * Gets elliptic_curve
     * @return \SdkmsClient\Model\EllipticCurve
     */
    public function getEllipticCurve()
    {
        return $this->container['elliptic_curve'];
    }

    /**
     * Sets elliptic_curve
     * @param \SdkmsClient\Model\EllipticCurve $elliptic_curve
     * @return $this
     */
    public function setEllipticCurve($elliptic_curve)
    {
        $this->container['elliptic_curve'] = $elliptic_curve;

        return $this;
    }

    /**
     * Gets rsa
     * @return \SdkmsClient\Model\RsaOptions
     */
    public function getRsa()
    {
        return $this->container['rsa'];
    }

    /**
     * Sets rsa
     * @param \SdkmsClient\Model\RsaOptions $rsa
     * @return $this
     */
    public function setRsa($rsa)
    {
        $this->container['rsa'] = $rsa;

        return $this;
    }

    /**
     * Gets dsa
     * @return \SdkmsClient\Model\DsaOptions
     */
    public function getDsa()
    {
        return $this->container['dsa'];
    }

    /**
     * Sets dsa
     * @param \SdkmsClient\Model\DsaOptions $dsa
     * @return $this
     */
    public function setDsa($dsa)
    {
        $this->container['dsa'] = $dsa;

        return $this;
    }

    /**
     * Gets fpe
     * @return \SdkmsClient\Model\FpeOptions
     */
    public function getFpe()
    {
        return $this->container['fpe'];
    }

    /**
     * Sets fpe
     * @param \SdkmsClient\Model\FpeOptions $fpe
     * @return $this
     */
    public function setFpe($fpe)
    {
        $this->container['fpe'] = $fpe;

        return $this;
    }

    /**
     * Gets group_id
     * @return string
     */
    public function getGroupId()
    {
        return $this->container['group_id'];
    }

    /**
     * Sets group_id
     * @param string $group_id Group ID (not name) of the security group that this security object should belong to. The user or application creating this security object must be a member of this group. If no group is specified, the default group for the user or application will be used.
     * @return $this
     */
    public function setGroupId($group_id)
    {
        $this->container['group_id'] = $group_id;

        return $this;
    }

    /**
     * Gets rotation_policy
     * @return \SdkmsClient\Model\RotationPolicy
     */
    public function getRotationPolicy()
    {
        return $this->container['rotation_policy'];
    }

    /**
     * Sets rotation_policy
     * @param \SdkmsClient\Model\RotationPolicy $rotation_policy
     * @return $this
     */
    public function setRotationPolicy($rotation_policy)
    {
        $this->container['rotation_policy'] = $rotation_policy;

        return $this;
    }

    /**
     * Gets obj_type
     * @return \SdkmsClient\Model\ObjectType
     */
    public function getObjType()
    {
        return $this->container['obj_type'];
    }

    /**
     * Sets obj_type
     * @param \SdkmsClient\Model\ObjectType $obj_type
     * @return $this
     */
    public function setObjType($obj_type)
    {
        $this->container['obj_type'] = $obj_type;

        return $this;
    }

    /**
     * Gets key_ops
     * @return \SdkmsClient\Model\KeyOperations[]
     */
    public function getKeyOps()
    {
        return $this->container['key_ops'];
    }

    /**
     * Sets key_ops
     * @param \SdkmsClient\Model\KeyOperations[] $key_ops Optional array of key operations to be enabled for this security object. If this property is not provided, the SDKMS server will provide a default set of key operations. Note that if you provide an empty array, all key operations will be disabled.
     * @return $this
     */
    public function setKeyOps($key_ops)
    {
        $this->container['key_ops'] = $key_ops;

        return $this;
    }

    /**
     * Gets custom_metadata
     * @return map[string,string]
     */
    public function getCustomMetadata()
    {
        return $this->container['custom_metadata'];
    }

    /**
     * Sets custom_metadata
     * @param map[string,string] $custom_metadata User-defined metadata for this key. Stored as key-value pairs.
     * @return $this
     */
    public function setCustomMetadata($custom_metadata)
    {
        $this->container['custom_metadata'] = $custom_metadata;

        return $this;
    }

    /**
     * Gets value
     * @return string
     */
    public function getValue()
    {
        return $this->container['value'];
    }

    /**
     * Sets value
     * @param string $value When importing a security object, this field contains the binary contents to import. When creating a security object, this field is unused. The value of an OPAQUE or CERTIFICATE object is always returned. For other objects, the value is returned only with `/crypto/v1/keys/export` API (if the object is exportable).
     * @return $this
     */
    public function setValue($value)
    {

        if (!is_null($value) && (!preg_match("/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/", $value))) {
            throw new \InvalidArgumentException("invalid value for $value when calling SobjectRequest., must conform to the pattern /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.");
        }

        $this->container['value'] = $value;

        return $this;
    }

    /**
     * Gets enabled
     * @return bool
     */
    public function getEnabled()
    {
        return $this->container['enabled'];
    }

    /**
     * Sets enabled
     * @param bool $enabled Whether the new security object should be enabled. Disabled security objects may not perform cryptographic operations.
     * @return $this
     */
    public function setEnabled($enabled)
    {
        $this->container['enabled'] = $enabled;

        return $this;
    }

    /**
     * Gets transient
     * @return bool
     */
    public function getTransient()
    {
        return $this->container['transient'];
    }

    /**
     * Sets transient
     * @param bool $transient If this is true, SDKMS will create a transient key.
     * @return $this
     */
    public function setTransient($transient)
    {
        $this->container['transient'] = $transient;

        return $this;
    }

    /**
     * Gets deterministic_signatures
     * @return bool
     */
    public function getDeterministicSignatures()
    {
        return $this->container['deterministic_signatures'];
    }

    /**
     * Sets deterministic_signatures
     * @param bool $deterministic_signatures
     * @return $this
     */
    public function setDeterministicSignatures($deterministic_signatures)
    {
        $this->container['deterministic_signatures'] = $deterministic_signatures;

        return $this;
    }

    /**
     * Gets state
     * @return \SdkmsClient\Model\KeyObjectState
     */
    public function getState()
    {
        return $this->container['state'];
    }

    /**
     * Sets state
     * @param \SdkmsClient\Model\KeyObjectState $state
     * @return $this
     */
    public function setState($state)
    {
        $this->container['state'] = $state;

        return $this;
    }

    /**
     * Gets deactivation_date
     * @return string
     */
    public function getDeactivationDate()
    {
        return $this->container['deactivation_date'];
    }

    /**
     * Sets deactivation_date
     * @param string $deactivation_date When this object will be deactivated.
     * @return $this
     */
    public function setDeactivationDate($deactivation_date)
    {
        $this->container['deactivation_date'] = $deactivation_date;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


