<?php
/**
 * User
 *
 * PHP version 5
 *
 * @category Class
 * @package  SdkmsClient
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations.
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace SdkmsClient\Model;

use \ArrayAccess;

/**
 * User Class Doc Comment
 *
 * @category    Class
 * @package     SdkmsClient
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class User implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'User';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'user_id' => 'string',
        'user_email' => 'string',
        'state' => '\SdkmsClient\Model\UserState',
        'account_role' => '\SdkmsClient\Model\UserAccountFlags[]',
        'groups' => '\SdkmsClient\Model\UserGroupMap',
        'enabled' => 'bool',
        'email_verified' => 'bool',
        'created_at' => 'string',
        'last_logged_in_at' => 'string',
        'u2f_devices' => '\SdkmsClient\Model\U2fDevice[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerFormats = [
        'user_id' => null,
        'user_email' => null,
        'state' => null,
        'account_role' => null,
        'groups' => null,
        'enabled' => null,
        'email_verified' => null,
        'created_at' => 'dateTime',
        'last_logged_in_at' => 'dateTime',
        'u2f_devices' => null
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'user_id' => 'user_id',
        'user_email' => 'user_email',
        'state' => 'state',
        'account_role' => 'account_role',
        'groups' => 'groups',
        'enabled' => 'enabled',
        'email_verified' => 'email_verified',
        'created_at' => 'created_at',
        'last_logged_in_at' => 'last_logged_in_at',
        'u2f_devices' => 'u2f_devices'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'user_id' => 'setUserId',
        'user_email' => 'setUserEmail',
        'state' => 'setState',
        'account_role' => 'setAccountRole',
        'groups' => 'setGroups',
        'enabled' => 'setEnabled',
        'email_verified' => 'setEmailVerified',
        'created_at' => 'setCreatedAt',
        'last_logged_in_at' => 'setLastLoggedInAt',
        'u2f_devices' => 'setU2fDevices'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'user_id' => 'getUserId',
        'user_email' => 'getUserEmail',
        'state' => 'getState',
        'account_role' => 'getAccountRole',
        'groups' => 'getGroups',
        'enabled' => 'getEnabled',
        'email_verified' => 'getEmailVerified',
        'created_at' => 'getCreatedAt',
        'last_logged_in_at' => 'getLastLoggedInAt',
        'u2f_devices' => 'getU2fDevices'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['user_id'] = isset($data['user_id']) ? $data['user_id'] : null;
        $this->container['user_email'] = isset($data['user_email']) ? $data['user_email'] : null;
        $this->container['state'] = isset($data['state']) ? $data['state'] : null;
        $this->container['account_role'] = isset($data['account_role']) ? $data['account_role'] : null;
        $this->container['groups'] = isset($data['groups']) ? $data['groups'] : null;
        $this->container['enabled'] = isset($data['enabled']) ? $data['enabled'] : null;
        $this->container['email_verified'] = isset($data['email_verified']) ? $data['email_verified'] : null;
        $this->container['created_at'] = isset($data['created_at']) ? $data['created_at'] : null;
        $this->container['last_logged_in_at'] = isset($data['last_logged_in_at']) ? $data['last_logged_in_at'] : null;
        $this->container['u2f_devices'] = isset($data['u2f_devices']) ? $data['u2f_devices'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['user_id'] === null) {
            $invalid_properties[] = "'user_id' can't be null";
        }
        if ($this->container['user_email'] === null) {
            $invalid_properties[] = "'user_email' can't be null";
        }
        if ($this->container['state'] === null) {
            $invalid_properties[] = "'state' can't be null";
        }
        if ($this->container['groups'] === null) {
            $invalid_properties[] = "'groups' can't be null";
        }
        if ($this->container['enabled'] === null) {
            $invalid_properties[] = "'enabled' can't be null";
        }
        if ($this->container['email_verified'] === null) {
            $invalid_properties[] = "'email_verified' can't be null";
        }
        if ($this->container['created_at'] === null) {
            $invalid_properties[] = "'created_at' can't be null";
        }
        if ($this->container['u2f_devices'] === null) {
            $invalid_properties[] = "'u2f_devices' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['user_id'] === null) {
            return false;
        }
        if ($this->container['user_email'] === null) {
            return false;
        }
        if ($this->container['state'] === null) {
            return false;
        }
        if ($this->container['groups'] === null) {
            return false;
        }
        if ($this->container['enabled'] === null) {
            return false;
        }
        if ($this->container['email_verified'] === null) {
            return false;
        }
        if ($this->container['created_at'] === null) {
            return false;
        }
        if ($this->container['u2f_devices'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets user_id
     * @return string
     */
    public function getUserId()
    {
        return $this->container['user_id'];
    }

    /**
     * Sets user_id
     * @param string $user_id User ID uniquely identifying this user.
     * @return $this
     */
    public function setUserId($user_id)
    {
        $this->container['user_id'] = $user_id;

        return $this;
    }

    /**
     * Gets user_email
     * @return string
     */
    public function getUserEmail()
    {
        return $this->container['user_email'];
    }

    /**
     * Sets user_email
     * @param string $user_email The User's email address.
     * @return $this
     */
    public function setUserEmail($user_email)
    {
        $this->container['user_email'] = $user_email;

        return $this;
    }

    /**
     * Gets state
     * @return \SdkmsClient\Model\UserState
     */
    public function getState()
    {
        return $this->container['state'];
    }

    /**
     * Sets state
     * @param \SdkmsClient\Model\UserState $state
     * @return $this
     */
    public function setState($state)
    {
        $this->container['state'] = $state;

        return $this;
    }

    /**
     * Gets account_role
     * @return \SdkmsClient\Model\UserAccountFlags[]
     */
    public function getAccountRole()
    {
        return $this->container['account_role'];
    }

    /**
     * Sets account_role
     * @param \SdkmsClient\Model\UserAccountFlags[] $account_role
     * @return $this
     */
    public function setAccountRole($account_role)
    {
        $this->container['account_role'] = $account_role;

        return $this;
    }

    /**
     * Gets groups
     * @return \SdkmsClient\Model\UserGroupMap
     */
    public function getGroups()
    {
        return $this->container['groups'];
    }

    /**
     * Sets groups
     * @param \SdkmsClient\Model\UserGroupMap $groups
     * @return $this
     */
    public function setGroups($groups)
    {
        $this->container['groups'] = $groups;

        return $this;
    }

    /**
     * Gets enabled
     * @return bool
     */
    public function getEnabled()
    {
        return $this->container['enabled'];
    }

    /**
     * Sets enabled
     * @param bool $enabled Whether this user's account is enabled.
     * @return $this
     */
    public function setEnabled($enabled)
    {
        $this->container['enabled'] = $enabled;

        return $this;
    }

    /**
     * Gets email_verified
     * @return bool
     */
    public function getEmailVerified()
    {
        return $this->container['email_verified'];
    }

    /**
     * Sets email_verified
     * @param bool $email_verified Whether this user's email has been verified.
     * @return $this
     */
    public function setEmailVerified($email_verified)
    {
        $this->container['email_verified'] = $email_verified;

        return $this;
    }

    /**
     * Gets created_at
     * @return string
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     * @param string $created_at When this user was added to SDKMS.
     * @return $this
     */
    public function setCreatedAt($created_at)
    {
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets last_logged_in_at
     * @return string
     */
    public function getLastLoggedInAt()
    {
        return $this->container['last_logged_in_at'];
    }

    /**
     * Sets last_logged_in_at
     * @param string $last_logged_in_at When this user last logged in.
     * @return $this
     */
    public function setLastLoggedInAt($last_logged_in_at)
    {
        $this->container['last_logged_in_at'] = $last_logged_in_at;

        return $this;
    }

    /**
     * Gets u2f_devices
     * @return \SdkmsClient\Model\U2fDevice[]
     */
    public function getU2fDevices()
    {
        return $this->container['u2f_devices'];
    }

    /**
     * Sets u2f_devices
     * @param \SdkmsClient\Model\U2fDevice[] $u2f_devices
     * @return $this
     */
    public function setU2fDevices($u2f_devices)
    {
        $this->container['u2f_devices'] = $u2f_devices;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\SdkmsClient\ObjectSerializer::sanitizeForSerialization($this));
    }
}


